2011-12-13  Marek Safar  <marek.safar@gmail.com>

	Fixes NRE when checking most specific type of default parameters.
	Fixes #2465

2011-05-17  Marek Habersack  <grendel@twistedcode.net>

	Support colors on 256-color terminals

2011-08-17  Miguel de Icaza  <miguel@gnome.org>

	updated copyrights

2011-07-20  Martinho Fernandes  <martinho.fernandes@gmail.com>

	[Fix] Command-line option -checked now works (bug #706877)

	The -checked option was not being considered in the
	BuilderContext. Now it is set on construction of BuilderContext to
	the value from RootContext.

2011-04-21  Marek Safar  <marek.safar@gmail.com>

	[688891] Keep same TypeParameter ctor syntax

2011-04-21  Marek Safar  <marek.safar@gmail.com>

	[688891] Copy type parameters for base proxy method

2011-04-19  Marek Safar  <marek.safar@gmail.com>

	[687282] Fixes cross references of nested anonymous methods which
	don't start at parameters level block

2011-03-09  Marek Safar  <marek.safar@gmail.com>

	[677550] Fixes fixed buffer regressions

2011-03-08  Miguel de Icaza  <miguel@gnome.org>

	Make print take an object

2011-03-01  Marek Safar  <marek.safar@gmail.com>

	[675777] Remove invalid zero based optimization

2011-02-23  Marek Safar  <marek.safar@gmail.com>

	[674224] Type parameter constraint can resolve to nested type
	before it has been imported

2011-02-14  Marek Safar  <marek.safar@gmail.com>

	[671552] Use correct emit method for stobj type

2011-02-08  Marek Safar  <marek.safar@gmail.com>

	[657099] Fix cloning of remapped blocks

2011-02-08  Marek Safar  <marek.safar@gmail.com>

	Fix remapping of cloned block parent when already in cloned
	context

2011-02-03  Marek Safar  <marek.safar@gmail.com>

	Fix importing of private types under dynamic context

2011-02-03  Marek Safar  <marek.safar@gmail.com>

	Allow any expression to be used in where clause. Some custom linq
	implementations use non-predicate version of where

2011-02-02  Miguel de Icaza  <miguel@gnome.org>

	[csharp] Change the signature for print

2011-02-02  Marek Safar  <marek.safar@gmail.com>

	Implement support for implicit user conversion for
	DefaultParameterValue (very odd)

2011-02-01  Marek Safar  <marek.safar@gmail.com>

	Fix empty cast conversion from dynamic type object type argument

2011-01-30  Miguel de Icaza  <miguel@gnome.org>

	[repl] Fix running specified scripts from command line, allow #!
	syntax, add print command

	We were calling the Reset () method after we had initialized the
	driver with the new command line arguments, clearing the list of
	files to execute before we executed them.

	Added support for #! in the csharp repl, and added the print()
	command to the InteractiveBase

	Add a better way of dealing with -e, without adding hacks to the
	core that wont work in the future

2011-01-30  Miguel de Icaza  <miguel@gnome.org>

	[repl] Add support for -e EXPRESSION to the csharp command

2011-01-30  Miguel de Icaza  <miguel@gnome.org>

	[repl] Fix running specified scripts from command line, allow #!
	syntax, add print command

	We were calling the Reset () method after we had initialized the
	driver with the new command line arguments, clearing the list of
	files to execute before we executed them.

	Added support for #! in the csharp repl, and added the print()
	command to the InteractiveBase

2011-01-27  Marek Safar  <marek.safar@gmail.com>

	[667261] Fixes overload resolution of an optional parameter
	followed by a params parameter of the same type

2011-01-26  Marek Safar  <marek.safar@gmail.com>

	Optimized constructor readonly access has to be inside same
	declarting type

2011-01-25  Marek Safar  <marek.safar@gmail.com>

	Degrade wrong override member to virtual instead of non-virtual

2011-01-24  Tomasz Kubacki  <tomasz.kubacki@gmail.com>

	[Mono.CSharp] Improve error reporting

2011-01-24  Marek Safar  <marek.safar@gmail.com>

	[666476] Use correct parameter count when checking ambiguous
	params methods

2011-01-21  Marek Safar  <marek.safar@gmail.com>

	Use byte array as underlying storage for AttributeEncoder

2011-01-21  Miguel de Icaza  <miguel@gnome.org>

	[Mono.CSharp] Fix bug where overwriting variables cleared the
	wrong value

	This fixes #641910

2011-01-21  Miguel de Icaza  <miguel@gnome.org>

	[csharp] repl using statement fix + support for --fatal

	Fixes #638585 which kept reporting the same error on the using
	statements over and over Added support for the --fatal flag to the
	REPL

2011-01-19  Marek Safar  <marek.safar@gmail.com>

	[665333] Encode Length of Public Key correctly

2011-01-18  Marek Safar  <marek.safar@gmail.com>

	Checking skd path for is not enough, add check for mscorlib as
	well

2011-01-17  Marek Safar  <marek.safar@gmail.com>

	Fallback to corlib location when sdk path cannot be found

2011-01-18  Marek Safar  <marek.safar@gmail.com>

	Remove devirtualization for Type members

2011-01-17  Marek Safar  <marek.safar@gmail.com>

	Add new mcs -sdk option

2011-01-17  Marek Safar  <marek.safar@gmail.com>

	Update to the latest mcs version

2011-01-11  Marek Safar  <marek.safar@gmail.com>

	Update copyright years

2011-01-11  Marek Safar  <marek.safar@gmail.com>

	Use base type parameters to extract params modifier of virtual
	method

2011-01-11  Marek Safar  <marek.safar@gmail.com>

	Install new ikvm based C# compiler as mcs

2011-01-11  Marek Safar  <marek.safar@gmail.com>

	[662222] Import dynamic attribute using attribute type reader

2011-01-10  Marek Safar  <marek.safar@gmail.com>

	Report correct base modifier for inaccessible protected internal
	members

2011-01-10  Marek Habersack  <grendel@twistedcode.net>

	[asp.net,mcs] Fixed 'protected internal' build errors and removed
	System.Web-specific hack from mcs

2011-01-08  Marek Safar  <marek.safar@gmail.com>

	[663059] Add check for protected modifier in InternalsVisibleTo
	assembly

2011-01-08  Marek Safar  <marek.safar@gmail.com>

	Allow trailing comma for resource argument

2011-01-07  Marek Safar  <marek.safar@gmail.com>

	Better anonymous methods require same parameter types

2011-01-06  Marek Safar  <marek.safar@gmail.com>

	More global state hacking

2011-01-05  Marek Safar  <marek.safar@gmail.com>

	[662440] Don't expand nested type builders of non-generic types

2011-01-05  Marek Safar  <marek.safar@gmail.com>

	Add mcs solution file

2011-01-04  Marek Safar  <marek.safar@gmail.com>

	Set build-in types modifiers

2011-01-04  Marek Safar  <marek.safar@gmail.com>

	Type correctly implicit as expression

2011-01-04  Marek Safar  <marek.safar@gmail.com>

	Cleanup isinst expression resolver

2011-01-04  Marek Safar  <marek.safar@gmail.com>

	Use reduced expression for transparent is check

2011-01-04  Marek Safar  <marek.safar@gmail.com>

	Use one routine for type argument scan for type parameter

2010-12-29  Marek Safar  <marek.safar@gmail.com>

	Implements checking of referenced members with missing references

2010-12-22  Marek Safar  <marek.safar@gmail.com>

	Report obsolete warning for generic methods which base
	implementation constraints are obsolete

2010-12-22  Marek Safar  <marek.safar@gmail.com>

	[660553] Fixed delegate name hiding.

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Enable fixed ikvm exception mode

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Emit constant data type using compiler type containers

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Add a workaround for ikvm unfixed baked method tokens

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Disable ikvm exception optimization until it's fixed

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Keep looking for references assembly after first lib path fails

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	Replace initial eval Reset with PartialReset

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	[660260] A static method is inaccessible from a nested type with
	explicit generic args

2010-12-20  Marek Safar  <marek.safar@gmail.com>

	[660255] Keep inflated non-inflated method info independently

2010-12-17  Marek Safar  <marek.safar@gmail.com>

	Add more files to mcs dist

2010-12-17  Marek Safar  <marek.safar@gmail.com>

	[660077] Setup class interfaces for defined types in same way as
	for imported types

2010-12-17  Marek Safar  <marek.safar@gmail.com>

	Made SecurityAction predefined type

2010-12-17  Marek Safar  <marek.safar@gmail.com>

	[657601] Fixes parsing pragma warning when encounter eof

2010-12-16  Marek Safar  <marek.safar@gmail.com>

	Set ImageRuntimeVersion based on mscorlib version when available

2010-12-16  Marek Safar  <marek.safar@gmail.com>

	[659970] Close anonymous method scope also for top-level blocks

2010-12-16  Marek Safar  <marek.safar@gmail.com>

	Switch to single mcs compiler for all managed code build

2010-12-16  Marek Safar  <marek.safar@gmail.com>

	Cleanup references in static mode

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Add more attribute arguments checks

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Fixed cloning of default switch case

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	[659536] Don't re-create array expressions when infering implicit
	array type

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	[659528] Fixed cloning of switch sections

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	[656150] Fix repl recovery after invalid expression.

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Fix comment typo

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Workaround problem when compiling many resource files references

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Switch to resizeable array when adding second item to base member
	cache

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Emit delegate constructor parameter names

2010-12-15  Marek Safar  <marek.safar@gmail.com>

	Recover from invalid linq block syntax

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[653710] Check type parameter reference type constraint
	recursively

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[656918] Implement expression tree access to hoisted variable
	reference

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[656918] Emit instance expression for ET delegate creation

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	Reject automatic version number at major and minor positions

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[655284] Implemented automatic assembly version numbers

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[655770] Emit unused members warning for nested types as well

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[657623] Fix incorrect logic in value type parameter `is' check

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	Add more restrictions to custom attribute encoding

2010-12-14  Marek Safar  <marek.safar@gmail.com>

	[657797] Expand type member cache using secondary constraints as
	well.

2010-12-13  Marek Safar  <marek.safar@gmail.com>

	Remove duplicate checks

2010-12-13  Marek Safar  <marek.safar@gmail.com>

	[659038] Check interface hierarchy before reporting ambiguous
	errors

2010-12-13  Marek Safar  <marek.safar@gmail.com>

	[657862] Correctly scan for parent of base method override

2010-12-13  Marek Safar  <marek.safar@gmail.com>

	[658722] Don't require arity symbol to be part of the typename

2010-12-13  Marek Safar  <marek.safar@gmail.com>

	[659022] Resolve reduced expressions

2010-12-10  Marek Safar  <marek.safar@gmail.com>

	Revert unwanted makefile change

2010-12-10  Marek Safar  <marek.safar@gmail.com>

	Add v1 runtime target (broken by design)

2010-12-10  Marek Safar  <marek.safar@gmail.com>

	Resolve entire base initializer block in correct context

2010-12-10  Marek Safar  <marek.safar@gmail.com>

	Report missing types (some of them for now)

2010-12-09  Marek Safar  <marek.safar@gmail.com>

	Try to handle missing generic type definition

2010-12-09  Marek Safar  <marek.safar@gmail.com>

	Read custom attribute name without resolving attribute type if
	possible

2010-12-09  Marek Safar  <marek.safar@gmail.com>

	Redirect all mscorlib loads into assembly builder when compiling
	corlib

2010-12-08  Marek Safar  <marek.safar@gmail.com>

	Add initial handling of missing assemblies

2010-12-08  Marek Safar  <marek.safar@gmail.com>

	Add internal --runtime option

2010-12-08  Marek Safar  <marek.safar@gmail.com>

	Add references loading trace

2010-12-08  Marek Safar  <marek.safar@gmail.com>

	Removed check for generics on 1.1 runtime

2010-12-07  Marek Safar  <marek.safar@gmail.com>

	Put back actual save of module target

2010-12-07  Marek Safar  <marek.safar@gmail.com>

	Check file extension manually

2010-12-07  Marek Safar  <marek.safar@gmail.com>

	Symbol writer has to use 4.0 methods in static mode

2010-12-07  Marek Safar  <marek.safar@gmail.com>

	Add IKVM.Reflection support

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Extract reflection specific assembly builder

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Re-use existing code path

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Refactor assemblies loading into a base class

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Move more fields to RootContext

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Removed obsolete files

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Use type definition for generic type forwarders

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Don't close same type twice when base call closes this declaration

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Use Version type instead of string value

2010-12-06  Marek Safar  <marek.safar@gmail.com>

	Use decimal optional parameter value decoded by System.Reflection

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	Extract reflection specific code from extended builder

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	Move assembly security declaration to extened builder

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	Don't call module symbol writer methods when we are not using it

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	Delay initialization of missing methods needed by symbol writer

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	Apply implicit parameter attributes using standard path to avoid
	any duplicates

2010-12-03  Marek Safar  <marek.safar@gmail.com>

	More symbol writer clean-up

2010-12-02  Marek Safar  <marek.safar@gmail.com>

	Don't try to parse invalid namespace declarations, it does more
	harm than good

2010-12-02  Marek Safar  <marek.safar@gmail.com>

	Update setting of buildin internal types

2010-12-02  Marek Safar  <marek.safar@gmail.com>

	Removed InitOptionalCoreTypes

2010-12-02  Marek Safar  <marek.safar@gmail.com>

	Clean-up module indirections

2010-12-02  Marek Safar  <marek.safar@gmail.com>

	Move all predefined types to module to work with any mscorlib

2010-12-01  Marek Safar  <marek.safar@gmail.com>

	Move references loading into a new class

2010-12-01  Marek Safar  <marek.safar@gmail.com>

	Move AssemblyResource to assembly.cs

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Import parameter default values using TypeCode

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Remove remaining typeof

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Read dynamic attribute using CustomAttributeData

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Emit optional default value-type parameter using nullref

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Move core predefined types into a new class

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Add initial reflection dependant code

2010-11-30  Marek Safar  <marek.safar@gmail.com>

	Move metadata importer out of compiler context finally

2010-11-29  Marek Safar  <marek.safar@gmail.com>

	Check imported custom attributes based on name only

2010-11-29  Marek Safar  <marek.safar@gmail.com>

	Made type member kind logic more flexible

2010-11-29  Marek Safar  <marek.safar@gmail.com>

	Don't special case value type constraint

2010-11-29  Marek Safar  <marek.safar@gmail.com>

	Add sanity check for imported static fixed buffer

2010-11-26  Marek Safar  <marek.safar@gmail.com>

	Removed few custom attribute IsDefined calls

2010-11-26  Marek Safar  <marek.safar@gmail.com>

	Import constants using their raw values only

2010-11-26  Marek Safar  <marek.safar@gmail.com>

	[655766] Encode string null attribute argument

2010-11-26  Marek Safar  <marek.safar@gmail.com>

	Cleanup typed constants

2010-11-26  Marek Safar  <marek.safar@gmail.com>

	Switch symbol writer to public api

2010-11-25  Marek Safar  <marek.safar@gmail.com>

	More using cleanup

2010-11-25  Marek Safar  <marek.safar@gmail.com>

	Remove TypeBuilder from DefineType

2010-11-24  Marek Safar  <marek.safar@gmail.com>

	Unify System.Reflection usings

2010-11-24  Marek Safar  <marek.safar@gmail.com>

	Recover from broken for statement

2010-11-24  Marek Safar  <marek.safar@gmail.com>

	Inflate imported type arguments types with type definition type
	arguments

2010-11-23  Marek Safar  <marek.safar@gmail.com>

	Remove typeof comparisons

2010-11-22  Marek Safar  <marek.safar@gmail.com>

	Remove typeof usage from DefaultCharSet

2010-11-22  Marek Safar  <marek.safar@gmail.com>

	Don't multiply fixed buffer size (it's done by runtime). Fixes
	#654058

2010-11-22  Marek Safar  <marek.safar@gmail.com>

	Emit fixed buffers using standard api only

2010-11-22  Marek Safar  <marek.safar@gmail.com>

	Tweak async modifier constant value

2010-11-18  Alexander Corrado  <alexander.corrado@gmail.com>

	Added 'async' as a recognized method modifier.

2010-11-22  Marek Safar  <marek.safar@gmail.com>

	Define embeded resources using standard API

2010-11-21  Marek Safar  <marek.safar@gmail.com>

	Move entry point handling to AssemblyDefinition

2010-11-21  Marek Safar  <marek.safar@gmail.com>

	Make generated assembly attributes container name unique

2010-11-21  Marek Safar  <marek.safar@gmail.com>

	Don't sign netmodules.

2010-11-21  Marek Safar  <marek.safar@gmail.com>

	Put back private key handling

2010-11-21  Marek Safar  <marek.safar@gmail.com>

	Improve handling of netmodules. Fixes #504085

2010-11-19  Marek Safar  <marek.safar@gmail.com>

	Add AssemblySpec to handle all assembly attributes in same way.

2010-11-19  Marek Safar  <marek.safar@gmail.com>

	Add missing file

2010-11-15  Marek Safar  <marek.safar@gmail.com>

	Remove old accessibility check routine

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	Move an assembly declaration handling into a new file

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	Add local version of constructor info constants

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	Remove unused namespaces

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	Show more details for CS1061 eror

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	Inflate nested non-generic interfaces inside generic type

2010-11-12  Marek Safar  <marek.safar@gmail.com>

	[652390] Return type inference can inflate using type parameters
	out of the reach

2010-11-11  Marek Safar  <marek.safar@gmail.com>

	[650850] Inflate all hoisted type parameter constraints

2010-11-11  Marek Safar  <marek.safar@gmail.com>

	Synchronize event add/remove using CAS

2010-11-10  Marek Safar  <marek.safar@gmail.com>

	Unwraped equality operators cannot use a user operator of
	different types

2010-11-10  Marek Safar  <marek.safar@gmail.com>

	Implement dynamic mutator over dynamic indexer

2010-11-10  Marek Safar  <marek.safar@gmail.com>

	More tweaks for nullable binary operation

2010-11-10  Marek Safar  <marek.safar@gmail.com>

	False user-operator has priority over logical not user-operator

2010-11-10  Marek Safar  <marek.safar@gmail.com>

	Fixes a logic error in filtering out operators like methods

2010-11-09  Marek Safar  <marek.safar@gmail.com>

	Don't crash on liften null left/right shift

2010-11-09  Marek Safar  <marek.safar@gmail.com>

	Logical binary operarions with dynamic arguments have to be
	unfolded

2010-11-09  Marek Safar  <marek.safar@gmail.com>

	Import declaring type base type when walking up the tree

2010-11-08  Marek Safar  <marek.safar@gmail.com>

	Emit correctly EndInvoke parameters attributes and names

2010-11-08  Marek Safar  <marek.safar@gmail.com>

	Fixed ambiguity for overload resolution between params and
	optional parameter of same type

2010-11-08  Marek Safar  <marek.safar@gmail.com>

	Clean up event expression assigning error reporting

2010-11-08  Marek Safar  <marek.safar@gmail.com>

	[651547] Check definitely assigned struct this access correctly.

2010-11-05  Marek Safar  <marek.safar@gmail.com>

	Better 843 error message

2010-11-05  Marek Safar  <marek.safar@gmail.com>

	Move 2.0 Monitor.Enter back out of the try block

2010-11-05  Marek Safar  <marek.safar@gmail.com>

	Only when importing nested types definition base type cannot be
	setup

2010-11-04  Marek Safar  <marek.safar@gmail.com>

	Allow liften null as a given number of bit positions for shift
	operator

2010-11-04  Marek Safar  <marek.safar@gmail.com>

	Add boxing for dynamic nullable conversion of coalescing operator

2010-11-04  Marek Safar  <marek.safar@gmail.com>

	Reject inaccessible members based on declaring type in dynamic
	context

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Inflate also event backing field

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Another missing full dynamic type equality check

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Implement lock statement over generic type parameter

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Issue a warning about re-assigned locked local variable

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Fixes NRE in pre-4.0 compilation

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Reset lock_taken before entering Monitor.Enter

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	ExclusiveOr is not nullable bitwise boolean operator

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	A candidate method can use dynamic in expanded form at non-first
	position

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	typeof expression does not need unsafe context for pointer types

2010-11-03  Marek Safar  <marek.safar@gmail.com>

	Pass checked context to compound member access setters

2010-11-02  Marek Safar  <marek.safar@gmail.com>

	Emit lock statement using Monitor.Enter (object, ref bool) when
	available

2010-11-02  Marek Safar  <marek.safar@gmail.com>

	Implements indirect delegates invocation via dynamic member
	dispatch

2010-11-01  Marek Safar  <marek.safar@gmail.com>

	Pass value type dynamic members as by-ref to persist member side
	effects

2010-11-01  Marek Safar  <marek.safar@gmail.com>

	Convert dynamic assignment in checked context when set

2010-11-01  Marek Safar  <marek.safar@gmail.com>

	Check for unfixed type arguments before calling overload
	resolution for inferred return type

2010-11-01  Marek Safar  <marek.safar@gmail.com>

	Set correct result type for chained folded enum subtraction

2010-11-01  Marek Safar  <marek.safar@gmail.com>

	Check binary header using right methods.

2010-10-29  Marek Safar  <marek.safar@gmail.com>

	Make dynamic array access index expresions in checked context

2010-10-29  Marek Safar  <marek.safar@gmail.com>

	Ignore private methods in batch import

2010-10-28  Marek Safar  <marek.safar@gmail.com>

	Fix emitted code for predefined or/and operation between bool? and
	bool

2010-10-28  Marek Safar  <marek.safar@gmail.com>

	Add more type parameter checks for inherited constraints.

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	Implement type inference of dynamic arguments used as unknown
	types

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	Use correct location for unexpected type parameter

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	Reorder MethodBase::Attributes usage

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	[649448] Compare original goto block for cloned blocks.

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	[648360] When inflating nested generic type use same type
	arguments to not inflate already inflated type

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	Make the static field readonly

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	Make static fields readonly

2010-10-27  Marek Safar  <marek.safar@gmail.com>

	crlf fix

2010-10-26  Marek Safar  <marek.safar@gmail.com>

	Revert unwanted changes

2010-10-26  Marek Safar  <marek.safar@gmail.com>

	Check nested declaring types when testing member overrides

2010-10-26  Marek Safar  <marek.safar@gmail.com>

	Delay expensive inflator construction for type parameter
	constraints

2010-10-25  Marek Safar  <marek.safar@gmail.com>

	Recover from invalid implicit lambda block

2010-10-24  Marek Safar  <marek.safar@gmail.com>

	Add more details to timing debugging

2010-10-24  Marek Safar  <marek.safar@gmail.com>

	Make setting a position out of the buffer size actually work

2010-10-23  Marek Safar  <marek.safar@gmail.com>

	Add missing v3 language version

2010-10-22  Marek Safar  <marek.safar@gmail.com>

	Use faster MemberKind when checking for a nested type

2010-10-22  Marek Safar  <marek.safar@gmail.com>

	Include parent type parameters when inflating nested type
	parameter constraint of type parameter type

2010-10-22  Marek Safar  <marek.safar@gmail.com>

	Move nested declaration looup to TypeContainer

2010-10-21  Marek Safar  <marek.safar@gmail.com>

	Add dynamic conversion to coalescing operator

2010-10-21  Marek Safar  <marek.safar@gmail.com>

	Implement closest override return type matching

2010-10-20  Marek Safar  <marek.safar@gmail.com>

	[601801] Fixes for parsing nant documentation

	Gleb Golubitsky <rush.william@gmail.com>

2010-10-20  Marek Safar  <marek.safar@gmail.com>

	Check for name conflicts between parent members and child block
	variables

2010-10-20  Marek Safar  <marek.safar@gmail.com>

	[647845] Don't skip parent types when looking for simple name

2010-10-20  Marek Safar  <marek.safar@gmail.com>

	More work on ambiguous named arguments

2010-10-19  Marek Safar  <marek.safar@gmail.com>

	More optional parameter VB compatibility fixes

2010-10-19  Marek Safar  <marek.safar@gmail.com>

	Restore altered arguments when overload resolution ends up in
	dynamic dispatch

2010-10-18  Marek Safar  <marek.safar@gmail.com>

	[512754] Overload resolution with named or optional arguments has
	to use closest member parameters

2010-10-15  Marek Safar  <marek.safar@gmail.com>

	[646997] Correctly emit platform ILOnly flag

2010-10-15  Marek Safar  <marek.safar@gmail.com>

	Extension method argument cannot exercise numeric conversion

2010-10-15  Marek Safar  <marek.safar@gmail.com>

	Add more dynamic conversion restrictions

2010-10-15  Marek Safar  <marek.safar@gmail.com>

	Clean up few more warnings

2010-10-15  Marek Safar  <marek.safar@gmail.com>

	More tweaks to dynamic overload resolution

2010-10-14  Marek Safar  <marek.safar@gmail.com>

	A conditional expression with either dynamic side is always of
	dynamic type

2010-10-14  Marek Safar  <marek.safar@gmail.com>

	Don't define same parameter more than once.

2010-10-14  Marek Safar  <marek.safar@gmail.com>

	More conversion tweaks for dynamic in using statement

2010-10-14  Marek Safar  <marek.safar@gmail.com>

	[646298] Compile multiple interface event declarators

2010-10-13  Marek Safar  <marek.safar@gmail.com>

	Use 2 phase dynamic load only for compound operations

2010-10-13  Marek Safar  <marek.safar@gmail.com>

	HasDynamicElement became available use it when building dynamic
	custom attributes

2010-10-13  Marek Safar  <marek.safar@gmail.com>

	[645992] When importing dynamic type arguments dynamic custom
	attribute flag has to be checked

2010-10-13  Marek Safar  <marek.safar@gmail.com>

	Dynamic type is never better than other types in overload
	resolution

2010-10-12  Marek Safar  <marek.safar@gmail.com>

	More fixes for implicit conversions of nullable types with
	nullable arguments

2010-10-12  Marek Safar  <marek.safar@gmail.com>

	Keep parsing after invalid contstructor declaration

2010-10-12  Marek Safar  <marek.safar@gmail.com>

	[645572] Import more type as possible dynamic types.

2010-10-12  Marek Safar  <marek.safar@gmail.com>

	Report correct error message for compound lifted binary operations

2010-10-12  Marek Safar  <marek.safar@gmail.com>

	Fold duplex conversion casts into a expression to emit single
	convert for expression trees

2010-10-11  Marek Safar  <marek.safar@gmail.com>

	Compound assignments over reference type array cannot use ldelema

2010-10-10  Marek Safar  <marek.safar@gmail.com>

	[645232] Implement ITypeDefinition for internal types.

2010-10-08  Marek Safar  <marek.safar@gmail.com>

	Don't assume the system.object does not have any fields

2010-10-08  Marek Safar  <marek.safar@gmail.com>

	[642975] Fix initializer of partially static multidimensional
	arrays

2010-10-08  Marek Safar  <marek.safar@gmail.com>

	[644673] Import of modules got broken

2010-10-08  Marek Safar  <marek.safar@gmail.com>

	Allow imported members cache to be setup in 2 phases as compiled
	one is to deal with generics recursions

2010-10-07  Marek Safar  <marek.safar@gmail.com>

	Fix compound event assigments with dynamic side effect

2010-10-07  Marek Safar  <marek.safar@gmail.com>

	[644507] Don't use nested type cache until declaring type is
	setup.

2010-10-07  Marek Safar  <marek.safar@gmail.com>

	Fix compound assigments with dynamic side effect

2010-10-06  Marek Safar  <marek.safar@gmail.com>

	Verify type parameter constraints type parameters

2010-10-06  Marek Safar  <marek.safar@gmail.com>

	Fixes allowed interface method modifiers

2010-10-05  Marek Safar  <marek.safar@gmail.com>

	Inflate imported nested type correctly.

2010-10-05  Marek Safar  <marek.safar@gmail.com>

	Compare all type arguments for nested generic types.

2010-10-01  Marek Safar  <marek.safar@gmail.com>

	ref/out arguments are always of static type

2010-10-01  Marek Safar  <marek.safar@gmail.com>

	Keep imported indexer parameters (they can contain non-inflated
	type parameters)

2010-10-01  Marek Safar  <marek.safar@gmail.com>

	Implement compound assignment over null value

2010-10-01  Marek Safar  <marek.safar@gmail.com>

	Dynamic compound assignment breaks standard C# result conversion
	rules

2010-09-30  Marek Safar  <marek.safar@gmail.com>

	void is never of type object

2010-09-30  Marek Safar  <marek.safar@gmail.com>

	Initialize both disposable and local variable for dynamic
	expressions.

2010-09-30  Marek Safar  <marek.safar@gmail.com>

	More awkward nullable binary expressions which are not lifted even
	though they should be

2010-09-29  Marek Safar  <marek.safar@gmail.com>

	Implement binary user operators over nullable not lifted
	expressions.

2010-09-29  Marek Safar  <marek.safar@gmail.com>

	Dynamic compound assignment can be used as an expression as well.

2010-09-29  Marek Safar  <marek.safar@gmail.com>

	[642437] Nested types have to check type arguments only and not
	full class

2010-09-29  Marek Safar  <marek.safar@gmail.com>

	Skip inaccessible nested types for member access expressions.

2010-09-29  Marek Safar  <marek.safar@gmail.com>

	Inflate custom site container delegates correctly.

2010-09-28  Marek Safar  <marek.safar@gmail.com>

	Optional parameters can be of a user value type

2010-09-28  Marek Safar  <marek.safar@gmail.com>

	Ignore imported not visible internal types

2010-09-25  Marek Safar  <marek.safar@gmail.com>

	Implemented more combinations of nullable boolean logical
	operators

2010-09-25  Marek Safar  <marek.safar@gmail.com>

	Better error message for syntax error in namespace name

2010-09-21  Marek Safar  <marek.safar@gmail.com>

	Don't restore unused flags

2010-09-21  Marek Safar  <marek.safar@gmail.com>

	[640722] Consider delegate parameters when checking member hiding

2010-09-21  Marek Safar  <marek.safar@gmail.com>

	[640709] Don't reuse method parameters for base proxy, they can be
	hoisted

2010-09-21  Marek Safar  <marek.safar@gmail.com>

	[640699] Reduced compound expressions need explicit conversion
	too.

2010-09-20  Marek Safar  <marek.safar@gmail.com>

	Implement postfix operations involving an implicit user operator.

2010-09-20  Marek Safar  <marek.safar@gmail.com>

	Don't check inferred dynamic type arguments against best candidate
	constraints.

2010-09-20  Marek Safar  <marek.safar@gmail.com>

	More missing conversions between object and dynamic

2010-09-20  Marek Safar  <marek.safar@gmail.com>

	[640285] Initialize this in current block instead of original
	block

2010-09-20  Marek Safar  <marek.safar@gmail.com>

	Parse secondary static like expression as a non-cast

2010-09-17  Marek Safar  <marek.safar@gmail.com>

	User operators are resolved in a batch, pick up the foremost

2010-09-17  Marek Safar  <marek.safar@gmail.com>

	Make the dynamic sites container name really unique

2010-09-17  Marek Safar  <marek.safar@gmail.com>

	Fixes preference of a user-defined conversion operators over
	lifted conversion operators

2010-09-17  Marek Safar  <marek.safar@gmail.com>

	Fixes cloning of a variable declarator.

2010-09-17  Marek Safar  <marek.safar@gmail.com>

	Implement predefined binary enum operators involving an implicit
	user conversion

2010-09-16  Marek Safar  <marek.safar@gmail.com>

	Recover wrong invalid character constants.

2010-09-16  Marek Safar  <marek.safar@gmail.com>

	[639603] Don't emit statements as expressions when they don't
	support it.

2010-09-16  Marek Safar  <marek.safar@gmail.com>

	[639407] Clean up more static stuff to fix repl instances.

2010-09-15  Marek Safar  <marek.safar@gmail.com>

	Recover wrong embedded statement syntax

2010-09-15  Marek Safar  <marek.safar@gmail.com>

	[639403] Fixes the endless recursion with hacked EOF

2010-09-14  Marek Safar  <marek.safar@gmail.com>

	Encode correctly all constants into a payload

2010-09-14  Marek Safar  <marek.safar@gmail.com>

	Recover wrong invalid initializer syntax.

2010-09-14  Marek Safar  <marek.safar@gmail.com>

	Finish predefined attributes instance access to allow compile time
	dynamic support in repl.

2010-09-14  Marek Safar  <marek.safar@gmail.com>

	Initialize all core types

2010-09-13  Marek Safar  <marek.safar@gmail.com>

	Removed confusing catch error message.

2010-09-13  Marek Safar  <marek.safar@gmail.com>

	Add a test for arrays with dynamic elements.

2010-09-13  Marek Safar  <marek.safar@gmail.com>

	Implement foreach over nullable values.

2010-09-13  Marek Safar  <marek.safar@gmail.com>

	Keep only 1 using implementation and handle all nullable and
	dynamic cases there.

2010-09-13  Marek Safar  <marek.safar@gmail.com>

	Better error reporting for missing identifiers.

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Always compare original block for cloned versions.

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Tweak few error reports

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Add comments.

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Converting the switch statement into normal statement (the block
	part).

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	When doing member access left side lookup the arity value is
	actually the exact value.

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Reject varianly implemented interface members.

2010-09-10  Marek Safar  <marek.safar@gmail.com>

	Try to speep up the GetLocation by a bit.

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	Recover from broken single parameter

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	Report precise error about local variable hiding

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	Do all possible mistaken empty statement checks in the parser

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	Don't recreate top-level destructor block, it carries precious
	stuff

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	Try to recover after each wrong statement.

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	__arglist can be used as an expression.

2010-09-09  Marek Safar  <marek.safar@gmail.com>

	The first push to make flow-analysis work for complex blocks.

	All blocks are now strictly hierachical which greatly simplifies
	many things and fixes many subtle bugs with local names. Removing
	the block cross references helps scalling when compiling deeply
	nested blocks or large method bodies including linq. Prepared
	possible dynamic statements to work with variable declarators.

2010-09-06  Jonathan Pobst  <monkey@jpobst.com>

	Normalize line endings.

2010-09-01  Marek Safar  <marek.safar@gmail.com>

	Add ctor block to field initializers to avoid member lookup at
	wrong block

2010-08-31  Rodrigo Kumpera  <kumpera@gmail.com>

	* rootcontext.cs (CloseTypes): Only apply the enum hack for corlib
	here.

	* rootcontext.cs (EmitCode): Do the corlib basic type hack here
	before types are emitted. This is required since EmitType produce
	type initializers, which derive from ValueType and must be able to
	see the TypeBuilder version of it.

2010-08-31  Marek Safar  <marek.safar@gmail.com>

	Add support for indirect pointer type constants.

2010-08-31  Marek Safar  <marek.safar@gmail.com>

	[635714] Inconsistent accessibility between nested private and
	protected internal types

2010-08-29  Marek Safar  <marek.safar@gmail.com>

	Don't generate tracing for the parser, it slows it down
	unnecessary

2010-08-29  Marek Safar  <marek.safar@gmail.com>

	Add more rules for static initializers

2010-08-29  Marek Safar  <marek.safar@gmail.com>

	Removed misused break, format long comment

2010-08-27  Marek Safar  <marek.safar@gmail.com>

	Implement dynamic sites for hoisted mvar types

2010-08-27  Marek Safar  <marek.safar@gmail.com>

	Check also modifier for identical ref/out parameters

2010-08-27  Marek Safar  <marek.safar@gmail.com>

	Fixes build

2010-08-27  Marek Safar  <marek.safar@gmail.com>

	Don't convert ByRef parameters

2010-08-26  Marek Safar  <marek.safar@gmail.com>

	Consider parameter constraints when choosing applicable method
	candidate

2010-08-26  Marek Safar  <marek.safar@gmail.com>

	Always build type from compiler type when flagged

2010-08-26  Marek Safar  <marek.safar@gmail.com>

	Jagged arrays have to be imported not created

2010-08-26  Marek Safar  <marek.safar@gmail.com>

	Import private event backing fields in dynamic context

2010-08-26  Marek Safar  <marek.safar@gmail.com>

	Special case unbox SLE conversion

2010-08-25  Marek Safar  <marek.safar@gmail.com>

	Maintain only one place with dynamic explicit conversions

2010-08-25  Marek Safar  <marek.safar@gmail.com>

	Defer null check to resolver

2010-08-25  Jonathan Pryor  <jonpryor@vt.edu>

	Fix explicitly-implemented interface member cref generation.

	The //member/@name for explicitly implemented interface members
	needs to contain the fully-qualified interface name, including
	type parameters (if necessary), so we need to generate
	"M:Container`2.Element.System#ICloneable#Clone", not
	"M:Container`2.Element.ICloneable.Clone".

	Furthermore, explicitly implemented generic interface methods
	within a generic type were always getting the type parameter count
	appended to them (which somewhat makes sense, as they're on a
	generic type...) which is counter to what CSC generates, e.g. we
	need to generate
	"P:Container`2.System#Collections#Generic#IList&lt;TValue&gt;#Item(System.Int32)"
	not "P:Container`2.IList`1.Item``1(System.Int32)".

2010-08-25  Marek Safar  <marek.safar@gmail.com>

	Show better message when assigning to the type

2010-08-25  Marek Safar  <marek.safar@gmail.com>

	Import private members too when using dynamic context

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	Import all delegates as sealed

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	Probing dynamic compatibility is identical to object

2010-08-24  Jonathan Pryor  <jonpryor@vt.edu>

	Improve XML documentation support for generic type parameters.

	Fixes #624242

	This also allows master 'gmcs /doc' to build OpenTK,
	gitorious.org/cadenza, and build the mcs/tools/mdoc unit tests w/o
	compilation error.

	The bug was caused by a NotSupportedException when calling
	ArrayContainer.Name within DocUtil.GetSignatureForDoc(TypeSpec).
	This is directly fixed by checking explicitly for ArrayContainer.

	Another bug fixed was wrt type parameter indexing in nested types,
	hence "counting" the number of type parameters declared in all
	declaring types.

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	More variance best candidate tweaks

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	[633674] Consider nested inflated types when mutating fields and
	methods

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	[633277] Import type parameters used as type parameter constraints

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	Recreate proxy parameters for imported methods

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	Fixes bootstrap corlib build

2010-08-24  Marek Safar  <marek.safar@gmail.com>

	Dynamic shares object members internally

2010-08-23  Marek Safar  <marek.safar@gmail.com>

	Fixed type inference between upper and lower bounds

2010-08-23  Marek Safar  <marek.safar@gmail.com>

	Add explicit variant delegates conversion

2010-08-23  Marek Safar  <marek.safar@gmail.com>

	Fixed moving of named params arguments

2010-08-20  Marek Safar  <marek.safar@gmail.com>

	Custom attribute itself can be used to specify optional parameter

2010-08-20  Marek Safar  <marek.safar@gmail.com>

	Add workaound for 2.6 bootstrap

2010-08-20  Marek Safar  <marek.safar@gmail.com>

	Prefer dynamic over other types when used with type inference.

2010-08-20  Marek Safar  <marek.safar@gmail.com>

	Create dynamic sites in the scope where used to overcome
	visibility issues

2010-08-20  Marek Safar  <marek.safar@gmail.com>

	[633037] Resolve instance expression of dynamic members

2010-08-19  Marek Safar  <marek.safar@gmail.com>

	Fixes delegate creation with dynamic parameters

2010-08-19  Marek Safar  <marek.safar@gmail.com>

	More dynamic conversion fixes

2010-08-19  Marek Safar  <marek.safar@gmail.com>

	Optimize few common paths

2010-08-19  Marek Safar  <marek.safar@gmail.com>

	[520151] Fail on invalid directive inside pre-processed block

2010-08-19  Marek Safar  <marek.safar@gmail.com>

	Refactor preprocessor parsing to use less string operations.

2010-08-18  Marek Safar  <marek.safar@gmail.com>

	Reduce memory footprint

2010-08-18  Marek Safar  <marek.safar@gmail.com>

	When merging sessions error messages don't get confused by
	warnings.

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	Cannot skip on the first type match for multiple inheritances

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	Defer checks until all base types are ready

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	Move lambda return type inference context out of BlockContext

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	[614924] Use proper best type expression for implicit array

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	Clean up unused code

2010-08-17  Marek Safar  <marek.safar@gmail.com>

	Crash with better error message for missing references.

2010-08-16  Marek Safar  <marek.safar@gmail.com>

	[570422] Cannot return from iterators

2010-08-16  Marek Safar  <marek.safar@gmail.com>

	[472007] Add warning about obsolete security attributes

2010-08-16  Marek Safar  <marek.safar@gmail.com>

	[408516] No implicit user conversion from or to interfaces

2010-08-16  Marek Safar  <marek.safar@gmail.com>

	[379537] Mark fields assigned in named argumets as used.

2010-08-16  Marek Safar  <marek.safar@gmail.com>

	[319462] Add more call optimizations

2010-08-13  Marek Safar  <marek.safar@gmail.com>

	[627488] Inflate inherited base method constraints with MVAR
	arguments

2010-08-13  Marek Safar  <marek.safar@gmail.com>

	Not all nested generic types are allowed for typeof expression.

2010-08-13  Marek Safar  <marek.safar@gmail.com>

	Check inaccessible type arguments

2010-08-13  Marek Safar  <marek.safar@gmail.com>

	Implicit conversions between dynamic and object is allowed for
	managed types only

2010-08-12  Marek Safar  <marek.safar@gmail.com>

	Optimize little bit cloning operations.

2010-08-10  Marek Safar  <marek.safar@gmail.com>

	[629383] Inflate generic type of default expression

2010-08-10  Marek Safar  <marek.safar@gmail.com>

	[629390] Avoid crash on the sole type expressions used for
	extension methods

2010-08-10  Marek Safar  <marek.safar@gmail.com>

	Also check for generic arguments of dynamic arrays

2010-08-10  Marek Safar  <marek.safar@gmail.com>

	[629742] Iterators can be of dynamic type

2010-08-10  Marek Safar  <marek.safar@gmail.com>

	Migrate more code to public API for 4.0

2010-08-06  Marek Safar  <marek.safar@gmail.com>

	Avoid a crash when using attributes and only partial method
	definition exists.

2010-08-06  Marek Safar  <marek.safar@gmail.com>

	Implement dynamic dispatch for element initializers.

2010-08-06  Marek Safar  <marek.safar@gmail.com>

	Add more sanity checks for dynamic attributes.

2010-08-06  Marek Safar  <marek.safar@gmail.com>

	Restrict allowed modifiers for struct members.

2010-08-06  Marek Safar  <marek.safar@gmail.com>

	More fixes for equality comparison between G<object> and
	G<dynamic>.

2010-08-05  Marek Safar  <marek.safar@gmail.com>

	Removed duplicate variant conversion.

2010-08-05  Marek Safar  <marek.safar@gmail.com>

	Add more files to ignore list

2010-08-05  Marek Safar  <marek.safar@gmail.com>

	Resolve ambiguity between optional and params parameter. Fixes
	#582360, #625353

2010-08-04  Marek Safar  <marek.safar@gmail.com>

	Ambiguous enumerator pattern means that we can still try to apply
	interface matching rules. Fixes #620154

2010-08-04  Marek Safar  <marek.safar@gmail.com>

	Use TypeSpecComparer.Default comparer for dynamic ref/out
	arguments.

2010-08-03  Marek Safar  <marek.safar@gmail.com>

	Member names cannot be the same as their enclosing type. Fixes
	#627296

2010-08-04  Jb Evain  <jbevain@gmail.com>

	DynamicConversion: properly order the arguments to Binder.Convert

2010-08-03  Marek Safar  <marek.safar@gmail.com>

	Report CS0243 before CS0578. Fixes #624650

2010-08-03  Marek Safar  <marek.safar@gmail.com>

	Add more cases for 4.0 identity comparison. Fixes #624183

2010-08-03  Marek Safar  <marek.safar@gmail.com>

	Fixed equality match between object and dynamic for ref/out
	parameters.

2010-08-03  Marek Safar  <marek.safar@gmail.com>

	Implemented as operator over dynamic expression. Fixes #624194

2010-08-02  Marek Safar  <marek.safar@gmail.com>

	Add verifier assistance for coalescing operator. Fixes #619192

2010-08-02  Marek Safar  <marek.safar@gmail.com>

	Add verifier required boxing of reference type of fields left
	expression

2010-08-02  Marek Safar  <marek.safar@gmail.com>

	Emit address load for compound struct references assignment. Fixed
	#620362

2010-08-02  Marek Safar  <marek.safar@gmail.com>

	Initialize anonymous methods story for all sections inside switch
	block. Fixes #624324

2010-08-02  Raja R Harinath  <harinath@hurrynot.org>

	Re-enable 'crlf' attributes on *.cs

	This fixes EOL conversions flagged by git 1.7.1
	core.autocrlf=true. At this point, neither git 1.7.1 nor 1.7.2
	show any automatic CRLF normalization. I think we're ready for
	another experiment.

	There seems to be a difference in the handling of mixed
	line-ending files between git 1.7.2 and older versions, when
	core.autocrlf is set to true.

2010-08-01  Marek Safar  <marek.safar@gmail.com>

	Import abstract members as abstract only, Fixes #617970.

2010-07-30  Marek Safar  <marek.safar@gmail.com>

	Allow Delegate.Combine/Remove with right null. Fixes #627044

2010-07-28  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, assign.cs, attribute.cs, decl.cs, delegate.cs,
	doc.cs, dynamic.cs, ecore.cs, expression.cs, generic.cs, import.cs,
	iterators.cs, linq.cs, membercache.cs, method.cs, report.cs,
	statement.cs, typemanager.cs: Major name lookup fixes to deal with
	C# 3.0 invocable members, correctly handle accessibility hidding and
	property-like different get/set base accessors.
	
	Also fixes bugs #624870, #618522, #616068, #444180, #333891

2010-07-14  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs, import.cs: When importing nested type via type
	arguments set their parent type correctly (Fixes #622051).

2010-07-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #622104
	* attribute.cs: Add default lookup flags.
	
2010-07-12  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Don't use Report directly.
	
	* expression.cs, ecore.cs: UserOperatorCall uses MethodSpec without
	MethodGroupExpr, will be simplified later.

2010-07-09  Marek Safar  <marek.safar@gmail.com>

	* property.cs, parameters.cs: Inflated IndexerSpec parameters.
	
	* import.cs: Don't build unused parameters.

2010-07-08  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Invocation): Don't recreate simple-name expression.

2010-07-07  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Don't report NRE warning for lifted null.

2010-07-07  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, convert.cs, expression.cs: Another reference
	equality implementation attack (Fixes #620025, #579058).

2010-07-05  Marek Safar  <marek.safar@gmail.com>

	* context.cs, expression.cs, ecore.cs: BaseThis is fully based on
	this expression (Fixes #619904).

2010-07-05  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs, class.cs: Don't use base member to check for
	property or indexer base implementation.

2010-07-03  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs: Copy Membercache member state flags for 2 stage
	inflate (Fixes #619555).
	
	* ecore.cs: Use resolved accessors everywhere.
	
2010-07-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #360820
	* membercache.cs, property.cs: Check accessors of base property and
	not the closest one.

2010-07-02  Marek Safar  <marek.safar@gmail.com>

	* modifiers.cs, membercache.cs, import.cs, class.cs: Moved imported
	override method checks into import.

	* expression.cs: Removed redundant check.

2010-06-30  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, expression.cs, statement.cs, method.cs, ecore.cs,
	delegate.cs, cs-parser.jay, visit.cs: Use MemberAccess to resolve
	base access expression, it has all bits done correctly.

2010-06-30  Marek Safar  <marek.safar@gmail.com>

	* support.cs: Removed unused code.
	
	* ecore.cs: Don't use memberlookup for operators.

2010-06-30  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, membercache.cs, convert.cs, expression.cs,
	ecore.cs: Replace remaining MethodLookup with correct user operator
	lookup (to do correct deep lookup). Clean up most of outstanding
	quirks in binary operator overload resolution.

2010-06-29  Marek Safar  <marek.safar@gmail.com>

	* import.cs: Operators must have between 1 and 2 parameters.
	
	* method.cs: Switch destructor to direct membercache lookup

2010-06-29  Marek Safar  <marek.safar@gmail.com>

	* driver.cs, expression.cs: Use Membercache for StringConcat when
	it got all what is needed.

2010-06-29  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs, expression.cs, statement.cs, doc.cs, ecore.cs:
	Changed FindMembers to allocate a new list only when a filter is
	used. Saves decent chunk of memory and should save even more in the
	future when the filter is not used that often.

2010-06-28  Marek Safar  <marek.safar@gmail.com>

	* field.cs, property.cs, assign.cs, const.cs, expression.cs,
	ecore.cs, class.cs, cs-parser.jay, enum.cs: Don't use intermediate
	structure for simple type fields (saves memory and makes few things
	simpler). Clean up some hacks mostly for events.

2010-06-25  Marek Safar  <marek.safar@gmail.com>

	* statement.cs, cs-parser.jay: Don't create expensive block for
	simple statements.

2010-06-24  Marek Safar  <marek.safar@gmail.com>

	* statement.cs, report.cs: Rethrow internal error when reporting is
	disabled.
	
	* ecore.cs: Check for identical name only when simple name is set.
	Fixes #616667

2010-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #616809
	* generic.cs, expression.cs, ecore.cs: Added a new type expression
	for open generic type to pass unbound type arguments to typeof
	expression.

2010-06-24  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Foreach collection implementation refactoring to
	search for GetEnumerator more preciselly. Fixes #431453 and more
	unreported bugs.

	* linq.cs, decl.cs, ecore.cs, delegate.cs: Update methodgroup api.

2010-06-23  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Track more locations.

2010-06-22  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, location.cs, cs-parser.jay: Track more locations.

2010-06-18  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, anonymous.cs, expression.cs, statement.cs,
	support.cs, location.cs, cs-parser.jay: Some work on full ast mode.

2010-06-18  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, typespec.cs, method.cs: Fixed few more dynamic
	conversion.

2010-06-18  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, namespace.cs: Report more predefined types and
	imported types collision types as a warning.
	Fixes #537414, #601157

2010-06-18  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Overrides base method constraint can use method type
	parameter.

	* import.cs: Removed redundant cache.
	
2010-06-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Propagate type only inflate downwards.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #614955
	* method.cs: Do not reject binary dynamic operators.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	* typespec.cs: Internal types have no generic parameters.
	Fixes #615022.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #614955
	* cs-parser.jay: Correctly set expression mode for default parameter
	values.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #615023
	* ecore.cs: Resolve dynamic namespace and keyword collision in the
	favour of the keyword.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #614917
	* convert.cs: Allow more undocumented 0 like values to enum type 
	conversions.

2010-06-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, method.cs: Inflate copied type parameters from base
	class or explicit interfaces.
	
	* convert.cs: Fixed conversion between two type parameters.
	Fixes #614471

2010-06-16  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs, convert.cs: Correctly resize an array used by
	GetUserOperator.

2010-06-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #599601
	* dynamic.cs, ecore.cs: A new flag for dynamic resolver to ignore
	generated member access left expression.
	
2010-06-16  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Dispatch dynamic invocation solely on left
	expression type.

2010-06-16  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, statement.cs: Always persist explicit cast
	semantic at expression level.
	
2010-06-15  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, attribute.cs: Enable generic type parameters
	attribute check.
	
2010-06-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #612146
	* generic.cs: Don't use fixed array for inflated type parameter
	interface constraints.
	
2010-06-15  Marek Safar  <marek.safar@gmail.com>

	* typespec.cs: ElementTypeSpec has to use its own ITypeDefinition.
	
	* report.cs: Unwrap elements for related symbols reporting.

2010-06-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #612796
	* cs-tokenizer.cs: Offset correctly keywords the first character
	comparison.
	
2010-06-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #613397
	* expression.cs: Removed too aggressive object initializers
	optimization.
	
2010-06-15  Marek Safar  <marek.safar@gmail.com>
	
	* parameter.cs, property.cs, membercache.cs, decl.cs, iterators.cs,
	anonymous.cs, expression.cs, support.cs, method.cs, pending.cs,
	class.cs, cs-parser.jay: Simplify parsing of accessors by removing
	any intermediate steps and fake nodes, also saves few MBs of memory.

2010-06-11  Marek Safar  <marek.safar@gmail.com>
	
	* modifiers.cs, rootcontext.cs, location.cs, cs-parser.jay: More
	precise modifiers parsing.

2010-06-09  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, anonymous.cs, expression.cs, cs-parser.jay:
	Fixed few shift/reduce conflicts.

2010-06-09  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, parameter.cs, dynamic.cs, typespec.cs,
	expression.cs, ecore.cs, cs-parser.jay: Fully parse composed type
	specifiers and stop using string in AST.

2010-06-07  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, eval.cs, iterators.cs, anonymous.cs, expression.cs
	method.cs, class.cs, delegate.cs, cs-parser.jay, driver.cs, visit.cs
	enum.cs: Hold location of predefined types.

2010-06-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #610878
	* pending.cs: Clone cached list before modifying.

2010-06-04  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, typespec.cs, expression.cs: Start using array member
	kind for better conversion checks.
	
	* import.cs, report.cs: Report better error message for runtime
	reflection bugs.

2010-06-04  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs, convert.cs, nullable.cs, expression.cs: Optimize
	user defined conversion probing and simplify user conversion for
	nullabe types. Fixes #610940.

2010-06-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #610919
	* parameter.cs, property.cs, cs-parser.jay: Use independent implicit
	parameters for explicit event accessors. Anonymous method capturing
	won't otherwise work for event implicit parameter.

2010-06-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #610088
	* nullable.cs, expression.cs, statement.cs, method.cs, ecore.cs:
	Ignore overrides for base overload resolution as for non-base
	expressions and convert the best candidate to closest override
	afterwards.

2010-06-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #610139
	* generic.cs, convert.cs: Recursively check effective base interface

2010-06-01  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Handle nullable types and type parameters in using
	statement, avoid boxing value types. Also fixes #571010

2010-06-01  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, expression.cs: Emit unbox for underlying nullable
	type boxing cast.

2010-05-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #610126
	* expression.cs: Don't use branch optimization for types bigger than
	int.

2010-05-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #609088
	* import.cs: Check private modifier correctly.

2010-05-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #609049
	* ecore.cs: Don't ignore override methods when looking for base
	member.

2010-05-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #608007, #572540, #566130, #476358

	* generic.cs, linq.cs, expression.cs, statement.cs, cs-parser.jay:
	More tricky refactoring of implicit linq blocks.
	
2010-05-25  Marek Safar  <marek.safar@gmail.com>

	* linq.cs, cs-parser.jay: Keep location for all linq clauses.

2010-05-25  Marek Safar  <marek.safar@gmail.com>

	* context.cs, expression.cs, cs-parser.jay: Don't store current
	block in This expression (it's too early for linq blocks).

2010-05-21  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Use constrained prefix more broadly to avoid boxing.

2010-05-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #591149
	* nullable.cs: Don't double wrap same expression.
	
2010-05-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #569827
	* anonymous.cs: Any issued error in probing mode means no match.

2010-05-20  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Search for base indexer using the closest match
	rule.

2010-05-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #572071
	* method.cs: Set override constraints using unexpanded interface
	list.

2010-05-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #572071
	* ecore.cs: Include secondary extension method lookup in probing
	mode.

2010-05-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #515801
	* typespec.cs (MayBecomeEqualGenericTypes): Recursively check
	type arguments.

2010-05-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #515801
	* pending.cs: Advance counter correctly.

2010-05-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #480139
	* method.cs, pending.cs: Indexer override uses base name.
	
2010-05-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #424064
	* generic.cs: Replace original with inflated type parameter on
	failure.

2010-05-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #359733
	* parameter.cs: Extension attribute can be defined in each assembly.

2010-05-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #446507
	* method.cs: Only one method can implement an interface.

2010-05-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #594905
	* convert.cs, constant.cs, expression.cs, literal.cs, ecore.cs:
	Typed null can be used as a source for expression methods.

2010-05-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #606551
	* namespace.cs: Using directive imports only types and not nested
	namespaces.

2010-05-17  Marek Safar  <marek.safar@gmail.com>

	* typespec.cs, expression.cs, statement.cs, ecore.cs, complete.cs,
	delegate.cs: Member instance is resolved after member overload
	definitely resolves static/instance property of member expression.
	Fixes #545047, #358848, #456605, #460016, #603299

2010-05-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #604981
	* generic.cs, decl.cs, anonymous.cs: Reset more type arguments
	details for nested anonymous methods stories.

2010-05-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #604735
	* namespace.cs: Don't report namespace collision.

2010-05-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #604748
	* class.cs, typespec.cs: Search full imported attribute hierarchy
	for AttributeUsage.

2010-05-11  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs: Ignore missing dependencies failure at
	initialization.

2010-05-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #604640
	* namespace.cs: Don't resolve using constraints too early.

2010-05-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #604239
	* generic.cs: Copy partial type constraints to partial container.

2010-05-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #557210
	* import.cs: Relax underlying enum field rules.

2010-05-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #603476
	* property.cs: Implement IParametersMember for indexer accessors.

2010-05-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #601141
	* class.cs: Update all partial modifiers.

2010-05-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #601708
	* method.cs, membercache.cs: Destructors cannot be hidden.

2010-05-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #602551
	* class.cs: Resursive reference of type definition is allowed.

2010-05-06  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Mutate cached storey instance types too.

2010-05-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #602443
	* convert.cs: Explicit enum conversion cannot involve user operators

2010-05-05  Miguel de Icaza  <miguel@novell.com>

	* class.cs (TypeContainer.DefineBaseTypes)
	(TypeContainer.CheckRecursiveDefinition): check for the iface not
	being null, as we could have failed resolution and crashed;
	Fixes #442144

	* cs-parser.jay: Productions to catch common mistakes when other
	punctuation operators are used instead of comma.   Fixes 571702	

2010-05-05  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Mutate correct set of constraints.

2010-05-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #602842
	* expression.cs: Resolve all array bound arguments.

2010-05-05  Marek Safar  <marek.safar@gmail.com>

	* import.cs: Don't import private fields.

2010-04-30  Marek Safar  <marek.safar@gmail.com>

	Partially based on patch by <sami.lamti@gmail.com>

	* eval.cs, ecore.cs: Fixed eval show methods.

2010-04-30  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, delegate.cs: Implement output type inference of
	methodgroup now when the specification was cleared at least little
	bit.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #575611
	* class.cs: Fix recursive unmanaged recursice sruct check.
	
2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #479776
	* expression.cs: Implement typeof unbounded nested generic types.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #474953
	* class.cs: Fix valid recursive base type definition.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #421737
	* convert.cs, expression.cs: A boxing conversion exists from a
	nullable-type to a reference type, if a boxing conversion exists
	from the underlying non-nullable-value-type to the reference type.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #376875
	* import.cs: Import volatile modifier.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #372412
	* typespec.cs, expression.cs, codegen.cs: Emit readonly prefix for
	generic arrays.

2010-04-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #568955
	* statements.cs: Handle recursive scope initializers.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #566511
	* anonymous.cs: Always get inflated version of hoisted variable
	on generic type definition.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	* import.cs, membercache.cs: Relax rules for valid properties.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	* import.cs: Intern arrays used in generic arguments.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #600398
	* convert.cs: Actually use effective base type for the comparison.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #600326
	* ecore.cs: Pass arity to base member lookup.

2010-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #573385
	* expression.cs: MemberAccess is of generic type based on right
	arity length only.

2010-05-28  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Made tab size configurable.

2010-05-27  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs: Ensure Obsolete members are defined before doing
	ctor look-up.

2010-05-27  Marek Safar  <marek.safar@gmail.com>

	* visit.cs: Add DOM visitor skeleton.
	
	* *.cs: Updated.

2010-05-27  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs, codegen.cs: Drop COMPILER_ACCESS hack.
	
2010-05-27  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Major rewrite of compiler internals to better work with
	unmodified System.Reflection.Emit. Some of the key changes are
	- TypeSpec replaces reflection specific System.Type.
	- All Type(TypeSpec) operations are now done in compiler therefore
	no dependency on SRE to inflate generic members and types or to
	query unclosed types.
	- MemberCache is now the only and full hierarchical topology.
	- Generic constraints are implemented properly.
	- And as a bonus compilation is on average 30% faster.

2010-04-15  Jb Evain  <jbevain@novell.com>

	* dmcs.exe.config: update the runtime version to .net 4.0 RTM.

2010-04-12  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, attribute.cs, parameter.cs: More attribute type
	checks.

2010-04-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #593342

	* generic.cs, parameter.cs, argument.cs, field.cs, property.cs,
	decl.cs, roottypes.cs, constant.cs, nullable.cs, expression.cs,
	method.cs, ecore.cs, class.cs, delegate.cs, attribute.cs,
	codegen.cs: Add custom attribute encoder to deal with unfinished
	types and easier corlib bootstrap from its own types.

2010-03-26  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Report invalid constraint types.

2010-03-16  Jb Evain  <jbevain@novell.com>

	* Makefile: rename the net_2_1 profile to moonlight.

2010-03-11  Marek Safar  <marek.safar@gmail.com>

	* statement.cs, cs-parser.jay: Use correct location for empty
	statements.

2010-03-11  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Disable Location from expression.
	
	* generic.cs: Check constraints for overrides in the parser.

2010-03-09  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay (GetLocation): Use an expression when available.

2010-03-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #582579
	* ecore.cs (FieldExpr): Don't optimize cross reference loads.

2010-03-04  Marek Safar  <marek.safar@gmail.com>

	A patch by kornelpal@gmail.com
	
	* dynamic.cs, anonymous.cs, rootcontext.cs, class.cs: Don't make
	compiler generated classes sealed by default. Emit and close top
	level compiler generated classes as well. 
	
	* support.cs: Use RuntimeHelpers.GetHashCode.

2010-03-03  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* Makefile: We need to use the internal bootstrapping gmcs for
	net_2_1_bootstrap too now.

2010-03-02  Raja R Harinath  <harinath@hurrynot.org>

	* expression.cs (IndexerAccess.ResolveAccessor): Add CS1540 check.

2010-03-02  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Missed few locations in previous fix.

2010-03-02  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, argument.cs, dynamic.cs, assign.cs, anonymous.cs,
	nullable.cs, expression.cs, statement.cs, cs-parser.jay, cfold.cs:
	Report correct location for operator errors.

2010-03-02  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs (IsDynamicType): Don't check external types when
	the attribute is not external.

2010-02-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #582579
	* decl.cs (IsExposedFromAssembly): Use PartialContainer for parent
	modifiers.

2010-02-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #581804
	* ecore.cs: Fixed type comparison.

2010-02-08  Miguel de Icaza  <miguel@novell.com>

	* namespace.cs (CompletionGetTypesStartingWith): Do not include
	private types in the completion results.

	* cs-parser.jay: Bubble completions after "from x in ?" and "from x
	... let ?"

2010-02-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, field.cs, decl.cs, cs-parser.jay: Simplify special
	constraint parsing.

2010-02-14  Miguel de Icaza  <miguel@novell.com>

	* eval.cs: Do not do the report printer dance unless the user has
	set the DescribeTypes feature.

2010-02-10  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, expression.cs: Track RC API changes.

2010-02-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #577029
	* anonymous.cs: Fixed TypeBuilder* check.

2010-02-06  Miguel de Icaza  <miguel@novell.com>

	* eval.cs (CompileBlock): Also undo if there are problems during
	semantic analysis, fixes various cases where invalid C# code would
	be reported, but the internal changes would not be undone.

2010-02-03  Miguel de Icaza  <miguel@novell.com>

	* driver.cs: Change the --fatal flag to allow a number to be
	passed, this ignores the first N fatal errors.   Useful to debug
	errors that do not happen on the first hit.

	* cs-parser.jay (invocation_expression): accept both the
	CLOSE_PARENS and COMPLETE_COMPLETION, this allows completions
	inside an invocation.

	* driver.cs: Expose FatalErrors.

	* eval.cs: Initialize the printer's Fatal property from the
	Driver's FatalError flag, this allows csharp --fatal to work
	again. 

	Add support for calling Describe (typeof (TYPE)) if the expression
	entered is a TYPE.
	
2010-02-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #574991
	* rootcontext.cs, class.cs, driver.cs: Hide enhanced warnings behind
	--lint.

2010-02-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #575986
	* expression.cs: Don't mutate typeof type definitions.

2010-01-28  Marek Safar  <marek.safar@gmail.com>

	* decl.cs: Use only one set of modifiers.

2010-01-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #573329
	* eval.cs: Don't disable error reporting completely on silent mode.
	
2010-01-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #573312
	* constant.cs, expression.cs, ecore.cs: Emit correct offset for
	pointer index of unknown size types greater than 2.

2010-01-15  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Use only 1 member kind enum.

2010-01-15  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Add event specification.

2010-01-14  Marek Safar  <marek.safar@gmail.com>

	* membercache.cs: Extracted from decl.cs.
	
	* *.cs: Put more infrastructure in place.

2010-01-13  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Add property specification, unused yet.

2010-01-13  Marek Safar  <marek.safar@gmail.com>

	* property.cs: Move all property based declarations into a new file.

2010-01-13  Marek Safar  <marek.safar at gmail.com>

	* expression.cs (Conditional): Resolve reduced expression.

2010-01-13  Marek Safar  <marek.safar at gmail.com>

	* *.cs: Introduced non-generic method specification.

2010-01-07  Marek Safar  <marek.safar@gmail.com>

	* method.cs: Move all method based declarations into a new file.

2010-01-07  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Extract field specification.

2009-12-17  Marek Safar  <marek.safar@gmail.com>

	* field.cs: Extracted from class.cs

2009-12-15  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs (GetFixedBuffer): Work on field definition only.

2009-12-15  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Clean up NET_4_0 conditional where possible.

2009-12-14 Rodrigo Kumpera  <rkumpera@novell.com>

	support.cs (DynamicType): Assembly property returns the assembly builder.
	This is required due to how compiler context works in corlib.

2009-12-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #564376
	* assign.cs (LocalTemporary): Removed no longer needed special
	by-ref handling.

2009-12-11  Marek Safar  <marek.safar@gmail.com>

	* modifiers.cs, decl.cs, iterators.cs, const.cs, anonymous.cs,
	class.cs, delegate.cs, cs-parser.jay, enum.cs: Turn modifiers into
	enum for easier debugging.

2009-12-10  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, anonymous.cs, class.cs: Sealed Define it's now main entry
	point.
	
	* parameter.cs, delegate.cs, dynamic.cs: Don't use builder methods
	directly.

2009-12-10  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, statement.cs: Handle parser error in code
	completition.

2009-12-10  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Ignore base imported methods when they are already
	in method bag.
	
	* eval.cs: Handle non-existent keys.
	
	* report.cs, driver.cs: Make fatal work with console printer only.

2009-12-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* typemanager.cs (MakeGenericMethod): Fix stupid mistake.

2009-12-08 Rodrigo Kumpera  <rkumpera@novell.com>

	* typemanager.cs: Add MakeGenericMethod that checks if the method
	is really the generic method definition.

	ecore.cs (MethodGroupExpr:IsApplicable): Use new TypeManager function
	to inflate generic methods.

2009-12-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #561149
	* anonymous.cs: Use actual type parameters when checking for generic
	method host.

2009-12-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #561369
	* expression.cs (DoNumericPromotion): Fixed typo.

2009-12-08  Marek Safar  <marek.safar@gmail.com>

	*.cs: Moving to generics world.

	cs-parser.jay: Removed current_array_type.

2009-12-07  Marek Safar  <marek.safar@gmail.com>

	*.cs: Moving to generics world.

2009-12-04  Marek Safar  <marek.safar@gmail.com>

	*.cs: Moving to generics world (day 2).

2009-12-03  Marek Safar  <marek.safar@gmail.com>

	*.cs: Moving to generics world.

2009-12-02  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, parameter.cs, class.cs, delegate.cs, attribute.cs:
	Encode dynamic type attribute for elements where attributes cannot
	be used.

2009-12-01  Marek Safar  <marek.safar@gmail.com>

	 argument.cs, assign.cs, expression.cs, cs-parser.jay: Named
	 arguments by ref.

2009-12-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #360455
	* class.cs: Never report a unused warning for generic events to
	workaround wrong expression type.

2009-11-30  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #558305
	* decl.cs, class.cs: Check partial method definitions using correct
	flag.

2009-11-30  Marek Safar  <marek.safar@gmail.com>

	* argument.cs: Don't cache rarely used dynamic flag.

2009-11-27  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Use jay global stacks (saves over 3MB for corlib).

2009-11-27  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (SimpleName): Removed no longer needed in_transit as
	Resolve is now non-reentrant (saves ~0.6MB for corlib).

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #545081
	* decl.cs: Check private nested types of nested types recursively.

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #558305
	* location.cs: Ignore self referencing #line directive

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #558292
	* class.cs: Allow single unsafe fixed buffer fields.

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	* expression: Optimize few more zero-based operations.

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, cs-parser.jay: Simplify literal parsing, also
	avoids boxing of literal values.

2009-11-26  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, argument.cs, eval.cs, linq.cs, decl.cs,
	expression.cs, ecore.cs, location.cs, cs-parser.jay, attribute.cs,
	codegen.cs: LocatedToken redesing to avoid excessive allocation and
	boxing (saves ~7MB for corlib). Also fixes presise token location.

2009-11-25  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, cs-parser.jay: Keep parser structures local. Share
	common data buckers.

2009-11-24  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Lower static array initializer barrier.
	
	* support.cs, driver.cs: Share reader buffer.

2009-11-23  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, support.cs: Some tokenizer optimizations.

2009-11-23  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, support.cs: Use Dictionary instead of Hashtable,
	cleanup some obsolete code.

2009-11-20  Marek Safar  <marek.safar@gmail.com>

	* context.cs, expression.cs, ecore.cs, complete.cs: Cleaned up
	Expression.Resolve.

2009-11-20  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Resolved expressions are never resolved again, this helps to
	uncover some not easy to find bugs and improve the performance.

2009-11-19  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Made constant expressions fully compatible with any other
	expression.

2009-11-19  Marek Safar  <marek.safar@gmail.com>

	* *.cs: DoResolve is a worker method and has to be protected.

2009-11-18  Marek Safar  <marek.safar@gmail.com>

	* *.cs: More context specific handling.

2009-11-17  Marek Safar  <marek.safar@gmail.com>

	* *.cs: More context specific handling.

2009-11-16  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, class.cs: Removed few fixed user types conversions.
	
	* symbolwriter.cs: Uses public ILOffset.

2009-11-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #553650
	* generic.cs: Another missing TypeToCoreType, still too many to fix.

2009-11-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #555170

	* class.cs, delegate.cs, enum.cs: Constants have to be available
	for parameters resolve.

2009-11-12  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, argument.cs, support.cs, delegate.cs: Dynamic
	arrays.

2009-11-12  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, context.cs, expression.cs, ecore.cs: Dynamic binding
	with a statically known candidate set.

2009-11-11  Scott Peterson  <lunchtimemama@gmail.com>

	* generic.cs: Made type inflation for generic constraint checks
	recursive. This fixes BGO #553655.

2009-11-11  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, decl.cs, expression.cs, ecore.cs: More dynamic type
	checks.

2009-11-10  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, parameter.cs, argument.cs, dynamic.cs,
	linq.cs, rootcontext.cs, ecore.cs, class.cs, delegate.cs,
	attribute.cs: Add some dynamic error checking.

2009-11-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #553465

	* expression.cs: Fixed mixed version of expression tree anonymous
	type.

2009-11-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #553031

	* linq.cs, expression.cs, class.cs, cs-parser.jay: Initialize
	expression tree version of anonymous type with members declaration.

2009-11-05  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs: Handle nullable parameter default expression.
	
	* argument.cs, dynamic.cs, expression.cs, support.cs, ecore.cs,
	class.cs, attribute.cs: Check for wrong dynamic arguments.

2009-11-05  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Dynamic statements.

2009-11-04  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, assign.cs, context.cs, expression.cs, ecore.cs:
	Compound assignments over dynamic type.

2009-11-03  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, expression.cs, delegate.cs: Dynamic
	constructor arguments.

2009-10-30  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, convert.cs, assign.cs, constant.cs, expression.cs,
	codegen.cs: Unary mutator on dynamic member access expression.

2009-10-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #550580	
	* convert.cs: Don't eliminate explicit precission casts.

2009-10-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #550404
	
	* parameter.cs, iterators.cs, context.cs, anonymous.cs,
	expression.cs, statement.cs, ecore.cs: Quote any nested expression
	tree.

2009-10-27  Marek Safar  <marek.safar@gmail.com>

	* constant.cs, nullable.cs: Create nullable-null as LiftedNull
	constant.
	
	* class.cs: Allow nullable binary user operators.

2009-10-26  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Move binary expression optimization at the end of
	resolve.

2009-10-23  Marek Safar  <marek.safar@gmail.com>

	* constant.cs, nullable.cs, expression.cs, literal.cs, cfold.cs:
	Separate NullConstant from NullLiteral.

2009-10-23  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, eval.cs, decl.cs, roottypes.cs, context.cs,
	anonymous.cs, expression.cs, rootcontext.cs, ecore.cs, class.cs,
	flowanalysis.cs, cs-parser.jay, driver.cs, codegen.cs: Split
	ModuleContainer. Add common unclosed member check routine.

2009-10-22  Marek Safar  <marek.safar@gmail.com>

	* argument.cs: Use literal flag for real literals only.

	* dynamic.cs: Use correct return type for custom delegates.

2009-10-22  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, expression.cs: Pass logical binary flag to dynamic
	resolver.

2009-10-22  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, ecore.cs: Dynamic invocation with void return type.

2009-10-21  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, convert.cs, expression.cs, ecore.cs: Wrap array index
	conversion.

2009-10-21  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, dynamic.cs, expression.cs: Don't resolve runtime
	binder flags.

2009-10-20  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, expression.cs: Latest API update.

2009-10-19  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, expression.cs: Dynamic array initializer.

2009-10-16  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, rootcontext.cs: Clear -nostdlib flag when object
	is imported.

2009-10-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #493523, #507067
	* convert.cs, nullable.cs, expression.cs: Do implicit and explicit
	standard nullable conversion using underlying standard conversion
	and not full conversion.

2009-10-15  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, expression.cs, ecore.cs, delegate.cs: Check return
	type in VerifyArgumentsCompat.

2009-10-15  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, expression.cs, statement.cs, namespace.cs, ecore.cs:
	Reject variable used with type arguments.

2009-10-14  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, assign.cs, expression.cs, ecore.cs:
	Implement dynamic expressions assignment.

2009-10-14  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Build underlying expression when resolving unary
	mutators.

2009-10-14  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Emit enum array initializer using binary blob.

2009-10-08  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, constant.cs: Optimize decimal constants which fit
	to long range.

2009-10-07  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs: Reset object_type.
	
	* assign: Made SimpleAssign public.

2009-10-06  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, decl.cs, namespace.cs, ecore.cs, class.cs: Pass
	invocation assembly to IsThisOrFriendAssembly.

2009-10-05  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Equality comparison of generic parameter with
	class constraint.

2009-10-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #543570
	* generic.cs: Import predefined constraints correctly.

2009-10-02  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Don't crash on overloads with optional paremeters where
	arguments count overflows.
	
	* parameter.cs: Import optional parameter constants using optional
	value type.

2009-10-01  Marek Safar  <marek.safar@gmail.com>

	* Makefile: Default is gmcs compiler.

2009-10-01  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Fixed few NRE.

2009-10-01  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, driver.cs: Expose parser exception in verbose mode.

2009-09-30  Marek Safar  <marek.safar@gmail.com>

	* linq.cs, convert.cs, assign.cs, expression.cs, ecore.cs: Add
	ShimExpression, ImplicitCast.

2009-09-30  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #542959
	* delegate.cs: Emit correct delegate instance variable when there
	are static and non-static overloads.

2009-09-29  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, linq.cs, anonymous.cs, expression.cs, statement.cs,
	ecore.cs, cs-parser.jay: Unary expression dynamic compiler.

2009-09-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #542487
	* ecore.cs: Resolve extension methods hidden by properties.

2009-09-25  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: More dynamic binary expressions.

2009-09-22  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, expression.cs: Fixed null lifted conversion for
	bitwise enum operations.

2009-09-22  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, ecore.cs: Fixed explicit unsafe coversion of long
	values in checked context.

2009-09-22  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: Fixed array index constant conversion.

2009-09-20  Miguel de Icaza  <miguel@novell.com>

	* expression.cs: Do not crash when MemberLookup returns something
	that is not a MemberExpr here.   Report error 582 instead. 

	Fixes #499988.

2009-09-18  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, class.cs: Check protected property accessors.

2009-09-18  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, assign.cs: Dynamic compound assignment.

2009-09-17  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Fixed compound assignment explicit conversion.

2009-09-17  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: Cannot infer variables from method group.

2009-09-16  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, convert.cs, context.cs, anonymous.cs,
	constant.cs, nullable.cs, expression.cs, literal.cs, ecore.cs,
	codegen.cs: Dynamic binary operations scaffolding.

2009-09-15  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Fixes nullable promotion for enum type variables.

2009-09-11  Marek Safar  <marek.safar@gmail.com>

	* driver.cs, dynamic.cs: Reset more static variables.

2009-09-11  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, expression.cs, rootcontext.cs, namespace.cs, ecore.cs,
	driver.cs: Introduced Expression::MakeExpression.

2009-09-11  Marek Safar  <marek.safar@gmail.com>

	* eval.cs: Exposed MessageOutput instead of cleaning up eval API.

2009-09-09  Marek Safar  <marek.safar@gmail.com>

	* eval.cs, report.cs: Use Console.Out for all eval error or warning
	output.

2009-09-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #518707
	* expression.cs (Is): Optimize only generic parameter type
	expression probing value type generic parameter.

2009-09-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #532571
	* ecore.cs: Check for simple name type arguments used with
	non-generic type.

2009-09-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #497421
	* generic.cs (CheckConstraint): Don't use buildin types to check for
	parameterless constructor.

2009-09-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #537402
	* generic.cs (CheckConstraint): Correctly inflate generic type
	arguments when checking generic method. 

2009-09-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #536463
	* decl.cs (AddToContainer): Don't report collision between explicit
	and parameterless non-explicit members.

2009-09-08  Marek Safar  <marek.safar@gmail.com>

	* eval.cs: Reset more static stuff.

2009-09-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324625
	* expression.cs, ecore.cs: Create nested generic type expression
	using declaring and not current type.

2009-09-07  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Changed Report class to accept various output printers and
	be an instance class. An expression resolver can now use different
	message reporter for each call and Report.Error can safely throw
	an exception. Part of ongoing work to turn mcs into proper library.

2009-09-04  Marek Safar  <marek.safar@gmail.com>

	* statement.cs, ecore.cs: Removed error reporting from emit code.

2009-09-04  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, parameter.cs: Moved parser check out of constructor

2009-09-03  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, expression.cs, statement.cs, cs-parser.jay: Moved
	parser checks out of constructors.

2009-09-02  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, statement.cs, ecore.cs: Use common Report.Error.

2009-09-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #535448
	* anonymous.cs, class.cs: Copy return label between all contexts.

2009-09-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #535395
	* namespace.cs: Resolve context can be null.

2009-08-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #533912
	* generic.cs: Use correct context for constraints resolving.

2009-08-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #532630
	* driver.cs: Trim conditional symbols.

2009-08-25  Marek Safar  <marek.safar@gmail.com>

	* context.cs: New file.
	
	* *.exe.sources, *.csproj: Updated.

2009-08-25  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, parameter.cs, decl.cs, statement.cs, namespace.cs,
	class.cs, generic-mcs.cs, codegen.cs: Add GetSignatureForError to
	IMembercontext, some small cleanups.

2009-08-24  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Split ResolveContext and EmitContext.

2009-08-24  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Only ResolveContext implements IMemberContext.

2009-08-21  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Renamed IResolveContext to IMemberContext.

2009-08-21  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Detached ResolveContext from EmitContext.

2009-08-21  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs: Moved flow-analysis to BlockContext.

2009-08-21  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Detached BlockContext from EmitContext.

2009-08-20 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* statement.cs: avoid nullref when the return value of GetEnumerator()
	does not contain any MoveNext() method.

2009-08-19  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Removed IResolveContext::GenericDeclContainer.

2009-08-19  Marek Safar  <marek.safar@gmail.com>

	* class.cs, delegate.cs: Changed Delegate to be TypeContainer based.

2009-08-19  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, iterators.cs, expression.cs, statement.cs, ecore.cs,
	cs-parser.jay, attribute.cs, codegen.cs: Better error reports.

2009-08-18  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Removed boolean fields from EmitContext.

2009-08-18  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Add IResolveContext::IsStatic.

2009-08-18  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Moved TopBlock's methods from EmitContext to TopBlock.

2009-08-17  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Removed DeclContainer from EmitContext.

2009-08-17  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Add IResolveContext::CurrentTypeParameters.

2009-08-14  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Removed TypeContainer and ContainerType from EmitContext.

2009-08-14  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, expression.cs, namespace.cs, ecore.cs, class.cs,
	codegen.cs: Add IResolveContext::LookupExtensionMethod.

2009-08-13  Marek Safar  <marek.safar@gmail.com>

	* decl.cs: Look in PartialContainer for parent type parameters.

2009-08-13  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, namespace.cs, ecore.cs, class.cs, attribute.cs,
	codegen.cs: Add IResolveContext::LookupTypeParameter.

2009-08-13  Marek Safar  <marek.safar@gmail.com>

	* lambda.cs, expression.cs, statement.cs, namespace.cs, ecore.cs:
	Moved resolved logic from Emit to Resolve.

2009-08-13  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, decl.cs, roottypes.cs, class.cs, attribute.cs,
	codegen.cs: Reworked atttributes handling of ResolveContext.

2009-08-12  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, ecore.cs, class.cs, attribute.cs, codegen.cs: Pushed
	LookupNamespaceOrType to ResolveContext.

2009-08-12  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, decl.cs, expression.cs, namespace.cs, ecore.cs,
	class.cs: Removed unused parameters and methods.

2009-08-11  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, lambda.cs, anonymous.cs, statement.cs, generic-mcs.cs,
	codegen.cs: Finding the best common type of a set of expressions for
	lambda statements.

2009-08-07  Marek Safar  <marek.safar@gmail.com>

	* dynamic.cs, expression.cs: More dynamic conversions.

2009-08-06  Miguel de Icaza  <miguel@novell.com>

	* generic.cs: This loop was incorrect, it was increment ii, but
	checking for `i'.  This was a change introduced to fix #327497,
	now we fix #424012.
 
	* class.cs: Catch another case for cs0533 error, fixes #324782.

2009-08-06 Rodrigo Kumpera  <rkumpera@novell.com>

	* typemanager.cs (GetGenericArguments): SRE returns null for
	generic methods on type builder instances if they are not generic
	themselves. For example, for Foo<int>::Bar() it returns null, but
	not for Foo<int>::Bar<>() or Foo<int>::Bar<double>().

2009-08-05  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, expression.cs, ecore.cs, class.cs,
	delegate.cs: Work on dynamic binding.

2009-08-04  Marek Safar  <marek.safar@gmail.com>

	A second fix for bug #525342
	* class.cs: Attach partial method attributes to method
	implementation.

2009-08-03  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, parameter.cs, support.cs, class.cs: Dynamic type
	restrictions.
	
	* rootcontext.cs: Default to langversion v4.

2009-08-03  Marek Safar  <marek.safar@gmail.com>

	* pending.cs: Check return type before member info is set.

2009-08-03  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Fully initialize generic hoisted field expression.

2009-08-02  Miguel de Icaza  <miguel@novell.com>

	* cs-parser.jay: Flag variables declared on the interactive shell
	as used to prevent the 168 warning about local variable not being
	used. 

2009-07-31  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, dynamic.cs, support.cs, class.cs, delegate.cs,
	attribute.cs: Emit dynamic export attribute.

2009-07-30  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: More verifier work.

2009-07-29  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs: Fixed SRE crash during corlib compilation.

2009-07-29  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, decl.cs, iterators.cs, convert.cs,
	nullable.cs, expression.cs, ecore.cs, class.cs, attribute.cs:
	More TypeManager.TypeToCoreType needed.

2009-07-29  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Update after recent SRE fixes.

2009-07-28  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, expression.cs, ecore.cs, delegate.cs: Use correct
	version of GetFieldHandle for fields of generic types.

2009-07-27  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, argument.cs, convert.cs, assign.cs, expression.cs,
	ecore.cs: Add TypeManager.IsDynamicType,
	PredefinedAttributes.Dynamic.

2009-07-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #415375
	* expression.cs: Fixed object and reference type parameter
	comparison.

2009-07-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #525342
	* class.cs: Attach partial method attributes to method
	implementation.

2009-07-24  Marek Safar  <marek.safar@gmail.com>

	* argument.cs, dynamic.cs, expression.cs, class.cs, attribute.cs:
	Dynamic arguments.

2009-07-24  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (MutateField): Add imported types handling.

2009-07-23  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, delegate.cs: Moved arguments resolve into their
	counterparts expressions. Removed argument resolve from
	CollectionElementInitializer.

2009-07-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #523683
	* convert.cs, delegate.cs: Use common overload mechanism for method
	group conversion check.

2009-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #523899
	* generics.cs: Exact type inference with other bound types.

2009-07-22  Raja R Harinath  <harinath@hurrynot.org>

	Don't complain when the same type is implemented by the output
	assembly as well as multiple referenced assemblies
	* namespace.cs (RootNamespace.LookupTypeReflection): Add
	'must_be_unique' flag.
	(GlobalRootNamespace): Update to changes.
	(Namespace.LookupType): Pass 'must_be_unique' only when we don't
	already have a type in hand.

2009-07-22  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: More verifier instrumentation.
	
	* statement.cs: Do proper throw expression conversion.

2009-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #522789
	* expression.cs: Mutate invocation return type.

2009-07-16  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Split assignable and readonly generated variable
	references.

2009-07-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #521671
	* statement.cs: Fixed crash when checking missing type.

2009-07-16  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, argument.cs, linq.cs, convert.cs,
	assign.cs, expression.cs, statement.cs, support.cs, ecore.cs,
	class.cs, driver.cs: Work on dynamic binding.

	* dynamic.cs: New file.

	* *.sources, *.proj: Updated.

2009-07-15  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Conditional): Avoid double Resolve.

2009-07-13  Marcus Griep  <marcus@griep.us>

	* ecore.cs: Fix obscure bug with resolving members of interfaces
	that hide parent interface members. Fixes bug #444388 and corrects
	bug #323096

2009-07-13  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (LocalVariableReference): Bounce resolve.

2009-07-10  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, lambda.cs, parameter.cs, convert.cs, anonymous.cs,
	expression.cs, literal.cs, ecore.cs, complete.cs: Moved internal
	types to new class.
	
	* support.cs: New dynamic type wrapper.

2009-07-08  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, cs-parser.jay: Better error reporting for implicitly
	typed local variable.

2009-07-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #519005
	* anonymous.cs: Use null_type as no return type placeholder.

2009-07-02  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Handle type inference of identical type parameters
	with different bounds.

2009-07-01  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, class.cs: Events variance.
	
	* cs-parser.jay: Interface events error messages.

2009-07-01  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, argument.cs: Updated type inference logic to C# 4.0.

2009-06-29  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, convert.cs, expression.cs, class.cs: Default
	parameter expression can be value-type New.

	* cs-parser.jay: Clean up too many parameter modifier boolean flags.

2009-06-26  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, argument.cs, expression.cs, ecore.cs, cs-parser.jay:
	Implemented C# 4.0 named arguments.

2009-06-24  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, parameter.cs, iterators.cs, convert.cs,
	expression.cs, ecore.cs, delegate.cs: Removed unnecessary ArgList
	parameter modifier. Also fixes bug #515497.

2009-06-24  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Replaced ArrayList with Arguments in need of a nonsequential 
	arguments expression to be implemented.
	
	*.sources: Add argument.cs

2009-06-23  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs: Moved GetParameterIndexByName to base class.
	
	* expression.cs, statement.cs, ecore.cs, delegate.cs: Removed
	unused AType. Use argument's version of GetExpressionTree.

2009-06-22  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, cs-parser.jay, attribute.cs, codegen.cs: Named
	arguments grammar.

2009-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #514096
	* class.cs: Allow IntPtr/UIntPtr fields to be volatile.

2009-06-17  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: The first multi-dimensional array nested array
	initializers was not checked.
	
	* statement.cs (Switch): Fixed error message to reflect 2.0 changes.

2009-06-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #513400
	* nullable.cs (EmitEquality): Operands emit could be simplified for
	built-in types when we now emit user operators differently.

2009-06-16  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Report inaccessible delegate methods correctly.

2009-06-16  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, expression.cs, ecore.cs, class.cs, delegate.cs,
	cs-parser.jay: Implemented C# 4.0 optional parameters.

2009-06-16  Marek Safar  <marek.safar@gmail.com>

	* driver.cs: Removed broken DefineManifestResource.

2009-06-16  Raja R Harinath  <harinath@hurrynot.org>

	* Makefile [net_2_0_bootstrap]: Don't explicitly mention net_1_1.
	Use $(BOOTSTRAP_PROFILE) instead.

2009-06-12  Jb Evain  <jbevain@novell.com>

	* rootcontext.cs: add a Platform field.
	* driver.cs: handle /platform.
	* codegen.cs: pass the proper flags according to
	the platform when saving the assembly.

2009-06-11  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, const.cs, report.cs, cs-parser.jay, attribute.cs:
	Add optional parameters grammar.

2009-06-10  Marek Safar  <marek.safar@gmail.com>

	* eval.cs, anonymous.cs, report.cs, rootcontext.cs, cs-parser.jay,
	driver.cs: Split lang version and metadata version.

2009-06-10  Marek Safar  <marek.safar@gmail.com>

	* decl.cs: Better overload ctor collision error message.

2009-06-05  Jb Evain  <jbevain@novell.com>

	* driver.cs (EmbededResource): avoid using an internal method
	in gmcs to embed manifest resources.

2009-06-04  Sebastien Pouliot  <sebastien@ximian.com>

	* generic.cs, parameter.cs: Avoid using 'var' so we can bootstrap
	the compiler from older mono versions (like moon's bots)

2009-06-04  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs (LookupTypeReflection): Ignore collisions between
	forwarded types.

2009-06-04  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs: Enabled generic type forwarders.

2009-06-04  Marek Safar  <marek.safar@gmail.com>

	* dmcs.*: Add another version of SRE compiler.

2009-06-03  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, parameter.cs, convert.cs,
	generic-mcs.cs: Fixed variant type conversions.

2009-06-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #507863
	* codegen.cs: Fixes a crash on invalid string value attribute.

2009-06-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #508334
	* typemanager.cs, parameter.cs, convert.cs, expression.cs, ecore.cs,
	cs-parser.jay: Fully import __arglist modifier.

2009-05-29  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, parameter.cs, ecore.cs, class.cs,
	delegate.cs, generic-mcs.cs: Rewrote type variance checks to
	actually work with closed generic types.

2009-05-27  Alan McGovern  <amcgovern@novell.com>

	* class.cs, decl.cs, delegate.cs, parameter.cs: 
	Fix the build by replacing the use of 'var' with the actual type.

2009-05-27  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, parameter.cs, decl.cs, ecore.cs, class.cs, delegate.cs
    cs-parser.jay, generic-mcs.cs: Report wrong variant types
	declarations.
	  
	* driver.cs, rootcontext.cs, report.cs: Add 3.0 language version
	filter.

2009-05-26  Rodrigo Kumpera  <rkumpera@novell.com>
			Marek Safar  <marek.safar@gmail.com>

	A fix for bug #377509
	* parameter.cs: Use predefined and not empty name for implicit
	setters.

2009-05-21  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Don't report wrong warnings for event fields.

2009-05-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #504667
	* class.cs: Check for static class using parent container instead of
	parent type.

2009-05-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #496922
	* expression.cs: Always use temporary variable when using object
	initializer.

2009-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #495112
	* class.cs (IsUnmanagedType): Handle recursive unmanaged types using
	local cache.

2009-04-27  Miguel de Icaza  <miguel@novell.com>

	* driver.cs: Add a flag to work as a replacement for CSC in VS.

2009-04-24  Miguel de Icaza  <miguel@novell.com>

	* complete.cs: No idea how gonzalo got a null in the list, but
	avoid crashing.

2009-04-24  Miguel de Icaza  <miguel@novell.com>

	* complete.cs (CompletionElementInitializer): New completion class
	to support completing inside a C# 3 element initializer, so this
	allows completion for Silverlight situations where it is very
	common to do:

	new TextBlock () { Fo<TAB>

	(CompletionSimpleName): Expose the prefix that was
	passed to the simple name.

	* cs-parser.jay (object_or_collection_initializer): Add support
	for element_initializers.

	* expression.cs (CollectionOrObjectInitializers.DoResolve):
	special case completion expressions as this method aggressively
	collects data before it operates, and errors were being thrown
	earlier than we were able to complete.

2009-04-23  Miguel de Icaza  <miguel@novell.com>

	* eval.cs: Make getcompletions silent and enable debugging output
	if the -v option is passed.

	* namespace.cs (NamespaceEntry.CompletionGetTypesStartingWith):
	Consider looking up the namespace that matches the prefix being
	used. 

	This is part of the support for allowing completions like:
	`System.Co<TAB>' to complete to System.Console.

	* complete.cs (CompletionSimpleName.AppendResults): Make this
	routine reusable.

2009-04-21  Raja R Harinath  <harinath@hurrynot.org>

	* cs-parser.jay (GetTokenName): Mark GENERATE_COMPLETION and
	COMPLETE_COMPLETION as internal.

2009-04-17  Miguel de Icaza  <miguel@novell.com>

	* complete.cs: Include namespace resolution in simple names as
	well as global types and types in the using scope in the
	resolution. 

	* namespace.cs: Supporting infrastrcture to provide completions
	based on the current using scope. 

	* eval.cs: Introduce an entry point that allows for initialization
	to return a list of the files passed on the command line.

2009-04-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #494243
	* report.cs (SymbolRelatedToPreviousError): Fixed NRE.

2009-04-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #493887
	* statement.cs: Don't skip string multi-section with default or
	null label when populating string hashtable.

2009-04-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #492329
	* expression.cs (New): Load variable when assigning type parameter
	to ref variable.

2009-04-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #488960
	* decl.cs: Compare MVAR types using non-null values.

2009-03-27  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, expression.cs: Removed unused nullable checks.

2009-03-27  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Removed some gmcs conditionals.

2009-03-26  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, support.cs: Moved generics stuff out of support.cs

2009-03-24  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs: Use queried type for MethodGroupExpr
	DeclaringType.

2009-03-23  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs: Consider all members for error reporting when
	checking named arguments.

2009-03-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #487625
	* namespace.cs: Use a warning for all predefined type conflicts.

2009-03-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #485706
	* statement.cs: Explicitly type catch type argument to pass verifier
	check.

2009-03-22  Miguel de Icaza  <miguel@novell.com>

	Initial support to provide code completion facilities to consumers
	of the evaluator API.
	
	* cs-tokenizer.cs (CompleteOnEOF): this new property is used to
	support the completion engine.   When we reach the end of the
	input stream instead of returning EOF, when this flag is true the
	tokenizer instead produces:

		One GENERATE_COMPLETION token: this token then must be
		handled in the grammar at every point where the user
		would likely request a completion.

		As many COMPLETE_COMPLETION tokens as necessary.   These
		tokens are generated to assist the parser in unwinding and
		producing a valid parse tree.    

	The parser rules do not have to be perfect, the parser needs to be
	augmented with judicious use of GENERATE_COMPLETION tokens to
	improve the areas where we can provide completion and the parser
	needs to add support for COMPLETE_COMPLETION tokens in productions
	to make them work.

	It is common to not have enough support for COMPLETE_COMPLETION
	under certain rules and that even if we generated the
	GENERATE_COMPLETION token that the resulting tree will be invalid
	due to the missing rules that support COMPLETE_COMPLETION.

	The final EOF token is produced by having the parser notify the
	tokenizer when it reaches the root production that the next token
	should be EOF.

	* support.cs (CompletionResult): New Exception.   This exception
	is thrown to return the completion results when one of the special
	completion expressions is reached.

	This exception is thrown by the completing ExpressionStatements
	classes that live in complete.cs

	* complete.cs (CompletingExpression): a new base class for
	completing expressions.   This derives from the
	ExpressionStatement class and not from Expression as it allows
	completion to happen not only where expressions are expected in
	the grammar, but also where statements are expected.

	(CompletionSimpleName): A new class used to provide completions
	for SimpleNames.     This currently only resolves to local
	variables from the evaluator context (GetVars call).

	(CompletionMemberAccess): Implements support for completing member
	access patterns. 

	* cs-parser.jay: Add support for completion in a few places. 

	* eval.cs (GetCompletions): New public API for the evaluator that
	returns a list of possible completions given the input.   The
	return value is an array of completions 

	* anonymous.cs (Compatible): If the exception thrown from the
	resolved expression is a CompletionResult exception let that one
	through instead of printing a diagnostic error in the try/catch. 
<	
2009-03-22  Miguel de Icaza  <miguel@novell.com>

	* 

	* driver.cs (Main): Use Environment.Exit to quit quickly and
	prevent the compiler from doing the usual wait for helper thread
	to terminate.  

	This is to prevent a slowdown that was reported by Gonzalo on
	ASP.NET 

2009-03-19  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Load build-in types directly instead of accessing
	an internal field.

2009-03-18  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Always use unbox.any when available.

2009-03-18  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Always set TypeAttributes.BeforeFieldInit conditionally.

2009-03-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Removed obsolete version of type inference.

2009-03-16  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, decl.cs, roottypes.cs, anonymous.cs, nullable.cs,
	expression.cs, rootcontext.cs, namespace.cs, ecore.cs, class.cs,
	delegate.cs, flowanalysis.cs, cs-parser.jay, driver.cs,
	attribute.cs, codegen.cs: Changed RootTypes to be ModuleContainer.

2009-03-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #482996
	* anonymous.cs: Make sure we are not infering return type when
	checking type compatibility.

2009-03-11  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, parameter.cs, decl.cs, const.cs,
	rootcontext.cs, namespace.cs, class.cs, delegate.cs, driver.cs,
	generic-mcs.cs, attribute.cs, codegen.cs: Maintain predefined
	attributes in their own structure. Needed when accessing their
	properties before they are resolved.

2009-03-09  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Optimized GetKeyword using an array instead of
	hashtable (~10x faster).
	
	* driver.cs: Removed wrong Reset.

2009-03-08  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Use correct common base type for unmanaged delayed
	check.

	* rootcontext.cs: Wrap unhandled exception.

2009-03-06  Raja R Harinath  <harinath@hurrynot.org>

	Make SeekableStreamReader self-tuning and arbitrarily seekable
	* support.cs (SeekableStreamReader.ResetStream): New.  Allocates
	the buffer.
	(SeekableStreamReader.Position.set): Use it.  Simplify logic
	which, as a side-effect, makes it arbitrarily-seekable.  Tune the
	buffer size when the stream needs to be re-read from the beginning.

2009-03-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #480100
	* parameter.cs: A parameter is not hoisted when used directly as ET.

2009-03-04  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Fixed an issue when using variable is of interface
	type.

2009-03-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #480319
	* report.cs, driver.cs: Support -warnaserror-:<warning list> option.

2009-03-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #480867
	* typemanager.cs, expression.cs, ecore.cs: Changed method group
	expression to have no valid type.

2009-03-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #481258
	* class.cs: Set extension method flag in partial container.

2009-03-03  Marek Safar  <marek.safar@gmail.com>

	* statement.cs, typemanager.cs: Use expression for StringEmitter.
	
	* attribute.cs: Add sanity check.

2009-02-27  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Add external constructor error.

2009-02-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475354
	* convert.cs, nullable.cs, expression.cs, statement.cs: Emit
	correctly user defined nullable equality operators.

2009-02-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #479532
	* expression.cs: Implement NewInitialize::AddressOf.

2009-02-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #413633
	* expression.cs: Iterate all base class-constraint types.

2009-02-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #479209
	* literal.cs: Mutate null underlying type.

2009-02-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #476295
	* convert.cs: Avoid wrapping implicitly convertible reference type.

2009-02-23  Marek Safar  <marek.safar@gmail.com>

	* iterators.cs: Create MemberName correctly.

2009-02-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #478655
	* literal.cs: Check also underlying null type conversion.

2009-02-21  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, ecore.cs, class.cs: Removed redundant AsAccessible.

2009-02-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #477447
	* statement.cs: Add reference to correct parent storey when this
	is accessible from deep children storey (more than 1 level).

2009-02-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475860 by David Mitchell <dmitchell@logos.com>
	* class.cs: Define base type members before setting up member cache.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #477378
	* nullable.cs, expression.cs, statement.cs: More precise null type
	sanity checks.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #472805
	* typemanager.cs, namespace.cs: Import only visible extension method
	types.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #476895
	* attribute.cs: Use correct resolve context for attribute type.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #476266
	* anonymous.cs: Mutate multi-dimensional arrays.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #476400
	* statement.cs, expression.cs: Removed wrong Dispose optimization.

2009-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #476811
	* generics.cs: Fixed null-literal check.

2009-02-17  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, convert.cs, flowanalysis.cs, driver.cs,
	expression.cs, ecore.cs, rootcontext.cs, eval.cs, class.cs: More
	messing with static variables.

2009-02-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475965
	* generics.cs: Check generic parameter type after extracting from
	Expression<T>.

2009-02-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475823
	* convert.cs, expression.cs, literal.cs, ecore.cs, cfold.cs: Add
	typed-null support.

2009-02-14  Marek Safar  <marek.safar@gmail.com>

	* modifiers.cs, decl.cs, ecore.cs, class.cs, flowanalysis.cs:
	Simplified event field definition using backing field and not
	field builder directly.

	* expression.cs (EmitLdArg): Optimize fast paths.

2009-02-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475327
	* expression.cs (ArrayCreation): Don't mutate values optimized away.

2009-02-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475342
	* cs-parser.jay: Using 'super' instead of 'base' to call base
	constructor crashes compiler.

2009-02-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475354
	* expression.cs (Constantify): Add nullable types.
	
	* const.cs (EmitDecimalConstant): Avoid explicit cast.

2009-02-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #475246
	* expression.cs: More broken flowanalysis hacking needed.

2009-02-12  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs: Compare only ref/out array modifiers. 

2009-02-11  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Use member cache when looking for foreach members.

2009-02-11  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Don't expose internal initializer types.
	
	* statement.cs: Check also explicit conversions for goto case.

2009-02-11  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, statement.cs: Removed usage of IsAssignableFrom.

2009-02-10  Marek Safar  <marek.safar@gmail.com>

	* *.cs: Replace null-type with NullLiteral where appropriate.

2009-02-09  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Initializer of reference argument use temporary
	variable to be verifiable.
	
	* parameter.cs: Share EmitLdArg.

2009-02-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #473559
	* class.cs: Fixed: Not reporting error about nested class with the
	same name.

2009-02-06  Scott Peterson  <lunchtimemama@gmail.com>

	Contributed under the MIT/X11 license.

	* generic.cs: Added VerifyVariantTypeParameters which performs new
	variance verification logic. The old logic, based on the spec, was
	wrong because the spec is full of LIES!

	* generic-mcs.cs: Stubbed out the VerifyVariantTypeParameters method.

	*typemanager.cs: Moved variance verification logic to GenericTypeExpr.

	* class.cs:
	* ecore.cs: Added calls to the new variance verification logic.

	* parameter.cs:
	* delegate.cs: Removed calls to the old variance verification logic.

2009-02-06  Marek Safar  <marek.safar@gmail.com>

	* delegate.cs: Use cached Invoke method directly.

2009-02-06  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Emit expression tree for hoisted variable access.

2009-02-04  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs: Add better extension class check.

2009-02-05  Scott Peterson  <lunchtimemama@gmail.com>

	* generic.cs: Fixed typeo (TypeParameter.Variacne).

2009-02-04  Scott Peterson  <lunchtimemama@gmail.com>

	This patch adds initial generic variance support to the compiler.
	It is contributed under the MIT/X11 license.

	* typemanager.cs: Modified ImplementsInterface to check variance.
	Added VerifyVariantTypeParameters which checks the specified type to see
	if it uses a variant type parameter as a type argument (which is not
	allowed). Added IsVariantOf which determins if the first type is a
	variant of the second. NOTE: This only supports reference types at
	the moment to conform with the current level of VM support. When the
	VM supports value types, this will follow step.

	* generic.cs: Added the Variance enum. Added a Variance property to
	TypeParameter and added variance support to definition phase. Added a
	Variance property to TypeParameterName. Also check to make sure that
	no variant types appear in generic method parameters.

	* cs-tokenizer.cs: Modified parse_less_than to tokenize the variance
	keywords if the langversion supports it.

	* parameter.cs: Added Parameter.VerifyNoVariantTypeParameters to ensure
	that variant types are only used in legal positions. Also added
	ParametersCompiled.VerifyNoVariantTypeParameters to check all of its
	parameters.

	* decl.cs: Construct TypeParameter with the variance information.

	* convert.cs: Checks variance in ImplicitReferenceConversionExists
	and ImplicitConversionStandard.

	* rootcontext.cs: Added new "Future" language version.

	* class.cs: In TypeContainer.DoDefineMembers, ensure that contravariant
	type parameters are not used as type arguments in interface inheritance.
	In MemberBase.DoMemberDependentChecks, ensure that contravariant type
	parameters are not used as method return types. In MemberBase.
	ResolveMemberType, ensure that variant type parameters are not used
	as type arguments. Also call VerifyNoVariantTypeParameters on every
	set of parameters which are resolved.

	* delegate.cs: Modified Delegate.Define to ensure that variant
	parameters are not used as type arguments and that a contravariant
	parameter is not used as the return type. Also call
	VerifyNoVariantTypeParameters on the delegate parameters.

	* cs-parser.jay: Modified grammar to support "in" and "out" keywords
	to specify generic variance.

	* driver.cs: Added support for LanguageVersion.Future in the form of
	"-langversion:future".

	* generic-mcs.cs: Stubbed out new members in generic.cs.

2009-02-03  Marek Safar  <marek.safar@gmail.com>

	* class.cs, generic.cs: Emit type parameter constraints for nested
	types.

2009-02-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #471213
	* class.cs: Avoid emitting backing field for abstract event fields.

2009-02-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #359731
	* cs-tokenizer.cs, cs-parser.jay: Correctly parse nested query
	expressions.

2009-01-30  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #470767
	* statement.cs: Introduced BlockScopeExpression, needed when 
	expression tree conversion has to emit scope variables.

2009-01-29  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Remove duplicate CallingConvention.

2009-01-29  Marek Safar  <marek.safar@gmail.com>

	*.cs: Rename Parameters to ParametersCompiled and ParametersImported
	when I finally found the right naming convention.

2009-01-29  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Put back different open parens optimization.

2009-01-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #470227
	* cs-tokenizer.cs: Remove too agressive parser optimization.

2009-01-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324319
	* class.cs: Remove too early base type resolve.

2009-01-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324319
	* ecore.cs: Explicitly type null when assigning to type argument to
	make pass verifier check.

2009-01-27  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Fixed recent regression when initializing captured 
	this.

2009-01-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #469019
	* anonymous.cs: Use all parent type parameters when instantiating
	nested generic storey.

2009-01-26  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Check for null instance methodgroup expression.

2009-01-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #469244
	* cs-tokenizer.cs, cs-parser.jay: Fixed parsing of nullable type
	instance inside a conditional expression.

2009-01-23  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, parameter.cs, decl.cs, anonymous.cs,
	expression.cs, report.cs, ecore.cs, attribute.cs: Use common 
	GetElementType and HasElementType. IsValueType clean up.

2009-01-23  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs: Use common EmitCall.
	
	* expression.cs: Emit constraint. for virtual calls only.

2009-01-23  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, eval.cs, convert.cs, const.cs, 
	expression.cs, statement.cs, rootcontext.cs, ecore.cs, class.cs,
	driver.cs, attribute.cs, enum.cs: Split IsValueType and IsStruct
	checks.

2009-01-22  Jb Evain  <jbevain@novell.com>

	* anonymous.cs: make anonymous types' ToString implementation
	match what csc outputs.

2009-01-21  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, ecore.cs, iterator.cs: TypeLookupExpression clean
	up.

2009-01-17  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, ecore.cs: Explicitly casts type arguments to pass
	verifier checks.

2009-01-16  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs (LiftedBinaryOperator): Check for all possible null
	expressions.

2009-01-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #466634
	* statement.cs: Add reference for nested storey when only this
	is captured.

2009-01-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #466474
	* codegen.cs: Emit SecurityPermissionAttribute when -unsafe option
	was specified.

2009-01-15  Marek Safar  <marek.safar@gmail.com>

	* iterators.cs, anonymous.cs, expression.cs, statement.cs, ecore.cs:
	Fixed nested stories parent referencing process. Also fixes #463985.

2009-01-06  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, iterators.cs, expression.cs, statement.cs, doc.cs, 
	class.cs, cs-parser.jay, codegen.cs: Clean up destructor
	implementation. Also fixes #463108.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #416109
	* decl.cs: Issue correct CLSAttribute warning location.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #456775
	* attribute.cs: Use attribute owner scope when resolving attribute
	arguments.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #457257
	* decl.cs: Fixed incorrect member declaring type comparison.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #460896
	* driver.cs: Handle /RES resources as embeddable.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #462515
	* ecore.cs: Report inacessible members upwards.

2009-01-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #463190, #463192
	* decl.cs, namespace.cs: Also import internal extension classes.

2009-01-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #463415
	* generic.cs: Use right index for RemoveDependentTypes.

2009-01-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #463196
	* expression.cs: Fixed enum to null comparison.

2009-01-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #463121
	* nullable.cs: Fixed nullable user equality operator comparison.

2009-01-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #462950
	* class.cs, decl.cs: Use full explicit name when defining automatic
	property backing field.

2009-01-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #462592
	* pending.cs: Emit type arguments for generic proxy method.

2008-12-30  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (As): Mutate all type arguments.

2008-12-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #462622
	* anonymous.cs: Resolve anonymous type GetHashCode in unchecked
	context.

2008-12-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #450782
	* ecore.cs: Consider more variables of form V.I to be fixed.

2008-12-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #460712
	* typemanager.cs: Core types could be imported.

2008-12-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #460847, #460772, #458049, #457339, #447807
	* generic.cs, parameter.cs, lambda.cs, linq.cs, anonymous.cs
	statement.cs, ecore.cs, class.cs, delegate.cs, flowanalysis.cs
	cs-parser.jay, driver.cs: LINQ implementation upgrade to deal with
	user lambdas used inside query clauses.

2008-12-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #460229
	* cs-tokenizer.cs: Ignore wrongly placed BOM markers.

2008-12-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #459952
	* decl.cs, namespace.cs: Use common CheckAccessLevel.

2008-12-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #459630
	* convert.cs: Enum to valuetype conversion is not allowed.

2008-12-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #457087
	* generic.cs: Don't crash when constraint comes from type
	declaration.

2008-12-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #459221
	* anonymous.cs, statement.cs: Delay only captured this
	initialization.

2008-12-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #457489
	* anonymous.cs, statement.cs: Split anonymous storey instantiation
	and initialization to capture scope initializers correctly.

2008-12-11  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, parameter.cs, expression.cs, statement.cs, doc.cs:
	ParameterReference refactoring.

2008-12-03  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, namespace.cs, driver.cs: Allow ExtensionAttribute
	to be imported from any assembly.

2008-12-03  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, lambda.cs, linq.cs, iterators.cs, anonymous.cs
	statement.cs, class.cs, cs-parser.jay: Removed duplicate parameters
	from anonymous method and lambda expression.

2008-12-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #448560
	* expression.cs (As): Box any generic type arguments to be
	verifiable.

2008-11-29  Raja R Harinath  <harinath@hurrynot.org>

	Add tripwire for implicit conversion bugs
	* ecore.cs (MethodGroupExpr.Error_ArgumentCountWrong): New helper
	for CS1501 error.
	(MethodGroupExpr.OverloadResolve): Add sanity check between
	IsApplicable and VerifyArgumentsCompat.
	(VerifyArgumentsCompat): Report CS1501 where appropriate.

2008-11-29  Raja R Harinath  <harinath@hurrynot.org>

	Fix build break in System.Data_test
	* convert.cs (ImplicitConversionExists): Move NullLiteral
	conversions ...
	(ImplicitStandardConversionExists): ... here.

2008-11-28  Marek Safar  <marek.safar@gmail.com>

	* literal.cs: Emit correctly explicit null to nullable cast.

2008-11-28  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, generics.cs: Fixed crash when type arguments fail to
	resolve.

2008-11-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #449005
	* convert.cs, nullable.cs: Use only one implicit nullable
	conversion.

2008-11-27  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, literal.cs: More Convert cleanup is needed.

2008-11-27  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, class.cs: Fixed misleading error message.

2008-11-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #449005
	* nullable.cs (EmitEquality): Disable optimization for user operator
	operands.

2008-11-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #447027
	* anonymous.cs (HoistedVariable): Cache also outer access to deal
	with context variables stored as expression instances.

2008-11-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #447027
	* delegate.cs: Fixed delegate VerifyMethod logic.

2008-11-24  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, delegate.cs: MethodGroup expressions can be applicable
	but not verifiable.

2008-11-21  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, decl.cs, anonymous.cs, class.cs, enum.cs: Rewrote
	member type resolve to follow normal flow, instead of random
	property access.

2008-11-21  Marek Safar  <marek.safar@gmail.com>

	* iterators.cs (GetEnumeratorStatement): Re-use already resolved
	type.

2008-11-21  Marek Safar  <marek.safar@gmail.com>

	* const.cs: Emit decimal array constant as literal.

2008-11-20  Marek Safar  <marek.safar@gmail.com>

	* iterators.cs, ecore.cs: Removed CurrentBlock statement.

2008-11-19  Marek Safar  <marek.safar@gmail.com>

	* eval.cs, location.cs, driver.cs (Location.SourceFiles): Turned
	into real property (saves 8 MB for corlib compilation).

2008-11-19  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, lambda.cs, linq.cs, iterators.cs, anonymous.cs,
	nullable.cs, expression.cs, statement.cs, ecore.cs, cs-parser.jay
	generic-mcs.cs: Small cleanup of TypeArguments.

2008-11-18  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, iterators.cs, anonymous.cs, nullable.cs, ecore.cs,
	expression.cs, namespace.cs, generic-mcs.cs, class.cs: Small cleanup
	of ConstructedType expression, renamed to GenericTypeExpr.

2008-11-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #445303
	* location.cs (IsConditionalDefined): Handle undefined global
	defines.

2008-11-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #444678
	* expression.cs (TryReduceConstant): Always create new constant
	instance.

2008-11-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #444673
	* ecore.cs: Ignore open generic types when used as generic type
	instance fields.

2008-11-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #445458
	* expression.cs, cs-parser.jay: Don't crash when an expression
	statement is null.

2008-11-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #445464
	* expression.cs, cs-parser.jay: Fixed typeof of non-generic type
	inside unbound type.

2008-11-14  Jb Evain  <jbevain@novell.com>

	* driver.cs: ignore empty -nowarn argument such as
	the one in -nowarn:12,13,,.

2008-11-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #444271
	* anonymous.cs: Rescan parent storeys when best candidate was
	undone.

2008-11-13  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, expression.cs, ecore.cs, cs-parser.jay: Removed
	useless UnboundTypeExpression.
	
	* attribute.cs: Do check obsolete attribute on generic types.

2008-11-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #425680, #400139
	* ecore.cs, expression.cs: Trying to do some almost_matched_members
	refactoring.

2008-11-11  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #435747
	* assign.cs, expression.cs: Cleanup New assignment to emit correcly
	compound value types assignment. Few micro optimizations added.

2008-11-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #442610
	* anonymous.cs (MutateConstructor): More SRE hacking.

2008-11-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #442579
	* ecore.cs: Also initialize expanded form of a method with 1 params
	parameter.

2008-11-06  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (UnaryMutator): Do early l-side check.

2008-11-05  Miguel de Icaza  <miguel@novell.com>

	* codegen.cs (InitDynamic): also setup Assembly.Name like we do in
	Init, otherwise we would crash later on when checking for friend
	assemblies. 

	* eval.cs: Do not hide errors from invalid calls to LoadAssembly.
	Otherwise we never get any meaningful information as to what
	failed. 

2008-11-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #436318
	* driver.cs, report.cs: Add -warnaserror:Wn to command line options.

2008-11-05  Miguel de Icaza  <miguel@novell.com>

	* namespace.cs: Turns out that it was a really bad idea to hide
	the errors for namespaces not found here in eval mode.    

	* eval.cs: When we process using clauses, only enter those into
	the list of valid using clauses after they have been validated.   

	The above change gives the proper semantics: it does not
	senselessly report the same errors with broken using statements by
	never storing them in the first place when they are invalid.

2008-11-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #421839
	* cs-parser.jay: Remove expression from coalesce rule to force lower
	priority than the assignment operator.

2008-11-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #437875
	* nullable.cs: Compile correctly method group operand used with null
	coalescing operator.

2008-11-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #434589
	* expression.cs (Binary): Ignore lifted conversions when at least
	one operand is of reference type.

2008-11-04  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Better syntax error report.

2008-11-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #436792
	* cs-parser.jay: Use GetLocation to access location.

2008-11-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #440774
	* cs-parser.jay: Also set current_array_type when parsing local
	variables types.

2008-11-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #440785
	* expression.cs (As): Don't resolve self modifing expression
	multiple times.

2008-11-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #439447
	* cs-tokenizer.cs: Tokenize surrogates only where allowed.

2008-11-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #437571
	* cs-parser.jay: Fixes internal error for invalid expression
	statements.

2008-10-17  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Resolve correctly ambiguous params delegate methods.

2008-10-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, anonymous.cs: Simplified GetDeclarations.

2008-10-17  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: More precise cast parsing.

2008-10-16  Martin Baulig  <martin@ximian.com>

	* anonymous.cs (AnonymousMethodStorey): Put back the
	`hoisted_locals' hashtable and use it in EmitType().

2008-10-15  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, nullable.cs, expression.cs, statement.cs,
	cs-parser.jay: Tokenizer optimizations and memory reduction, saves
	~5MB for corlib.

2008-10-14  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Add bool type to the list of valid cast tokens.

2008-10-14  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Mutate scope initializers.

2008-10-14  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Use typeless value for This constant.
	
	* ecore.cs: Access FieldInfo via GetConstructedFieldInfo.

2008-10-14  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, cs-parser.jay: Unify context sensite keyword
	tokenizer.

2008-10-13  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Add missing alias qualifier and dotted generic
	type to type cast.

2008-10-13  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, expression.cs, cs-parser.jay: Reworked parens
	parser and tokenizer. Fixes many ambiguities including #433258.

2008-10-10  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Fixed missing accessor recovery.

2008-10-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #433701
	* expression.cs: Better error message.

2008-10-10  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, expression.cs: Start reporting real parser errors.
	
	* Makefile: Disabled unused debug symbols.

	Also fixes: #320556, #321097, #321656, #321876, #351316

2008-10-09  Miguel de Icaza  <miguel@novell.com>

	* eval.cs: rename "<interactive>" to "{interactive}", to work
	around a requirement in the compiler that this be a valid
	filename, and in Windows it is not (433886).

2008-10-09  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, cs-parser.jay: Fixed more subtle parser problems

2008-10-08  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, eval.cs, anonymous.cs, statement.cs, class.cs
	cs-parser.jay: Generic type declaration and type arguments cleanup.

2008-10-05  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Allow parsing weird array creation construct.

2008-10-05  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Conflicts reduction.

2008-10-04  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Conflicts reduction.

2008-10-04  Raja R Harinath  <harinath@hurrynot.org>

	Fix #398325
	* flowanalysis.cs (MyBitvector.MakeShared): Rename from 'Shared'
	property.  Add a 'count' hint about the use of the shared vector.
	Ensure that we don't leak out dirty bits.
	(UsageVector.MergeChild): Throw away information about variables
	in child vectors.
	Based on patch and analysis by Moritz Kroll <Moritz.Kroll@gmx.de>.

2008-10-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #431746
	* iterators.cs, anonymous.cs: Re-initialize hoisted iterator
	parameters when iterator is created.

2008-10-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #431827
	* expression.cs: Fixed right based pointer arithmetic operations
	emit.

2008-10-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #353779
	* assign.cs, expression.cs: Fixed compound assignment conversions.

2008-10-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #375262
	* statement.cs: Refactor ArrayForeach to be usable with string
	indexer. Optimized single dimentional arrays foreach.

2008-10-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #431255
	* anonymous.cs, expression.cs: Removed broken optimization.

2008-10-01  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Use full type parameters of parent generic
	containers. Removed unnecessary AddParentStoreyReference call.

2008-10-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324702
	* class.cs: Use better shorter names for explicit interface member
	implementations.

	* ecore.cs, typemanager.cs: Convert only mscorlib predefined names.

2008-10-01  Marek Safar  <marek.safar@gmail.com>
	
	* expression.cs: Use new interface to check fixed expression.

2008-10-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #421101
	* expression.cs, statement.cs, ecore.cs: Use IFixedExpression
	interface to check for fixed fixed-buffers.

2008-10-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #429264
	* assign.cs, anonymous.cs, ecore.cs: More type mutators added.
	
	* delegate.cs: Removed unnecessary casts.

2008-09-30  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #352151
	* decl.cs, iterators.cs, anonymous.cs, report.cs, namespace.cs,
	class.cs: Fixed already defined explicit interface members check.

2008-09-29  Rodrigo Kumpera  <rkumpera@novell.com>

	cs-tokenizer.cs: Fix typo.

2008-09-28  Miguel de Icaza  <miguel@novell.com>

	* eval.cs (InteractiveBase): The quit command now just sets a
	flag, instead of calling Environment.Exit(), it is milder on
	embedded hosts. 

	CompiledMethod is now in Mono.CSharp, not nested inside
	the Evaluator, it was inconvenient to use.

2008-09-27  Miguel de Icaza  <miguel@novell.com>

	* eval.cs (Evaluator): Introduce Compile method, to allow compiled
	code to be invoked without having to reparse.

2008-09-27  Miguel de Icaza  <miguel@novell.com>

	* ecore.cs: The recent changes to FieldExpr broke this as well.
	Fixes LINQ queries in the interactive shell.

	* Multiple files: indentation fixing for the Mono coding
	guidelines for the switch statement.

	* eval.cs: Make the Evaluator API thread safe.

2008-09-26  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, statement.cs, class.cs, cs-parser.jay: Simplified
	constructor parsing.

2008-09-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #325326
	* statement.cs: Check possible mistaken empty statement using
	explicit blocks only.

2008-09-25  Miguel de Icaza  <miguel@novell.com>

	* eval.cs (LoadAssembly, ReferenceAssembly): Call
	RootNamespace.ComputeNamespaces to update the internal list of
	namespaces, this is no longer done for us.

	(InteractiveBase): Use the Evaluator APIs instead of calling into
	Driver directly

2008-09-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #429264
	* expression.cs: Missing mutator for access to multidimensional
	arrays.

2008-09-25  Marek Safar  <marek.safar@gmail.com>

	* class.cs, statement: Emit DebuggerHidden attribute for iterator
	entry wrapper.
	
	* driver.cs: Missing input argument check.

2008-09-25  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, eval.cs, decl.cs, anonymous.cs,
	expression.cs, statement.cs, rootcontext.cs, class.cs, 
	cs-parser.jay, driver.cs, generic-mcs.cs, enum.cs: Removed obsolete
	DefineMembers.

2008-09-24  Miguel de Icaza  <miguel@novell.com>

	* ecore.cs (FieldExpr): Only initialize eclass when we return a
	fully constructed FieldExpr, fixes the regression introduced in
	the last commit.
	
	* ecore.cs, expression.cs: Plug back the eclass initialization as
	otherwise it regresses `csharp'. 

2008-09-24  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, decl.cs, convert.cs, assign.cs, expression.cs,
	ecore.cs, attribute.cs: Moved obsolete method checks from emit
	phase to resolve phase. It resolves problems with expression trees
	and fixes bugs #323796, #325156.

2008-09-23  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs: Report better error when symbol writer is missing.

2008-09-23  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs: Set .NET symbol writer.
	
	* decl.cs: Guard against null generic arguments.
	
	* report.cs: Don't report exactly same additional details.

2008-09-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324917
	* cs-parser.jay: Add missing multidimensional non-expression type
	ranks.
	
2008-09-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #428191
	* anonymous.cs: Create an outer generic fields also for non-storey
	anonymous methods.

2008-09-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #378294
	* class.cs: Make fixed size buffers gmcs feature only.

2008-09-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355622, #324993
	* assign.cs, const.cs, class.cs: Create new EmitContext for each
	field initializer.

2008-09-19  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, expression.cs, namespace.cs, delegate.cs: Duplicate
	error reporting.

2008-09-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #416110
	* generic.cs: Struct constraint results in default ctor and
	ValueType base type constraint to be set.

2008-09-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #423791
	* generic.cs: Fixed params output type type-inference.

2008-09-19  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, expression.cs: Fixed few expression crashes.
	
2008-09-19  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Don't break on extra partial modifier.

2008-09-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #427592
	* generic.cs: Use common parameter resolve method.

2008-09-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #414758
	* expression.cs, ecore.cs: Fixed crash when accessing non-static
	property.

2008-09-18  Marek Safar  <marek.safar@gmail.com>

	* driver.cs, namespace.cs: Read types and namespaces after all
	requested assemblies are loaded, fixes issues with System.Core
	auto-reference, and #419888.

2008-09-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #417705
	* cs-parser.jay: Fixed as/is operator expression split.

2008-09-18  Marek Safar  <marek.safar@gmail.com>

	* const.cs, expression.cs, statement.cs, ecore.cs, cs-parser.jay:
	Fixed expression tree representation of empty new expression and
	new initializer expression.

2008-09-18  Miguel de Icaza  <miguel@novell.com>

	* eval.cs: Remove warning, keep reference to driver around.

	* Hide fields that do not need to be public.

2008-09-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #426385
	* expression.cs (ImplicitlyTypedArrayCreation): Use full implicit
	conversion for array elements.

2008-09-17  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, statement.cs, class.cs, cs-parser.jay: Fixed
	void parsing conflicts.

2008-09-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #425601
	* driver.cs, typemanager.cs, namespace.cs: Automatically reference
	System.Core only when there is no custom ExtensionAttribute
	implementation.

2008-09-15  Miguel de Icaza  <miguel@novell.com>

	* namespace.cs: Do not report CS0246 (name

2008-09-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #425669
	* generic.cs: Don't cache generic static anonymous method 
	containers.

2008-09-12  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, class.cs, delegate.cs: Check recursive inherited
	conflicting constraints.

2008-09-12  Raja R Harinath  <harinath@hurrynot.org>

	* cs-tokenizer.cs (consume_identifier): Allow partial methods in
	mcs too.

2008-09-12  Marek Safar  <marek.safar@gmail.com>

	* literal.cs, convert.cs, expression.cs, statement.cs: More null
	to null pointer conversion fixes.

2008-09-11  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, expression.cs: An implicitly typed local variable
	declarator cannot use an array initializer.

2008-09-11  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Reduced number of printed tokens, add sorting.

2008-09-11  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (InflatedConstraints): Don't crash when constraints
	are different.
	
	* cs-parser.jay: const_declarator is a block.

	* constant.cs: Check for not allowed NaN conversions.

2008-09-10  Miguel de Icaza  <miguel@novell.com>

	* driver.cs: Drop --shell argument, the compiler is no longer a
	REPL. 

	* eval.cs: Move most of the code that deals with evaluation into
	this file and document the public API from repl.cs

	* repl.cs: Remove from here.
	
2008-09-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #424684
	* generic.cs: Generic class constraints must come first.

2008-09-09  Miguel de Icaza  <miguel@novell.com>

	* cs-parser.jay: Improve error reporting for syntax errors in
	statements and expressions, we now report the expected tokens
	instead of reporting the useless "; expected".

	Drop the strings from the token declaration, it turns out that
	they did not do what I thought they did.  Instead they were adding
	two sets of tokens to the tables.

2008-09-09  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, generic.cs, parameter.cs, expression.cs, class.cs,
	delegate.cs: Share special type check.

2008-09-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #423981
	* expression.cs (EmitBranchable): Correctly emit inverted float conditions.

2008-09-09  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (ReducedConstantExpression): Implemented ConvertExplicitly and
	ConvertImplicitly.

2008-09-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs: #324750, #335946
	* cs-tokenizer.cs, cs-parser.jay, expression.cs: Use a custom 
	lookup rule to determine ?-based tokens.

2008-09-08  Miguel de Icaza  <miguel@novell.com>

	* repl.cs (OptionalAssign.EmitStatement): It is possible that some
	expressions (like event adding or removing) end up here, so we
	need to treat those as statements.

	Add LoadAssembly method.

2008-09-04  Miguel de Icaza  <miguel@novell.com>

	* repl.cs: Add Time method.

2008-09-05  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Fixed swaped UTF-16 surrogates parsing.

2008-09-05  Miguel de Icaza  <miguel@novell.com>

	* repl.cs: Add workaround for old compilers.

2008-09-04  Jb Evain  <jbevain@novell.com>

	* repl.cs (PrettyPrint): pretty print everything that
	implements IDictionary, as well as IEnumerables. Also,
	add a quit helper property.

2008-09-04  Marek Safar  <marek.safar@gmail.com>

	* constant.cs: Better error reporting for decimal literals.
	
	* class.cs, attribute.cs, typemanager.cs: Emit more fixed buffer
	field attributes.
	
2008-09-04  Marek Safar  <marek.safar@gmail.com>
			Miguel de Icaza  <miguel@novell.com>

	A fix for bug #422951
	* assign.cs (Assign.DoResolve): Perform the type conversions
	checks before we attempt to initialize `New' initializers. 

2008-09-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #422853
	* delegate.cs (DelegateCreation): Add special handling for
	EmptyExpression.Null instance expression which is just another
	hack for undecided member instance exression.

2008-09-04  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: Emit full expression tree for reduced
	binary expressions.

2008-09-04  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (This): Guard against multi-resolving.
	
	* ecore.cs, statement.cs (Throw): Simplified.
	
	* flowanalysis.cs: Also verify event fields.

2008-09-04  Miguel de Icaza  <miguel@novell.com>

	* assign.cs (Assign.DoResolve): Perform the type conversions
	checks before we attempt to initialize `New' initializers. 

	* repl.cs (PrettyPrint): Add Hashtable prettyprint

	* anonymous.cs (AnonymousTypeClass): On EvalMode make the class
	public. 

	* repl.cs: Update help.

2008-09-03  Miguel de Icaza  <miguel@novell.com>

	* driver.cs (ProcessDefaultConfig): Now it encapsulates all the
	handling of the default config handling, including the special
	treatment of System.Core assembly. 

	Fixes the REPL processing for LINQ.

2008-09-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #422507
	* expression.cs (UnboxCast): Add missing child expression mutator.

2008-09-03  Marek Safar  <marek.safar@gmail.com>

	* driver.cs: Don't self reference System.Core assembly.

2008-09-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #422507
	* expression.cs (StringConcat): Add missing type mutator.

2008-09-03  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (TypeInferenceContext): Follow equality rule for
	constructed type lower bound type inference.

2008-09-02  Miguel de Icaza  <miguel@novell.com>

	* getline.cs (CmdRefresh): Apply patch from Douglas S. Blank
	<dblank@cs.brynmawr.edu> which updates the cursor position on
	refresh.
	
2008-09-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #367145
	* driver.cs: Fixed import of extension methods when using -noconfig
	option.

2008-09-02  Marek Safar  <marek.safar@gmail.com>

	* iterator.cs: Don't emit GetEnumerator method twice but call a generic
	version from non-generic implementation instead.

2008-09-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #418908
	* class.cs: Use AddScopeStatement for field initializers.

2008-09-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #415385
	* ecore.cs, convert.cs: Do method group conversion for equal group types.

2008-09-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #421736
	* iterators.cs: Don't crash on unreachable iterators.

2008-09-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #421628
	* parameter.cs, attribute.cs: Clone also parameter attributes.

2008-08-30  Miguel de Icaza  <miguel@novell.com>

	* namespace.cs (LookupType): In EvalMode, try to replace
	the TypeBuilder from our cache with a Type as Reflection.Emit does
	not  like to mix code from older assemblies emitted and new
	assemblies emitted. 

	This sounds like a serious Mono bug that prevents multiple
	assemblies to be generated and consumed at the same time.

	* cs-parser.jay (push_current_class): Do not make interactive
	classes internal or private, make them public as we currently
	generate each new class in a new assembly.   

2008-08-29  Miguel de Icaza  <miguel@novell.com>

 	* decl.cs, roottypes.cs, class.cs:: Add an infrastructure to
 	remove types that are entered into the global namespace during
 	parsing so that we can remove them on failure.
 
 	* cs-parser.jay: Parsing: we now keep track of types that are
 	entered into global variables and queue those in case the parsing
 	or resolution fail.
 
 	This happens in a few situations: during partial-input, we invoke
 	the parser repeatedly for example with the string "class X", this
 	would cause X to be registed, and we need to remove this
 	registration so that another parse attempt later with say "class X {"
 	would actually work.
 
 	Additionally, if there is an error in the resolution phase, for
 	example: "class X : NonExistant {}" th
 	
	* cs-parser.jay: Be more precise with the errors being raised,
	instead of flagging all exceptions during parsing to be attributed
	to the parsing process, distinguish those from errors happening in
	the actions and hint that using -v would produce the actual
	exception. 

	* repl.cs: Do not load all compiler references on each reset,
	doing the partial reset takes care of this.
	
2008-08-28  Miguel de Icaza  <miguel@novell.com>

	* repl.cs: Add support for loading all the files from
	~/.config/csharp/*cs as startup scripts and ~/.config/csharp/*.dll
	as shell libraries.

	Introduce a micro-parser that is able to deambiguate on its input
	whether we are dealing with a compilation unit (namespace, class,
	interface, struct, delegate) declaration or a statement.   This
	allows both declarations and statements to be entered. 

	Set history size by default to 300 lines.

	Instead of distinguishing based on the parser.InteractiveResult,
	have only two cases: statements were parsed, or a compilation unit
	was.   Always pull the Using statement additions from the
	compilation unit parse.
	
	* cs-tokenizer.cs: Rename tokens to better describe their intent
	(EvalStatementParserCharacter and EvalCompilationUnitParserCharacter).
	
	* rootcontext.cs: Split EvalMode into EvalMode and StatementMode.
	EvalMode is used to trigger the lookup of global variables while
	StatementMode is used turn variable declarations into static
	fields.

	* getline.cs: Allow history size to be set.
	
2008-08-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #360755
	* ecore.cs (SimpleName): Exclude indexers from simple name resolve.

2008-08-29  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, iterators.cs, codegen.cs: Removed unused variable.
	
	* typemanager.cs, statement.cs, ecore.cs, enum.cs: Don't reconstruct enum
	member name, it is too confusing
	
	* decl.cs, class.cs: Don't report unused fields with attached attribute.
	
	* rootcontext.cs: Finally default to warning level 4.

2008-08-28  Marek Safar  <marek.safar@gmail.com>

	* class.cs (CheckBase): Ignore overloaded operators.

2008-08-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #420830
	* expression.cs, cs-parser.jay: Put back InvocationOrCast expression.

2008-08-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #420832
	* anonymous.cs, iterators.cs: Also clone hoisted this iterator variable.

2008-08-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #420386
	* nullables.cs: Fixed logic of nullable user comparison operators involving
	null values.

2008-08-28  Marek Safar  <marek.safar@gmail.com>
	
	* attribute (IsClsCompliant): Use FALSE value for pointer types.

2008-08-27  Miguel de Icaza  <miguel@novell.com>

	* repl.cs: Add support for aborting the running code with C-c. 

2008-08-27  Raja R Harinath  <harinath@hurrynot.org>

	* cs-parser.jay (CS1002): Dump 'yyToken' with Report.ExtraInformation.

2008-08-27  Miguel de Icaza  <miguel@novell.com>

	* cs-parser.jay (interactive_statement_list): A new set of rules
	for hosting statements that uses the "interactive_" prefix.   

	* repl.cs: Add support for parsing `using' as a statement or as a
	directive.  Deambiguating before passing this to the parser.

	We need to distinguish statement_expressions that occur at the
	toplevel vs those that occur embedded into expressions.

	* getline.cs: Applied patch from Stuart Carnie <stuart.carnie@gmail.com> 
	that fixes the cursor key handling, and a history bug.
	
2008-08-26  Miguel de Icaza  <miguel@novell.com>

	* Makefile: Drop BOOTSTRAP_COMPILER as that was masking the
	limitations in Console, instead the 2.0 bootstrap libraries now
	include the Console bits.

	Also, remove the use of Nullables from getline.cs

	------------
	
	Interactive support for the C# compiler.   Use gmcs --shell to
	enter a read-eval-print loop shell.

	Docs: http://www.mono-project.com/CsharpRepl
	
	* sources: include repl.cs here and getline.cs for gmcs.exe,
	everything else is getline.cs impaired.

	* Makefile: when bootstrapping pass a special flag
	BOOTSTRAP_COMPILER which we use to prevent failures in compilation
	as we use NET_2_0 define to pull 2.0 APIs from System.Console.
	This distinguishes those two cases.

	* repl.cs: Support for a read-eval-print loop.   Will be soon
	refactored into eval support and then REPL on top of it.

	* ecore.cs: If a simplename lookup fails, before erroring out,
	if we are in EvalMode to resolve the name to a declaration in the
	Eval-land.    

	This means that variable declarations that happened in previous
	classes (as repl puts every statement in a separate class) are
	made visible in this way.

	* cs-parser.jay: UnexpectedEOF, a new flag that is set if we
	triggered an error due to the end of file being reached.   This is
	used to do multi-line input, and notify the caller that the user
	needs to provide more text before a successful parse.

	Add new grammar rules after the INTERACTIVE_PARSER token is seen
	to drive the evaluation with a custom wrapper. 

	* driver.cs: Add support for --shell, and refactor some code to be
	reused from repl.cs
	
	* namespace.cs: Add support for serializing the contents of the
	namespaces and reloading them.  

	* getline.cs: A managed implementation of ReadLine under
	X11/Apache2 license terms.  Easy to embed in other applications as
	well.

	* namespace.cs: Add some functions to save and restore the
	namespace state.

	* rootcontext.cs: New public field.

	* cs-tokenizer.cs: Add support for one of the possible characters
	we introduce into the token stream.  

	This patch does not affect the regular tokenization process, the
	only performance hit would happen if there is an invalid character
	on the input string.

	* support.cs: Move isatty helper routine here.

	* codegen.cs: Small cleanup, and add a mechanism to initialize the
	code generator for in-memory assemblies.

2008-08-26  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, ecore.cs, delegate.cs, cs-parser.jay, expression.cs: A type
	parameter cannot be always used as a type.

2008-08-21  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, expression.cs: Use single ExplicitReferenceConversion routine.

2008-08-21  Marek Safar  <marek.safar@gmail.com>

	* convert.cs: Implement explicit array to IList<T> conversion.

2008-08-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #362740
	* cs-tokenizer.cs: Handle UTF-16 surrogates.

2008-08-20  Marek Safar  <marek.safar@gmail.com>
	
	* generic.cs, support.cs, typemanager.cs, lambda.cs, parameter.cs,
	pending.cs, ecore.cs, linq.cs, class.cs, decl.cs, delegate.cs,
	flowanalysis.cs, iterators.cs, cs-parser.jay, convert.cs, anonymous.cs,
	expression.cs, attribute.cs, statement.cs, doc.cs: Refactored parameters
	handling to use just one type of infrastructure and deal with generics
	more effectivelly.

2008-07-23  Martin Baulig  <martin@ximian.com>

	*** Merged this from trunk revision 108527 ***

	* statement.cs
	(ExplicitBlock.EmitSymbolInfo): Moved to `ToplevelBlock'.
	(ToplevelBlock.EmitSymbolInfo): Tell the symbol writer about the
	scope variable.

2008-08-15  Marek Safar  <marek.safar@gmail.com>
	
	* ecore.cs, linq.cs, const.cs, expression.cs, statement.cs: More robust
	error checks.

2008-08-15  Marek Safar  <marek.safar@gmail.com>
	
	* delegate.cs: Fixed compiler crash when creating delegate using partial
	method.
	
	* typemanager.cs: MulticastDelegate is not a delegate.

2008-08-14  Marek Safar  <marek.safar@gmail.com>
	
	* expression.cs, ecore.cs, anonymous.cs, class.cs: Fixed missing error
	checks.

2008-08-14  Raja R Harinath  <harinath@hurrynot.org>

	* cs-parser.jay (type): Allow 'var' in mcs too.
	(local_variable_type): Likewise.

2008-08-14  Marek Safar  <marek.safar@gmail.com>
	
	* driver.cs: Removed broken -noconfig variants.

2008-08-14  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #417078
	* expression.cs: Emit correctly left side pointer operators.

2008-08-13  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, lambda.cs: Inflate method generic arguments only.

2008-08-12  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Fixed struct layout check regression.

2008-08-12  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, enum.cs: Simplified enum parsing.
	
	* decl.cs: Check all type parameters conflicts.
	
	* expression.cs, statement.cs, attribute.cs: More expression checks.

2008-08-11  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Add type inference types restriction.
	
	* parameter.cs, class.cs, delegate.cs, iterators.cs, cs-parser.jay,
	anonymous.cs, expression.cs: Allocate less accessor parameters.

2008-08-08  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, ecore.cs: Ambiguous operators can come from different
	classes.

2008-08-08  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, delegate.cs: Fixed delegate compatibility conversion. 

2008-08-07  Marek Safar  <marek.safar@gmail.com>

	* class.cs, decl.cs, iterator.cs, ecore.cs: Refactor base type resolving.
	Also fixes #362146 and #381592.

2008-08-07  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Reduced constant cannot be used as an attribute value.
	
	* cs-parser.jay: Base expression has to be a type.
	
	* expression.cs (Conditional): Uses ReducedExpression.

2008-08-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #376826
	* parameter.cs, ecore.cs, anonymous.cs, expression.cs, statement.cs: An
	address of hoisted local variable or parameter cannot be taken.

2008-08-05  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, constant.cs, expression.cs, statement.cs: Resolve correctly 
	anonymous method inside checked/unchecked expression.

2008-08-05  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs (IsEqual): Guard against null.
	
	* ecore.cs, class.cs, convert.cs, const.cs, constant.cs, expression.cs,
	attribute.cs, enum.cs, statement.cs: Pass EmitContext to constant conversion
	routine. Fixed few misleading conversion errors.

2008-08-04  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Consider generics when checking cycles in struct layout.

2008-08-04  Raja R Harinath  <harinath@hurrynot.org>

	* cs-tokenizer.cs (get_cmd_arg): Simplify.  Don't be too pedantic.

2008-08-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #414165
	* anonymous.cs: Use same anonymous implementation method for all anonymous
	method emits.

2008-08-04  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, anonymous.cs, statement.cs: Emit inherited anonymous method
	constraints.

2008-08-04  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Typeof argument has to be a type expression.
	
	* namespace.cs: Check alias and namespace definitions collisions.
	
	* class.cs, pending.cs: Moved explicit interface accessor implementation
	check.
	
	* delegate.cs, expression.cs: Verify special name invocations.
	
2008-08-01  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Don't choke on empty generic type arguments.
	
	* cs-tokenizer.cs: Handle escaped preprocessor directives.
	
	* expression.cs, ecore.cs: Minor expressions bugs.

2008-08-01  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Removed duplicate interface declaration (fixes 2 conflicts)
	and added more error handling.
	
	* class.cs, iterators.cs, anonymous.cs: Removed useless interface parameter.
	
	*  modifiers.cs, enum.cs: Fixed.

2008-07-31  Jb Evain  <jbevain@novell.com>

	* driver.cs: remove -pkg ability of smcs.

2008-07-30  Marek Safar  <marek.safar@gmail.com>

	* statement.cs (Switch): Correctly set empty default target for single
	blocks.

2008-07-30  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, assign.cs, driver.cs, expression.cs, statement.cs: Rewrote
	string switch statement implementation to use string dictionary which
	significantly (2-8x) improves performance of generated code.

2008-07-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #412880 by Atsushi Enomoto <atsushi@ximian.com>
	* modifiers.cs (GetDescription): Fixed FamANDAssem case.
	
2008-07-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #412595
	* typemanager.cs, convert.cs, expression.cs: Some types are never
	convertible to each other.

2008-07-29  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs (CreateNullConstant): An error messages update.

2008-07-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #412595
	* cfold.cs: Don't cast undefined bool constant.

2008-07-29  Martin Baulig  <martin@ximian.com>

	* symbolwriter.cs
	(SymbolWriter.Reset): New public static method.

	* driver.cs
	(CompilerCallableEntryPoint.Reset): Call SymbolWriter.Reset().

2008-07-28  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs (IsLambdaOpenParens): Optimized using more stop tokens.
	
	* expression.cs (ElementAccess): Exact size allocation.

2008-07-26  Marek Safar  <marek.safar@gmail.com>

	* driver.cs: Replaced outdated UnixParseOption with CSCParseOption.

2008-07-25  Marek Safar  <marek.safar@gmail.com>

	* flowanalysis.cs (StructInfo): Fixed detection of dynamic types.
	
	* class.cs: Removed $PRIVATE$ field hack which caused problems during
	flow analysis.

2008-07-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #412217
	* assign.cs: Mutate also assignment type.

2008-07-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #323644
	* typemanager.cs (IsValidProperty): Verify DefaultMemberName when checking
	indexers.

2008-07-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #412134
	* expression.cs (ResolveOperatorEnum): Do implicit conversion of
	non-enumerable operands when overloading equality or bitwise operators.

2008-07-25  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Cache closed generic anonymous method delegates.

2008-07-24  Marek Safar  <marek.safar@gmail.com>

	* lambda.cs, linq.cs, class.cs, iterators.cs, cs-parser.jay, assign.cs, 
	anonymous.cs, statement.cs: Always emit anonymous method as static method
	when is instance free. Use nesting for nested anynomous methods blocks.
	
2008-07-23  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (MutateGenericMethod): Added extra code path for imported
	types.

2008-07-23  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Removed MakeSimpleCall.

2008-07-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #323012
	* class.cs, pending.cs: Emit proxy for indexers when they differ in name.
	Base method implementing interface has to be public.

2008-07-23  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Don't break on missing argument.

2008-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #320993
	* report.cs, parameter.cs, class.cs, decl.cs, delegate.cs, attribute.cs,
	  enum.cs, codegen.cs: Report CLS compliance errors as warnings.

2008-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #320748
	* convert.cs: Implicit user operators cannot convert to interfaces

2008-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #312686
	* driver.cs: Ignore empty assembly references.

2008-07-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #387040
	* ecore.cs: Skip constrains check for an explicit implementation.

2008-07-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #409045
	* cs-tokenizer.cs, rootcontext.cs, class.cs, location.cs, delegate.cs,
	  cs-parser.jay, driver.cs, expression.cs, attribute.cs: Conditional
	  identifiers are file specific unless passed as input arguments.

2008-07-21  Marek Safar  <marek.safar@gmail.com>

	 * typemanager.cs, parameter.cs, class.cs, attribute.cs: Use an attribute
	 to emit UnmanagedMarshal data under 2.0 profile.

2008-07-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #410369
	* parameter.cs: Clone correctly ParamsParameter.

2008-07-21  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Argument): Always report type for type based expressions
	errors.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #410666
	* anonymous.cs: Correctly initialize generic storey reference.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	* convert.cs: Don't box same type arguments.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, linq.cs, delegate.cs, constant.cs, nullable.cs, expression.cs:
	Finished missing generic type mutators.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	* iterators.cs, statement.cs: Finished statements CloneTo.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: ExpressionTreeProxy is of Value type expression.
	
	* expression.cs: Emit optimized default value expressions in expression tree
	array initializer.

2008-07-18  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, cs-parser.jay, statement.cs: Error reporting fixes.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #367536
	* cs-parser.jay: Check static constructor of generic types for an access
	modifier.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #353800
	* lambda.cs: Emit ret for contextual statements.
	
	* codegen.cs: Keep both resolved and unreachable flags, otherwise we end
	up emitting redundant ret for all anonymous methods with return.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #365188
	* ecore.cs, anonymous.cs, expression.cs, codegen.cs, statement.cs: Don't
	create anonymous method storey in unreachable block.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, cs-tokenizer.cs, parameter.cs, namespace.cs,
	class.cs, delegate.cs, flowanalysis.cs, iterators.cs, anonymous.cs,
	driver.cs, nullable.cs, expression.cs, attribute.cs, codegen.cs,
	statement.cs: Fixed relevant defects found by Gendarme.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #325291
	* modifiers.cs, class.cs, cs-parser.jay, anonymous.cs, codegen.cs, 
	statement.cs: Replaced IAnonymousHost with top level block flag.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Clean up unused open_parens.

2008-07-17  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Custom error message for a range variable assignment.

2008-07-16  Marek Safar  <marek.safar@gmail.com>

	* constant.cs, typemanager.cs: Emit empty string ("") as string.Empty field
	load.

2008-07-16  Marek Safar  <marek.safar@gmail.com>

	* literal.cs: Null literal is of object type.

2008-07-16  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs (LiftedBinaryOperator): Always lift unwrapped nullable
	expression of nullable equality comparison.

2008-07-15  Marek Safar  <marek.safar@gmail.com>

	* expression.cs(PointerArithmetic): Removed redundant assignment.

2008-07-15  Marek Safar  <marek.safar@gmail.com>

	* decl.cs (GetSignatureForError): Report full namespace name for containers.

2008-07-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #408361
	* anonymous.cs (MutateGenericMethod): Store generic type arguments before
	they are replaced by GetMethod.

2008-07-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #408721 by jeremie.laval@gmail.com
	* expression.cs (Indirection): Implemented CloneTo.

2008-07-14  Marek Safar  <marek.safar@gmail.com>

	* statement.cs (AssignableSlots): Temporary disabled variable initialization
	assert check.

2008-07-14  Marek Safar  <marek.safar@gmail.com>

	* report.cs (EnableReporting): Don't reinitialize 0-based values.

2008-07-11  Marek Safar  <marek.safar@gmail.com>

	* linq.cs: Reset tranparent parameter counter in probing mode.

2008-07-11  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Mutate anonymous method type.

2008-07-11  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, anonymous.cs: Mutate field expressions.

2008-07-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #369670
	* linq.cs, statement.cs: Use explicit block for query expressions variables.

2008-07-10  Marek Safar  <marek.safar@gmail.com>

	* report.cs, ecore.cs: Flush recorder only when silent mode is off.

2008-07-10  Raja R Harinath  <harinath@hurrynot.org>

	Fix bug #314902
	* cs-tokenizer.cs (is_punct): If a generic lookahead is looking
	only one '>', and finds a '>>', abort the generic lookahead.

2008-07-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #319902
	* cs-tokenizer.cs: Always look-ahed for `>='  when tokenizing `>'.

2008-07-10  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #406371
	* statement.cs: Moved EmitSymbolInfo to Block.

2008-07-09  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Report better error for extension method overload failures.

2008-07-09  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Is): No need to box reference values.

2008-07-09  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Use event resolve context when initializing CreateEmitContext.

2008-07-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #394436
	* anonymous.cs, class.cs, expression.cs, lambda.cs: Emit correctly extension
	method used inside expression trees. Added more LINQ to expression tree
	conversions.

2008-07-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #378189, #370577
	* lambda.cs, ecore.cs: Implemented 3.0 enhancement to better conversion
	from expression.

2008-07-08  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, class.cs, decl.cs: Emit CompilerGenerated attribute
	hierarchically.

2008-07-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #406702
	* anonymous.cs: Always park anonymous method in the nearest parent storey.

2008-07-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #406648
	* cs-parser.jay: Report nullable use in mcs for some cases.

2008-07-07  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Improved argument mismatch error messages.

2008-07-07  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Don't cache generic delegates when reference MVAR argument.

2008-07-07  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (TypeOf): Mutate type argument.

2008-07-04  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Report missing partial modifier for correct type.

2008-07-04  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs (VariableReference): Variable property is 
	protected.

2008-07-04  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, convert.cs: Made OpcodeCast more memory efficient.
	
2008-07-04  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, class.cs, lambda.cs, iterator.cs: Cache static anonymous
	method delegates.

2008-07-04  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, class.cs, expression.cs, iterator.cs, statement.cs: Reduce
	anonymous method storey to an instance method when only "this" is hoisted.

2008-07-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #321615
	* expression.cs: Pointer comparisons use unsigned operator.

2008-07-03  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Fixed native pointer conversions. Also fixes #321615.

2008-07-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #404905
	* class.cs: Always initialize local unsafe variables.

2008-06-30  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #396987
	* expression.cs (NewInitialize): Clear local temporary variable for next run

2008-06-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #401020
	* ecore.cs: Both types and modifiers have to match for ref and out arguments

2008-06-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #398319
	* cs-parser.jay: Implemented undocumented base access expression inside
	anonymous types.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #404227
	* cs-parser.jay: Parse namespace declaration using qualified identifier.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #404227
	* convert.cs: Fixed explicit array to interface cast.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #403894
	* delegate.cs: Mutate DelegateInvocation type.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #379348
	* delegate.cs: Box a load of generic parameters.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Add an array creation arguments mutate.

2008-06-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #386068
	* anonymous.cs, expression.cs: Emit correctly hoisted expression tree
	parameter.

2008-06-25  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs: Fixed broken TypeCast clone, implemented few more
	CloneTo.

2008-06-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #403518
	* delegate.cs: Type correctly anonymous method new invocation.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #394826
	* anonymous.cs: Fully qualify members when resolving anonymous type internal
	calls.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #394826
	* anonymous.cs, iterators.cs: Construct generic storey only when is really
	needed.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Clone indexer parameters for localized capturing.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #402379
	* expression.cs: Don't crash when an object initializer resolve fails.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #402888
	* expression.cs: Mutate conditional expression.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #401012
	* class.cs: Keep StructLayout in shared container.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #400438
	* decl.cs, class.cs: Only properties can be automatically implemented.

2008-06-24  Marek Safar  <marek.safar@gmail.com>

	* statement.cs (ChangeToIterator): Copy also labels.

2008-06-23  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Pass type argument details to parent extension method.

2008-06-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #375966
	* delegate.cs: Fixed IsTypeCovariant generic type conversions.

2008-06-23  Raja R Harinath  <harinath@hurrynot.org>

	* Makefile (bootstrap-libs): Pass NO_DIR_CHECK to sub-make.

2008-06-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #394347
	* anonymous.cs: Cache compatible delegates as compatibility check produces
	a new method every time.

2008-06-20  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Propagate storey reference for single references.

2008-06-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #387615
	* assign.cs, expression.cs: Correctly clone compound assignment.

2008-06-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #359611, #359604
	* anonymous.cs: Mutate all types of hoisted parameters.

2008-06-19  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, lambda.cs, parameter.cs, ecore.cs, linq.cs, class.cs
	delegate.cs, iterators.cs, cs-parser.jay, assign.cs, anonymous.cs, driver.cs
	expression.cs, codegen.cs, statement.cs
	
	Fixes bugs: #318652, #323223, #234779, #325069, #325476, #332532, #334465,
	#345907, #349190, #353276, #355256, #359617, #378542, #384584, #396530
	
	** Anonymous methods, lambda expressions rewrite **
	
	Anonymous expressions are now resolved when an explicit block is resolved 
	and they don't require any registration procedure anymore. Further,
	anonymous methods are defined when explicit block is emitted which allows
	better control of whole process and opens possibilities for more
	optimizations as well as alternative to reverse whole process.
	
	A concept of `MutateHoistedGenericType' was introduced to keep the resolve
	process consistent and to correctly emit hoisted generic methods when they
	have at least 1 hoisted variable.
	
2008-06-17  Martin Baulig  <martin@ximian.com>

	* class.cs: Also emit the `[DebuggerHidden]' attribute on the main
	iterator method.
	(AbstractPropertyEventMethod.IsDebuggerHidden): New protected
	virtual property; check it in Emit().
	(PropertyMethod.IsDebuggerHidden): Override, check whether we're
	an iterator.
	(MethodOrOperator.ResolveMethods): Set `DEBUGGER_HIDDEN' if we're
	an iterator.
	(Indexer.Define): Likewise.

2008-06-17  Marek Safar  <marek.safar@gmail.com>

	* convert.cs: Don't use IsInterface on type arguments.
	
	* delegate.cs: DelegateInvocation uses MethodInfo.
	
	* parameter.cs: Removed IsTypeParameter.
	
	* generic-mcs.cs: More missing stuff.

2008-06-16  Martin Baulig  <martin@ximian.com>

	* modifiers.cs
	(Modifiers.DEBUGGER_HIDDEN): New public const.

	* typemanager.cs
	(TypeManager.GetDebuggerHiddenAttribute): New public static method.

	* class.cs
	(MethodOrOperator.Emit): Check `Modifiers.DEBUGGER_HIDDEN'.
	(AbstractPropertyEventMethod): Likewise.
	(Constructor.Emit): Likewise.
	(SourceMethod.SetCompilerGenerated): Removed.

	* iterator.cs: Set `Modifiers.DEBUGGER_HIDDEN' everywhere except
	on MoveNext().

	* anonymous.cs
	(RootScopeInfo.DoDefineMembers): Set `Modifiers.DEBUGGER_HIDDEN'
	if we're an `IteratorHost'.
	(AnonymousMethodMethod..ctor): Don't set
	`Modifiers.COMPILER_GENERATED'; csc only sets this on the class,
	not on the method.

2008-06-16  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Clean-up foreach statements.

2008-06-12  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Stop using public method which should not exist
	(MethodBuilder.SetGenericMethodSignature).

2008-06-11  Martin Baulig  <martin@ximian.com>

	* location.cs
	(Location.LookupFile): Add `CompilationUnit' argument; when given
	a relative file name, make it relative to the directory the .cs
	file is located in instead of using the current directory.

2008-06-11  Martin Baulig  <martin@ximian.com>

	* class.cs
	(IMethodData.EmitExtraSymbolInfo): Added `SourceMethod' argument.
	(MethodOrOperator.EmitExtraSymbolInfo): Likewise.
	(SourceMethod.SetRealMethodName): Moved here from the symbol writer.
	(SourceMethod.SetCompilerGenerated): Likewise.

2008-06-11  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs, driver: Only write symbol file when it's asked for.

2008-06-11  Marek Safar  <marek.safar@gmail.com>

	* codegen.cs: Don't use assembly writer error handling for symbol writer.

2008-06-10  Martin Baulig  <martin@ximian.com>

	* symbolwriter.cs: Reflect latest MarkSequencePoint() API changes.

2008-06-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #316290
	* expression.cs: Include decimal operators in predefined table.
	
	* parameters.cs: More readonlyness.

2008-06-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #397213
	* cs-parser.jay: One more missing current_local_parameters reset.

2008-06-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #396633
	* class.cs: Host backing field in partial container.

2008-06-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #397068
	* expression.cs: Check both operand types when predefined operator is used.

2008-06-05  Martin Baulig  <martin@ximian.com>

	Merged the `debugger-kahalo' branch.

	* class.cs
	(MethodData.Emit): Call SymbolWriter.SetCompilerGenerated() if
	we're an iterator method.
	(SourceMethod): Reflect latest symbol writer changes;
	SymbolWriter.OpenMethod() now takes a `ICompileUnit' argument and
	now `start_row' and `end_row'.
	(Constructor.Emit): Fix the logic whether to emit symbol information.

	* iterator.cs: Call SymbolWriter.SetCompilerGenerated() on all the
	generated methods.

	* location.cs
	(CompilationUnit): New public class; derives from `SourceFile'.
	(SourceFileEntry.DefineSymbolInfo): New public method.
	(SourceFileEntry.SetChecksum): New public method.
	(Location): Encode hidden line numbers by using `column == 255';
	the .ctor now accepts `column == -1' to mark a hidden line number.
	(Location.Hidden): New public property.
	(Location.CheckPoint): Add `CompilationUnit'.
	(Location.SourceFiles): Change return type to `CompilationUnit[]'.
	(Location.Push): Add `CompilationUnit compile_unit' argument.
	(Location.CompilationUnit): New public property.

	* statement.cs
	(ToplevelBlock.Emit): Add `ec.Mark (EndLocation)'.

	* cs-parser.jay: `SourceFile' -> `CompilationUnit'.

	* driver.cs: `SourceFile' -> `CompilationUnit'.

	* cs-tokenizer.cs: `SourceFile' -> `CompilationUnit'.

	* namespace.cs: `SourceFile' -> `CompilationUnit'.

	* cs-tokenizer.cs: Add support for `#pragma checksum' and
	`#line hidden'.

	* symbolwriter.cs
	(SymbolWriter.MarkSequencePoint): Take a `Location' and use the
	new symbol writer API to also pass the file.

2008-06-05  Marek Safar  <marek.safar@gmail.com>

	* statement.cs: Emit catch variable assignment using variable expression.
	
2008-06-05  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, statement.cs: Make TemporaryVariable compatible
	with other variable types.

2008-06-04  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, statement.cs, typemanager.cs: Removed custom
	GetLength method emit, it breaks resolve rules.
	
2008-06-02  Atsushi Enomoto  <atsushi@ximian.com>
            Marek Safar  <marek.safar@gmail.com>
			
	A fix for bug #395542
	* cs-parser.jay: The trailing comma is allowed in anonymous type member
	declaration.
	
2008-06-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #395287
	* class.cs, modifiers.cs: Automatic properties method base modifiers checks.

2008-05-31  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #395845
	* class.cs, nullable.cs: User unary operator is allowed to have nullable and
	non-nullable parameter type.
	
2008-05-31  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Handle contructor initializer as a statement in top-level block.

2008-05-30  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs: Don't mix old and new corlib types when emitting corlib
	security attributes.

2008-05-24  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs: Small IVariable refactoring.

2008-05-22  Marek Safar  <marek.safar@gmail.com>

	* assign.cs (LocalTemporary): Implemented CreateExpressionTree.

2008-05-21  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay: Removed redundant catch type check.

2008-05-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #390372
	* nullable.cs: Set correct return type.

2008-05-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #391062
	* typemanager.cs: Fixed crash when comparing null types.

2008-05-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #391871
	* cs-parser.jay: Better error handling for invalid catch type.

2008-05-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #392155
	* cs-tokenizer.cs: Fixed casting of byte and decimal expression.

2008-05-15  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #390666
	* ecore.cs (BetterExpressionConversion): Unwrap each Expression<T>
	expressions.

2008-05-15  Marek Safar  <marek.safar@gmail.com>

	* class.cs, expression.cs, statement.cs: Removed a hack, setting block flag
	in getter.

2008-05-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #389625
	* delegate.cs, generic.cs: Some progress on method group return type
	inference.

2008-05-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #378419
	* namespace.cs: Inspect also parent namespaces not only namespace entries.

2008-05-12  Marek Safar  <marek.safar@gmail.com>

	* class.cs (Constructor): Added IsCompilerGenerated.

2008-05-12  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Enum binary operators can accept non-enum operand only when
	is implicitly convertible to underlying type.

2008-05-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #389272
	* support.cs: Workaround System.InvalidOperationException for enums.

2008-05-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #389073
	* convert.cs: More undocumented explicit IntPtr/UIntPtr conversions.

2008-05-10  Marek Safar  <marek.safar@gmail.com>

	* driver.cs: Split Parse.
	
	* location.cs (LookupFile): Uses string.Empty.

2008-05-07  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, parameter.cs: Small ParameterReference clean up.

2008-05-07  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, codegen.cs, convert.cs, ecore.cs: Removed uber ugly TempEc
	hack. Fixes #387502.

2008-05-06  Martin Baulig  <martin@ximian.com>

	* class.cs (Constructor.Emit): Fix the logic whether to emit
	symbol information.

2008-05-06  Raja R Harinath  <harinath@hurrynot.org>

	Fix #385503
	* iterators.cs (Iterator.CurrentBlock.DoEmit): Don't emit
	InvalidOperationException when the iterator is before the start or
	after the end.

2008-05-06  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs (NullCoalescingOperator): Result is underlying type of left,
	when left is nullable type.

2008-05-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #386628
	* expression.cs (LocalVariableReference): Continue in resolving when
	variable is not assigned.

2008-05-05  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, statement.cs (Unwrap): Store non-variable expression in all
	nullable operations.

2008-05-04  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, statement.cs (Unwrap): Don't duplicate variable expressions,
	it saves many redundant temporary variables for nullable operations.

2008-05-03  Marek Safar  <marek.safar@gmail.com>

	* assign.cs: EventAddOrRemove is a statement and cannot have a type.
	
	* cfold.cs, constant.cs, expression.cs: Share Error_OperatorCannotBeApplied
	method.
	
	* nullable.cs: Constant coalescing operator optimizations.

2008-05-03  Marek Safar  <marek.safar@gmail.com>

	* constant.cs: Use unsigned conversion for values which are unsigned only.

2008-05-03  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, literal.cs, nullabel.cs, typemanager.cs: Implemeted null 
	coalescing operator as it should be.

2008-05-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #371016
	* expression.cs: All predefined delegate operators require implicit method
	group conversion.
	
2008-05-02  Marek Safar  <marek.safar@gmail.com>

	* constant.cs: Emit long constant as uint when fits the range.
	
	* convert.cs, expression.cs: Fixed few unsafe conversions.

2008-05-02  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, literal.cs: Don't wrap implicit reference conversion to object

2008-05-02  Raja R Harinath  <harinath@hurrynot.org>

	Fix #385758
	* convert.cs (ImplicitNumericConversion): Don't modify the type of
	'expr'.
	* ecore.cs (EmptyCast.Create): Flatten nested EmptyCasts.

2008-05-01  Marek Safar  <marek.safar@gmail.com>

	* constant.cs, literal.cs: IsLiteral property for error reporting.
	
	* ecore.cs, expression.cs: Implemented Property expression.

2008-05-01  Marek Safar  <marek.safar@gmail.com>

	* class.cs, modifiers.cs, flowanalysis.cs: New BACKING_FIELD flag.
	
	* nullable.cs: Implemented nullable coalescing null operator.

	* ecore.cs, expression.cs: Expression trees work.

2008-05-01  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: CreateExpressionTree is finally abstract.

	* expression.cs, linq.cs: Updated.

2008-05-01  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: Block base access expression inside expression
	tree.

2008-05-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #385058
	* expression.cs: User-defined operator implementations always take
	precedence over predefined operator implementations.

2008-04-30  Marek Safar  <marek.safar@gmail.com>

	* assign.cs, anonymous.cs, lambda.cs, nullable.cs, ecore.cs, linq.cs,
	class.cs, iterators.cs, expression.cs, attribute.cs: Filled a few more
	expression tree conversions.
	
2008-04-30  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, ecore.cs, class.cs, expression.cs, doc.cs: Merged all
	operators method details to Operator class.

2008-04-30  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Pass unsafe flags to anonymous container.
	
	* ecore.cs, expression.cs, statement.cs: Block unsafe pointer operations
	inside expression tree.

2008-04-29  Martin Baulig  <martin@ximian.com>

	* cs-tokenizer.cs (Tokenizer.Position): Added `line'.
	(Tokenizer.PopPosition): Also restore the `line'.

2008-04-29  Marek Safar  <marek.safar@gmail.com>

	* delegate.cs: Implemented Invoke expression.

2008-04-29  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Fixed equality reference comparison regression.

2008-04-29  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Clean up EmptyCast hack.
	
	* expression.cs, nullable.cs: Implemented enum binary and unary operations
	using correct conversion rules. Also fixes #383993.

2008-04-28  Martin Baulig  <martin@ximian.com>

	* class.cs (Constructor.Emit): Don't emit debugging information
	for generated default .ctor's.

2008-04-28  Marek Safar  <marek.safar@gmail.com>

	* convert.cs: Empty-cast ushort to int conversion.

2008-04-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #384191
	* ecore.cs, expression.cs: Fixed expression cloning.

2008-04-28  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, delegate.cs, assign.cs: Few tweaks for recent changes.

2008-04-28  Raja R Harinath  <harinath@hurrynot.org>

	Fix #381559, test-638.cs, test-639.cs
	* assign.cs (CompoundAssign.Helper): New wrapper.
	(CompoundAssign.DoResolve): Use it to wrap the nested 'target'
	access.
	* ecore.cs (MethodGroupExpr.VerifyArgumentsCompat) <params arguments>:
	Pass unconverted expressions to the params array creation expression.
	(FieldExpr.EmitAssign): Don't special-case StringConcat.
	(PropertyExpr.EmitAssign): Likewise.
	* expression.cs (ArrayCreation.ResolveArrayElement): Keep track of the
	element if it is of kind CompoundAssign.Helper.
	(ArrayCreation.Emit): If we saw a CompoundAssign.Helper, emit it
	first before anything else.
	(ArrayAccess.EmitAssign): Don't special-case StringConcat.
	(ArrayAccess.LoadArrayAndArguments): Simplify.

2008-04-27  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Fixed cloning of typeof(void).

2008-04-27  Raja R Harinath  <harinath@hurrynot.org>

	* assign.cs (Assign.DoResolve): Remove support for EventExprs.
	(Assign.Emit): Likewise.  Move it to ...
	(CompoundAssign.DoResolve): ... here and ...
	(CompoundAssign.Emit): ... here.
	(EventAddOrRemove): New helper to handle += and -= on events, and
	avoid the use of BinaryDelegates.
	* ecore.cs (EventExpr.DoResolveLValue): Emit CS0070 unconditionally.
	(EventExpr.EmitAddOrRemove): Improve.
	* delegate.cs (DelegateInvocation.DoResolve): Simplify slightly.

	* cs-parser.jay (type) <namespace_or_type_name variant>: Don't
	create VarExprs for 'foo.bar.var'.
	* ecore.cs (VarExpr.InferType): Rename from DoResolveLValue, which
	is a highly inappropriate name for its functionality.

2008-04-26  Raja R Harinath  <harinath@hurrynot.org>

	Simplify handling of multiple assignments
	* assign.cs (Assign): Clear out all 'embedded assign' gunk.  Make
	inheritable-only.
	(SimpleAssign): New.  Class to be used for normal assignments.
	* anonymous.cs, class.cs, cs-parser.jay: Update to changes.
	* expression.cs, parameter.cs, statement.cs: Likewise.

2008-04-25  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, nullable.cs: Implemeted enum binary add operation
	for incompatible underlying types, more to come, uff.

2008-04-26  Raja R Harinath  <harinath@hurrynot.org>

	Fix gtest-388.cs
	* expression.cs (VariableReference.EmitAssign) <source is NewInstance>:
	Handle 'leave_copy'.

2008-04-25  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, nullable.cs: Implemented UnaryPlus expression.

2008-04-24  Raja R Harinath  <harinath@hurrynot.org>

	Fix test-636.cs.  Sprinkle a few more 'EmitSideEffect's around
	* expression.cs (Unary.TryReduceConstant): Unwrap SideEffectConstant.
	* statement.cs (While, Do, For): Allow test to have side effects.
	(For.DoEmit): Always emit InitStatement.

	Fix test-635.cs
	* expression.cs (Binary.DoResolve) <BitwiseAnd with zero constant>:
	Always create SideEffectConstant.
	(Binary.EnumLiftUp): Don't assume that the enumeration constant is
	of type EnumConstant.

	* expression.cs (Binary.EmitBranchable) <Equality with constant>:
	Handle 'right' being SideEffectConstant of type 'bool'.

	* expression.cs (Binary.EmitBranchable) <Equality with constant>:
	Use left.EmitBranchable instead of open coding it, so as to
	improve optimization opportunities.

	* constant.cs (SideEffectConstant.EmitSideEffect): Simplify slightly.

	* ecore.cs (Expression.EmitBranchable): Document some non-obvious
	assumptions.
	(Expression.EmitSideEffect): Document.

2008-04-23  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Implemented NewArrayBounds, TypeIs, and TypeAs expressions.

2008-04-23  Marek Safar  <marek.safar@gmail.com>

	* constant.cs, statement.cs: Use EmitSideEffect for constant if statement.

2008-04-23  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, delegate.cs: Implemeted delegate instantiation
	conversion to expression tree.

2008-04-23  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Removed unused expression.

2008-04-22  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Implemented NegateChecked and New expressions.

2008-04-22  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, nullable.cs, expression.cs: Implemented Negate expression.

2008-04-22  Raja R Harinath  <harinath@hurrynot.org>

	Fix #351102
	* anonymous.cs (AnonymousMethodExpression.DoResolve): Mark as
	needing final 'ret' instruction.

2008-04-22  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Disabled lifted binary conversion on ISO-1 profiles.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Emit ldnull and not null expression as an instance argument
	 of static method expression calls.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #378200
	* expression.cs: Fixed crash when creating parameterless expression tree
	method call.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #375297
	* anonymous.cs: Fixed crash when inferring from null argument anonymous
	method.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #377596
	* decl.cs, class.cs: Emit delegate type argument attributes.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #365314
	* generic.cs, ecore.cs: Type parameter declaration cannot be of generic type
	
2008-04-21  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, expression.cs: ComposedCast can work with type expressions
	only.

2008-04-21  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (TypeParameter): Removed redundant location.

2008-04-19  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, parameter.cs, namespace.cs, ecore.cs, class.cs, decl.cs,
	delegate.cs, iterators.cs, cs-parser.jay, const.cs, enum.cs: Use
	FullNamedExpression in all declaration type expression, statements will come
	later.

2008-04-18  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, namespace.cs, ecore.cs, class.cs, decl.cs, generic-mcs.cs,
	nullable.cs, expression.cs, enum.cs, doc.cs: Cleaning up type expressions.

2008-04-18  Marek Safar  <marek.safar@gmail.com>

	* parameter.cs, delegate.cs, cs-parser.jay, expression.cs: Removed unused
	code.

2008-04-17  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, class.cs, generic.cs: Verify partial parts type parameters and
	constraints.

2008-04-17  Marek Safar  <marek.safar@gmail.com>

	* decl.cs, class.cs, cs-parser.jay, ecore.cs, expression.cs: Unify all type
	name expressions.
	Also fixes #340463.

2008-04-17  Raja R Harinath  <harinath@hurrynot.org>

	Hook up 'EmitSideEffect'
	* constant.cs (Constant.EmitSideEffect): New.
	(SideEffectConstant.Emit): Simplify.  Use EmitSideEffect.
	(SideEffectConstant.EmitSideEffect): New.
	* ecore.cs (BoxedCast.EmitBranchable): Remove.  We can't use an
	unconditional branch in EmitBranchable.
	(FieldExpr.EmitBranchable): New.
	* expression.cs (Unary.EmitSideEffect): New.
	(Binary.EmitSideEffect): New.
	(VariableReference.EmitSideEffect): New.  Do nothing.

2008-04-16  Raja R Harinath  <harinath@hurrynot.org>

	Introduce 'EmitSideEffect'
	* ecore.cs (Expression.EmitSideEffect): New.
	(TypeCast): Rename from EmptyCast.
	(EmptyCast): New.
	(EmptyCast.EmitBranchable, EmptyCast.EmitSideEffect): Implement.
	(BoxedCast.EmitBranchable, BoxedCast.EmitSideEffect): Implement.
	* convert.cs, nullable.cs: Update to changes.

2008-04-16  Marek Safar  <marek.safar@gmail.com>

	* class.cs, cs-parser.jay: Early check for base types expression.

2008-04-16  Marek Safar  <marek.safar@gmail.com>

	* decl.cs (MemberName): Declare PrettyName as obsolete.

2008-04-16  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs: Use MemberName comparison.

2008-04-16  Raja R Harinath  <harinath@hurrynot.org>

	Fix build break
	* decl.cs (MemberName.PrettyName): New.  Replaces the misnamed
	FullName.
	(MemberName.MethodName, MemberName.GetSignatureForError): Improve.
	(MemberName.FullyQualifiedName): New.  Provides the functionality
	that users assume FullName would have.
	* ecore.cs, namespace.cs: Update to changes.

	* statement.cs (Using.assign): Make into ExpressionStatement.
	(Using.EmitPreTryBody): Simplify.

2008-04-16  Marek Safar  <marek.safar@gmail.com>

	* report.cs: ColorFormat is protected.
	
	* rootcontext.cs: Unused fields clean-up.
	
	* namespace.cs: Made UsingEntry name private.

2008-04-16  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, location.cs: Removed unused field.

2008-04-16  Jan Oravec <jan.oravec@6com.sk>
	    Raja R Harinath  <harinath@hurrynot.org>

	Fix #379822
	* constant.cs (SideEffectConstant.value): Rename from 'left'.
	(SideEffectConstant.side_effect): Rename from 'right'.
	(SideEffectConstant..ctor): Normalize 'side_effect'.
	(SideEffectConstant.Emit): Emit 'value', not 'side_effect' as the
	value of this constant.
	* cfold.cs: Update to changes.

2008-04-15  Marek Safar  <marek.safar@gmail.com>

	* cs-paser.jay: Removed unused variable.
	
	* driver.cs: Made Compile instance method.

2008-04-15  Raja R Harinath  <harinath@hurrynot.org>

	* flowanalysis.cs (FlowBranching.MergeChild): Simplify.

2008-04-15  Marek Safar  <marek.safar@gmail.com>

	* cs-paser.jay, namespace.cs: Simplified handling of namespace imports. 

2008-04-13  Jb Evain  <jbevain@novell.com>

	* namespace.cs: update the System.Core fullname for 2.1
	* driver.cs: update the list of required assemblies for 2.1.
	Merged from the Moonlight 2 branch.

2008-04-11  Marek Safar  <marek.safar@gmail.com>

	* assign.cs, ecore.cs, expression.cs, nullable.cs: More work on nullable
	types and user defined operators. User operators arguments has to be checked
	for null value before invocation, which also means no operator is called
	when any argument is not convertible to unwrapped nullable type.
	
2008-04-09  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, ecore.cs, expression.cs, nullable.cs: Initial refactoring
	of Unary expressions to follow operator overloading rules precisely.
	Also fixes #321794, #323794
	
2008-04-08  Marek Safar  <marek.safar@gmail.com>

	* cs-parser.jay, expression.cs: Don't wrap Indirection expression in Unary
	expression.
	
2008-04-08  Marek Safar  <marek.safar@gmail.com>

	* expression.cs, ecore.cs: Implemented MemberInit expression.
	
2008-04-08  Raja R Harinath  <harinath@hurrynot.org>

	Fix mono/tests/exception4.cs
	* statement.cs (ExceptionStatement, TryCatch): Revert to using
	ec.NeedReturnLabel () rather emitting a 'nop'.

	* statement.cs (ExceptionStatement.SomeCodeFollows): A hook for a
	simple heuristic.
	(TryCatch.SomeCodeFollows): Likewise.
	* flowanalysis.cs (FlowBranchingException): Call 'SomeCodeFollows'
	for 'break', 'continue' and 'return' statements inside a try.
	We're fairly sure that the generated IL stream will have more
	instructions textually following the try.
	(FlowBranchingTryCatch): Likewise.

	* statement.cs (Throw.Resolve): Move CS0156 and CS0724 testing ...
	* flowanalysis.cs (FlowBranching.CheckRethrow): ... here and to its
	overrides.

	* statement.cs (CollectionForeach.DisposableWrapper): Make a true
	wrapper -- forward everything to CollectionForeach.
	(CollectionForeach.NonDisposableWrapper): New.
	(CollectionForeach.EmitFinallyBody): Use 'endfinally' instruction
	instead of a pop + branch to end.

2008-04-07  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #377485
	* assign.cs, expression.cs, decl.cs, class.cs, ecore.cs, namespace.cs: 
	Propagate location for extension method groups. Report conversion failure at
	right place.

2008-04-07  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, expression.cs, ecore.cs, typemanager.cs: Implemented
	ListInit and Field expressions.

2008-04-06  Raja R Harinath  <harinath@hurrynot.org>

	* iterators.cs (Iterator.EmitMoveNext): Remove try/fault wrapper.
	Since $PC is always -1 inside the body of MoveNext, the fault
	handler is a no-op.
	* flowanalysis.cs (FlowBranchingException.EmitFinally): Kill.
	* statement.cs (ExceptionStatement.emit_finally): Likewise.
	(ExceptionStatement.ResolveFinally): Drop 'branching' argument.

	The denouement!  Fix #324708
	* iterators.cs (Iterator.EmitMoveNext): Reset $PC to -1 on entry.
	(Iterator.EmitYieldBreak): We no longer need to reset $PC.
	* statement.cs (ExceptionStatement.DoEmit): Actually emit the
	'finally' inside the finally clause.

	* statement.cs (ExceptionStatement.DoEmit): Emit try/finally block
	inside an iterator.  Don't emit the body of the 'finally' inside
	the finally clause yet.

	Use the ResumableStatement infrastructure for MoveNext ()
	* iterators.cs (Iterator.EmitMoveNext_NoResumePoints): New.
	(Iterator.EmitMoveNext): Use 'resume_points'.  Get rid of
	'old_resume_points'.  Move dispatcher upfront.
	(Iterator.MarkYield): Mark the 'resume_point' of a Yield.
	* statement.cs (ExceptionStatement.DoEmit): Emit a dispatcher if
	in an enumerator.  This encodes the main fix in this patch series
	-- we can only jump into the first instruction of a try from the
	outside, but we want to emit try/finally regions in iterators and
	resume in the middle of them.

2008-04-05  Raja R Harinath  <harinath@hurrynot.org>

	* statement.cs (ExceptionStatement.ResolveFinally): Move setting
	of NeedReturnLabel here.

	Introduce a common point for emitting try/finally to IL
	* statement.cs (ExceptionStatement.DoEmit): New.  Combines all the
	features of the various subclasses, which are now driven by ...
	(ExceptionStatement.EmitPreTryBody): ... this and ...
	(ExceptionStatement.EmitTryBody): ... this and the original
	EmitFinallyBody.
	(TryFinally, Lock, Using, UsingTemporary, DisposableWrapper):
	Remove DoEmit and update to follow above protocol.

	* statement.cs (ExceptionStatement.EmitForDispose): If all labels
	of the dispatcher are the same, skip emitting the 'switch'.
	* iterator.cs (Iterator.EmitDispose): Update to changes.

	Clean up handling of 'using' statement
	* statement.cs (UsingTemporary): New.  Carved out of ...
	(Using): ... this.  Simplify drastically.  Handle exactly
	one variable.
	* cs-parser.jay (using_statement): Split.  Create UsingTemporary
	or Using as appropriate.  If there are multiple variable declared,
	create nested Using statements.
	(resource_acquisition): Kill.

	* statement.cs (ExceptionStatement.EmitForDispose): Use
	EmitFinallyBody, not EmitFinally.

	* flowanalysis.cs (FlowBranching.StealFinallyClauses): Remove.
	* iterator.cs: Update to changes.

	Start using the ResumableStatement infrastructure
	* statement.cs (ResumeableStatement.PrepareForDispose): New.
	(ResumableStatement.EmitForDispose): New.
	(ExceptionStatement): Override them.
	* iterators.cs (Iterator.EmitDispose): Use PrepareForDispose and
	EmitForDispose to create the body of the Dispose method.  Don't
	use OldResumePoint.

	* iterator.cs (Iterator.AddResumePoint): Move here from ...
	* statement.cs (Toplevel.AddResumePoint): ... here.
	(Toplevel.MoveNextStatement.Resolve): Create FlowBranchingIterator.
	* flowanalysis.cs (FlowBranchingIterator): New.
	* codegen.cs (EmitContext): Update to changes.

	* iterators.cs (Iterator.OldResumePoint): Rename from ResumePoint.
	(Iterator.old_resume_points): Rename from 'resume_points'.
	(Iterator.MoveNextStatement): Remove unused class.

	New infrastructure for try/finally in iterators (still unused)
	* flowanalysis.cs (FlowBranching.AddResumePoint): New.
	(FlowBranchingToplevel.AddResumePoint): Hook into
	ToplevelBlock.AddResumePoint.
	(FlowBranchingTryCatch): Move CS01626 and CS01631 checks here.
	(FlowBranchingException): Hook into ExceptionBlock.AddResumePoint.
	* statement.cs (ToplevelBlock.AddResumePoint): New.  Collect
	resume points and assign program-counter values.
	(ExceptionBlock.AddResumePoint): Collect resume points for
	de-muxer at the top of try block.
	* iterators.cs (Yield.CheckContext): Simplify.
	(Yield.Resolve): Use FlowBranching.AddResumePoint.

2008-04-04  Raja R Harinath  <harinath@hurrynot.org>

	* flowanalysis.cs (FlowBranching.AddReturnOrigin): Change Location
	argument to an ExitStatement.
	(FlowBranchingException): Refactor saved origins code.
	* statement.cs (ExitStatement): Update to cahges.
	* iterator.cs (YieldBreak): Likewise.

	* statement.cs (ResumableStatement): New.  Common base class for
	YieldReturn and ExceptionStatement.
	(ExitStatement): New.  Common base class for Return and YieldBreak.
	(Return): Update to changes.
	* iterator.cs (YieldBreak): Likewise.
	* lambda.cs (ContextualReturn): Likewise.

	Fix #377028
	* ecore.cs (Expression.ResolveAsTypeStep): If '!silent' attempt to
	emit a meaningful error message.

	Fix #324765, #319508
	* flowanalysis.cs (VariableInfo.IsEverAssigned): New.
	(VariableInfo.SetAssigned): Set it.
	* statement.cs (Block.UsageWarning): Use 'IsEverAssigned' to
	determine if CS0219 or CS0168 is appropriate.  Don't use
	flow-analysis information.
	(Block.Resolve): Use ec.EndFlowBranching, not ec.DoEndFlowBranching.
	* codegen.cs (EmitContext.DoEndFlowBranching): Kill.  Inline into ...
	(EmitContext.EndFlowBranching): ... this.

2008-04-03  Marek Safar  <marek.safar@gmail.com>

	* class.cs, typemanager.cs: Emit volatile field with IsVolatile modifier.

2008-04-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #376508
	* convert.cs, expression.cs: Fixed difference between ImplicitConversion and
	ImplicitConversionExists.

2008-04-03  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Binary): Added remaining binary operators to expression
	tree builder.

	* nullable.cs: Optimize shift with null argument.

2008-04-03  Raja R Harinath  <harinath@hurrynot.org>

	Fix minor IL regression
	* statement.cs (TryCatch..ctor): Add 'inside_try_finally' argument.
	(TryCatch.DoEmit): Use it to avoid creating another ExceptionBlock.
	* cs-parser.jay (try_statement): Update to changes.

	* statement.cs (TryFinally.need_exc_block): Delete.
	(TryFinally): Update to changes.

	Now all ExceptionStatements are unconditional
	* statement.cs (CollectionForeach.DisposableWrapper): New.
	Extract out the try/finally code into a new wrapper.
	(CollectionForeach.Resolve): Use it to simplify the code.

2008-04-02  Raja R Harinath  <harinath@hurrynot.org>

	Start at simplifying ExceptionStatement semantics a bit
	* statement.cs (TryCatch, TryFinally): Split 'Try' into two pieces.
	* cs-parser.jay (try_statement): Update to changes.
	(opt_catch_clauses): Remove.
	* flowanalysis.cs: Update to changes.
	(FlowBranching.BranchingType.TryCatch): New.
	(FlowBranchingTryCatch): New.

	* flowanalysis.cs (FlowBranching.BranchingType.SwitchSection): Kill.
	(FlowBranching.CreateBranching): Update to changes.
	(FlowBranchingBlock.AddSibling): Add sanity check.
	* codegen.cs (EmitContext.StartFlowBranching) <Block variant>:
	Update to changes.

	* iterators.cs (Iterator.MarkFinally): Remove.
	* statement.cs (ExceptionStatement): Update to changes.

	Add support for skipping over finally blocks at runtime.  First
	in a series to fix #324708
	* iterators.cs (Iterator.SkipFinally): New LocalBuilder.
	(Iterator.EmitMoveNext): Initialize it.
	* statement.cs (ExceptionStatement.EmitFinally): Use it to emit a
	branch over the body of the 'finally' clause.

2008-03-31  Raja R Harinath  <harinath@hurrynot.org>

	Avoid lopsided use of Foo/DoFoo names
	* statement.cs (ExpressionStatement.EmitFinallyBody):
	Rename from EmitFinally.
	(ExpressionStatement.EmitFinally): Rename from DoEmitFinally.
	* iterator.cs: Update to changes.

2008-04-02  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, nullable.cs: ConditionalLogicalOperator is now
	based on UserOperatorCall. More binary nullable operators clean up.

2008-04-02  Martin Baulig  <martin@ximian.com>

	* symbolwriter.cs: Remove the `#if !DISABLE_TERRANIA_CHANGES' conditionals.

2008-04-02  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs: Merge user and empty conversions when lifting expression
	trees.
	
	* expression.cs (StringConcat): Implemented expression tree representation.

2008-04-01  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs: When lifting null literal and a user operator exists, no call 
	is made.
	
2008-04-01  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, ecore.cs, expression.cs: Convert null arithmetic to lifted
	null.

2008-04-01  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs, expression.cs: Use namespace instead heavily nested
	monster abstract class.

2008-04-01  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, convert.cs, constant.cs, nullable.cs, expression.cs: Implemented
	lifting of null literal and user operators. Clean up of some temporary
	nullable hacks.

2008-03-30  Raja R Harinath  <harinath@hurrynot.org>

	Fix #368224, test-629.cs
	* flowanalysis.cs (FlowBranching.StealFinallyClauses): Return true
	if it crossed an unwind-protect boundary.
	* iterators.cs (Yield.CheckContext): Relax check for 'yield break'.
	(Yield.Resolve, Yield.DoEmit): Track whether the yield occurs
	inside an unwind-protected region.
	(YieldBreak.Resolve, YieldBreak.DoEmit): Likewise.
	(Iterator.MarkYield): Add 'unwind_protect' parameter.  Emit a
	'leave' instead of a 'br' if unwind-protected.
	(Iterator.EmitYieldBreak): Likewise.

2008-03-29  Gert Driesen  <drieseng@users.sourceforge.net>

	* driver.cs: Only define versioninfo resources if no win32 resource
	file was specified.

2008-03-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #372375
	* convert.cs: Fixed boxing of nullable types.

2008-03-28  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs: Initialize InternalsVisibleTo as the very first optional
	type.

2008-03-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #374619
	* nullable.cs: Fixed guarding of EmitBitwiseBoolean.
	
2008-03-27  Marek Safar  <marek.safar@gmail.com>

	* lambda.cs: Check return type only for invocation.
	
2008-03-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #374214
	* ecore.cs: Correctly report argument type mismatch.

2008-03-27  Marek Safar  <marek.safar@gmail.com>

	* convert.cs (ImplicitReferenceConversionCore): Correctly compare enum type
	and not rely on broken IsEnum.

2008-03-27  Marek Safar  <marek.safar@gmail.com>

	* nullable.cs: New file, extracted from generic.cs.
	
	* generic.cs, generic-mcs.cs, *.csproj, *.sources: Updated.

2008-03-27  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, convert.cs, generic-mcs.cs, expression.cs: Added lifting of
	predefined comparison operators and null literals.
	
	* report.cs: New warning ID.
	
2008-03-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #370577
	* lambda.cs: Check return type too.

2008-03-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #372846
	* class.cs: Automatic properties can be declared as unsafe.

2008-03-20  Marek Safar  <marek.safar@gmail.com>

	* location.cs: Use string based concatenation.
	
	* expression.cs: LiftedBinaryOperator is gmcs only.
	
2008-03-20  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, literal.cs, ecore.cs, expression.cs: Ongoing work on nullable
	conversions rules and expression trees.

2008-03-19  Marek Safar  <marek.safar@gmail.com>

	* delegate.cs: Use extension method source as delegate target.

2008-03-19  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, generic-mcs.cs, expression.cs, ecore.cs: Rewrote nullable
	binary operations to be purely based on binary operations and optimized
	emitted code (30% less in some cases). Introduced ReducedExpression for ETs
	and other ET refactoring.
	
	* typemanager.cs: Fixed warning.
	
2008-03-17  Marek Safar  <marek.safar@gmail.com>

	* class.cs, decl.cs, delegate.cs: Do protected modifier check on each member
	
	* symbolwriter.cs: Fixed.

2008-03-17  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, driver.cs: Reset anonymous types counters.

2008-03-17  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (MethodGroupExpr): Skip first candidate, it's already the best.
	
	* class.cs: Use fullname for all type member definitions.
	
2008-02-19  Martin Baulig  <martin@ximian.com>

	* class.cs
	(IMethodData.EmitExtraSymbolInfo): New interface method.
	(MethodData.Emit): Call method.EmitExtraSymbolInfo().
	(MethodOrOperator.EmitExtraSymbolInfo): Implement this new
	interface method here as an empty public virtual method.

	* anonymous.cs
	(AnonymousMethodMethod.ctor): Added `string real_name' argument.
	(AnonymousMethodMethod.EmitExtraSymbolInfo): Override and call
	CodeGen.SymbolWriter.SetRealMethodName().	

2008-02-18  Martin Baulig  <martin@ximian.com>

	* anonymous.cs
	(ScopeInfo.EmitType): Override this and emit debugging
	information for captured variables.
	(RootScopeInfo.EmitType): Override this and emit symbol
	information for a captured `this'.

2008-02-15  Martin Baulig  <martin@ximian.com>

	* iterators.cs: Emit debugging info.

	* codegen.cs
	(EmitContext.Flags): Add `OmitDebuggingInfo'.
	(EmitContext.OmitDebuggingInfo): New public property.

	* statement.cs
	(While): Override Emit() and don't emit symbol info there; do it
	inside DoEmit() instead.
	(Block.Emit): Omit symbol information while emitting the scope
	initializers; don't ec.Mark() the `EndLocation'.  Fix the lexical
	block logic.
	(ExplicitBlock.IsIterator): Moved here from `ToplevelBlock'.
	(ToplevelBlock.MakeIterator): Pass the `flags' to `ExplicitBlock's
	.ctor to make `IsIterator' work.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* symbolwriter.cs: Added the new symbol writer function from the
	debugger's `terrania' branch; temporarily enclose them inside
	`#if !DISABLE_TERRANIA_CHANGES' conditionals until I'm back from
	my vacations.

2008-03-14  Martin Baulig  <martin@ximian.com>

	* symbolwriter.cs
	(SymbolWriter): Make this a public static class.

	* codegen.cs
	(CodeGen.SymbolWriter): Removed; use the new static `SymbolWriter'
	class instead of using `if (CodeGen.SymbolWriter != null)' everywhere.

2008-03-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #370577
	* statement.cs, lambda.cs: Added extra limitations when dealing with void
	return type.
	
2008-03-14  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs (CSharpName): Made 250 times faster.

2008-03-13  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs: Emit conversion for ET shift argument.
	
2008-03-12  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, enum.cs, codegen.cs, statement.cs: Try not to
	crash when predefined field does not exist.
	
2008-03-12  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (PropertyExpr): Fixed IsSingleDimensionalArrayLength regression.
	
2008-03-12  Marek Safar  <marek.safar@gmail.com>

	* class.cs (FixedField): Don't crash when contructors are missing.

2008-03-11  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, namespace.cs, literal.cs, ecore.cs, class.cs, decl.cs,
	convert.cs, constant.cs, expression.cs, statement.cs: Use same method to
	check internal types accessibility for internal and external types.
	Replaced EnumToUnderlying by GetEnumUnderlyingType.

2008-03-11  Marek Safar  <marek.safar@gmail.com>

	* support.cs, typemanager.cs, pending.cs, ecore.cs, class.cs, delegate.cs
	convert.cs, const.cs, anonymous.cs, constant.cs, expression.cs,
	attribute.cs, statement: Use corect instance of predefined types (work
	related to #364674).

2008-03-07  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (TypeOfVoid): Fixed predefined method initialization.
	
2008-03-07  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, parameter.cs, rootcontext.cs, ecore.cs, 
	class.cs, delegate.cs, iterators.cs, const.cs, constant.cs, driver.cs,
	expression.cs, attribute.cs, codegen.cs, statement.cs: TypeManager optional
	predefined types clean up, delayed predefined types members initialization
	(work related to #364674).

2008-03-05  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs (IsFriendAssembly): InternalsVisibleTo is not mandatory.
	
2008-03-05  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs, parameter.cs, rootcontext.cs, ecore.cs, class.cs, decl.cs,
	delegate.cs, convert.cs, driver.cs, attribute.cs, codegen.cs: TypeManager
	predefined types clean up (work related to #364674).

2008-03-04  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Print an error message instead of throwing exception.
	
2008-03-04  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, literal.cs, convert.cs, cfold.cs, constant.cs,
	expression.cs, statement.cs: Unififed null literal representation.

2008-03-03  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs, cfold.cs, convert.cs, delegate.cs, doc.cs, ecore.cs,
	expression.cs: Refactored binary operators resolve phase and improved speed.
	The nullable code is still missing and won't work correctly, more fixes
	required.

	It also fixes #323726, #324312, #324248, and many other unreported issues.

2008-02-29  Zoltan Varga  <vargaz@gmail.com>

	* report.cs (FeatureIsNotAvailable): Use 'mcs1' instead of 'mcs', and 'mcs' 
	instead of 'gmcs'.

2008-02-27  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Clean-up and split BetterConversion.
	
2008-02-25  Raja R Harinath  <harinath@hurrynot.org>

	Fix #363791
	* enum.cs (EnumMember.Value): Only access 'value' if
	ResolveValue says it's ok.
	(EnumMember.DoResolveValue): Don't set prev_member.value.
	(Enum.GetDefinition): Reverse arguments of Equals --
	EnumMember.Value can return 'null'.

	* statement.cs (Switch.Error_AlreadyOccurs): Fix typo in name.

2008-02-22  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, expression.cs: More ongoing work on expression trees.
	
2008-02-21  Marek Safar  <marek.safar@gmail.com>

	* class.cs, typemanager.cs: Rewrote operator matching logic to correctly
	handle missing matches when mutiple operators exist.
	
2008-02-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #363218
	* expression.cs (ArrayCreation.Clone): Deal with multi-dimensional
	initializers.
	
2008-02-20  Marek Safar  <marek.safar@gmail.com>

 	* expression.cs, constant.cs, cfold.cs: Yet another side-effect constant
 	update. This time to deal correctly with SideEffectConstant expression used
 	as an argument for another constant folding.

2008-02-20  Raja R Harinath  <harinath@hurrynot.org>

	* typemanager.cs (DropGenericMethodArguments): Ensure we get an underlying
	MethodBuilder.

2008-02-19  Marek Safar  <marek.safar@gmail.com>

 	* constant.cs, cfold.cs: SideEffectConstant results can apply for folding.

2008-02-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #328136
	* expression.cs: Do not fold immediately LogicalAnd operators when the left
	side is a false constant, because we still need to evaluate the right-hand
	side.

	* statement.cs (If): Emit two types of boolean constants (simple constant,
	side-effect constant).

2008-02-19  Marek Safar  <marek.safar@gmail.com>

	* constant.cs (SideEffectConstant): Don't emit boolean constant.

	* expression.cs: Fold immediately LogicalAnd operators when both sides are
	constants.

2008-02-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #361457
	* ecore.cs (IsApplicable): Params methods have lower priority.

	* support.cs: Return correct parameter modifier for params types.

2008-02-18  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (TypeParameter): Cache attribute target name.

	* support.cs: Removed unused variable.

	* typemanager.cs: Removed debugging leftover.

	* ecore.cs: Use local type instead of a property;

	* class.cs (VerifyMembers): Consider also parent to test whether type member
	is local or public.

	* expression.cs (FullMethodDesc): Removed.

	* attribute.cs (IsValidArgumentType): Made static.

2008-02-17  Raja R Harinath  <harinath@hurrynot.org>

	Cleanup to be more readable.
	* Makefile (GMCS_PROFILE): Remove.
	(COMPILER_NAME): New helper.

2008-02-15  Miguel de Icaza  <miguel@novell.com>

	* cs-tokenizer.cs: if a conditional expression happens inside a
	(...) this also means that we do not need to de-ambiguate between
	an parenthesized expression and a cast.

	Fixes 346484.

	* constant.cs (SideEffectConstant): a constant value that happens
	to have a side effect.

	Fixes the build regressions introduced by the fix for #359789

2008-02-14  Rodrigo Kumpera  <rkumpera@novell.com>

	* expression.cs (Conditional.Emit): when emitting the ternary
	operator, use local variables to generate code verifiable code.

	The verifier cannot infer that the type on stack before the
	stloc.0 is executed is of type ParentB. This happens because the
	stack merge algorithm uses only parent types when deciding which
	is the common type.  This is described in Part III 1.8.1.3 of ECMA
	335.

	This code compiled with mcs is not verifiable under MS. The MS
	verifier picks the first common interface of Foo and Bar, which is
	wrong, but doesn't use a full join type of the 2 interfaces.

	CSC uses a clever hack to compile such code in a verifiable
	way. It stores the intermediate values in a local variable with
	the expected type.

	Fixes: #358102

2008-02-14  Miguel de Icaza  <miguel@novell.com>

	* expression.cs: Do not fold BitwiseAnd operators when the left
	side is a false constant, because we still need to evaluate the
	right-hand side.

	Fixes #359789

	* support.cs: Instead of throwing an InternalErrorException when
	the position of the stream is outside the boundary of our buffer,
	reset the state of the reader, and restart the reading from the
	beginning of the file.

2008-02-14  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (TypeParameter.GetMembers): Is not supported operation.

2008-02-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #361686
	* decl.cs: A protected types used inside a private class which parents
	derives from the protected class are accessible.

2008-02-13  Marek Safar  <marek.safar@gmail.com>

	* generic.cs (ConstraintChecker): Use cached member lookup when looking for
	the parameterless constructor.

2008-02-13  Marek Safar  <marek.safar@gmail.com>

	* generic.cs, typemanager.cs, iterators.cs, codegen.cs: Refactored core
	lookup methods to use standard member cache when doing member lookup.

2008-02-12  Marek Safar  <marek.safar@gmail.com>

	* driver.cs: Don't report full path for referenced module as assembly error.

2008-02-12  Marek Safar  <marek.safar@gmail.com>

	* Makefile: Fixed `qh' target to work on all machines.

	* report.cs, typemanager.cs, parameter.cs, ecore.cs, class.cs, anonymous.cs,
	expression.cs, codegen.cs, statement.cs, doc.cs: Replaced type IsSubclassOf
	and HasElementType with TypeManager implementation.

2008-02-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #325134, #359749
	* expression.cs, ecore.cs: Try to resolve an extension method even if the
	first binds point to non-method member expression.

2008-02-08  Marek Safar  <marek.safar@gmail.com>

 	* cs-parser.jay: Null coalescing operator is not part of ISO-1.

2008-02-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #321394, #323028
	* generic.cs, parameter.cs, ecore.cs, class.cs, decl.cs, delegate.cs:
	Reworked naive IsAccessibleAs implementation to handle nested types.

2008-02-05  Jb Evain  <jbevain@novell.com>

	* class.cs: use generic type comparison for parameters
	as well.

2008-02-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #325372
	* class.cs: Use generic type comparison when testing method signatures.

2008-02-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #357047
	* ecore.cs: Applied C# 3.0 changes to better conversion.

2008-02-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #358374
	* cs-parser.jay: Correctly set modifiers for all constructor types.

2008-02-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355251
	* generic.cs: Added base class constraint based type inference.

2008-02-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #357255
	* decl.cs: One more missing visibility check.

2008-02-01  Marek Safar  <marek.safar@gmail.com>

	* support.cs: Fixed broken return.

2008-01-25  Marek Safar  <marek.safar@gmail.com>

	* report.cs: Correctly reset warnings count after probing.

2008-01-25  Martin Baulig  <martin@ximian.com>

	* namespace.cs
	(NamespaceEntry.SymbolFileID): Make this work again after
	MemberName.ToString() is gone.

2008-01-25  Marek Safar  <marek.safar@gmail.com>

	* expression.cs: Implemented Divide, Equal, ExclusiveOr, GreaterThanOrEqual
	expressions.

2008-01-25  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Use full implicit conversion for type inference fixing.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, generic.cs: Implemented Convert, ConvertChecked.
	Fixed user operator conversions.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	* generic.cs: Do nullable type to null comparison optimization during
	resolve phase.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355163
	* generic.cs: Enabled l-value resolve on nullable expressions.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #353986
	* class.cs: Ingore static ctors with parameters for any further checks.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #354310
	* namespace.cs: Removed redundant check.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #354928
	* expression.cs: ElementInitializers can be resolved only once.

2008-01-24  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, ecore.cs, expression.cs, generic.cs: Implemented Coalesce and
	Condition expressions.

2008-01-23  Marek Safar  <marek.safar@gmail.com>

 	* codegen.cs: Fixed AssemblyBuilder initialization on other platforms.

2008-01-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, generic.cs: Implicit bool? to bool conversion is
	not allowed.

	* generic.cs: Implemented coalesce expression.

2008-01-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355145
	* anonymous.cs, convert.cs, ecore.cs, generic.cs, lambda.cs: Implemented
	expression tree type inference.

2008-01-22  Raja R Harinath  <harinath@hurrynot.org>

	Fix #354663
	* expression.cs (Binary.IsUnsignedType): Fix typo.

2008-01-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, expression.cs, generic.cs: Implemented NewArrayInit expression.

2008-01-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355161
	* ecore.cs, expression.cs: Wider range of extension method supported
	expressions.

2008-01-22  Gert Driesen  <drieseng@users.sourceforge.net>

	* codegen.cs: Use magic value for AssemblyBuilderAccess to instruct
	AssemblyBuilder to operate in compiler context. Fixes mcs part of
	bug #354970.

2008-01-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #355148
	* ecore.cs, expression.cs: Correctly report misused ref and out modifiers.

2008-01-22  Miguel de Icaza  <miguel@novell.com>

	* expression.cs (CreateExpressionTree): Add support for or and
	logical or, and indent following the coding conventions.

	* typemanager.cs (LinqExpression): renamed from
	ExpressionTreeManager, for a shorter name.

	Use TypeManager.CoreLookupType to lookup types from our core
	assemblies and turn those into "Type" variables.

	Consumers that previously used "Namespace" and "Type" from this
	class should instead use the TypeExpression which is a type that
	is fully resolved (without involving the regular C# resolution
	rules). 

	This typically looks like this:

	TypeExpression texpr = new TypeExpression (LinqExpression.expression_type, loc);
	new MemberAccess (texpr, name, type_arguments, loc)

	This avoids the problem in: #355178

2008-01-21  Marek Safar  <marek.safar@gmail.com>

 	* cs-parser.jay, expression.cs: Check `namespace alias qualifier' language
 	feature in parser only as we do in other cases.
 	
2008-01-21  Marek Safar  <marek.safar@gmail.com>

 	* attribute.cs, ecore.cs, class.cs, delegate.cs, expression.cs, linq.cs,
 	typemanager.cs: A refactoring of params arguments to reuse existing
 	expressions (params -> array initializer) to emit params argument instead
 	of specialized handling.
 	It was required by expression tree implementation and it has other benefits
 	as well, we now apply same optimization for params arguments as we do for
 	array initializers.
 	
2008-01-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #353526
 	* generic.cs: A type inference of params arguments may not required any
 	temporary array creation.
 	
2008-01-18  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #353534
 	* generic.cs, ecore.cs, expression.cs: A method group type inference is
 	supported for delegates only.
 	
2008-01-18  Marek Safar  <marek.safar@gmail.com>

 	* generic.cs: Fixed 3.0 type inference fixing phase to determine a unique
 	type for more than 1 candidates.
 	
2008-01-18  Marek Safar  <marek.safar@gmail.com>

 	* typemanager.cs, ecore.cs, expression.cs: Implemented ArrayLength and Call
 	expressions.
 	
2008-01-16  Marek Safar  <marek.safar@gmail.com>

 	* generic.cs, typemanager.cs, lambda.cs, parameter.cs, ecore.cs, constant.cs,
 	expression.cs: Implemented Add, And, AndAlso, and ArrayIndex (without unary
 	operator) expressions. 
 	 	
2008-01-16  Zoltan Varga  <vargaz@gmail.com>

	* statement.cs: Avoid declaring an IL variable for this_variable since it is
	not accessed from the generated IL.

2008-01-14  Marek Safar  <marek.safar@gmail.com>

 	* typemanager.cs, lambda.cs, parameter.cs, ecore.cs, class.cs, delegate.cs,
 	iterators.cs, convert.cs, assign.cs, anonymous.cs, expression.cs,
 	statement.cs: The first expression tree implementation drop, mostly
 	infrastructure work.

2008-01-14  Marek Safar  <marek.safar@gmail.com>

 	* ecore.cs (IsNestedChild): Refactored.

2008-01-11  Marek Safar  <marek.safar@gmail.com>

 	* lambda.cs: Don't use a cast on unknown expression statement.

2008-01-10  Geoff Norton  <gnorton@novell.com>

	* cs-tokenizer.cs: One more token to distinguish between method and lambda
	arguments

2008-01-09  Marek Safar  <marek.safar@gmail.com>

 	* doc.cs: Report better /doc crash details.
 	
2008-01-09  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #352536
 	* ecore.cs, assign.cs, codegen.cs: Check event assignments.

2008-01-08  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #352287
 	* ecore.cs, expression.cs: Do `this' access checking in all member access
 	expressions.
 	
2008-01-08  Marek Safar  <marek.safar@gmail.com>

 	* rootcontext.cs, driver.cs: Switch to linq mode by default.
 	
 	* report.cs: Reset message stacks.
 	
2008-01-08  Marek Safar  <marek.safar@gmail.com>

 	* generic.cs (InferInPhases): Correctly calculate params position.
 	
2008-01-08  Marek Safar  <marek.safar@gmail.com>

 	* cs-tokenizer.cs: No need to parse full string when parsing lambda
 	arguments.

2008-01-07  Marek Safar  <marek.safar@gmail.com>

 	* cs-tokenizer.cs: Enabled lambda arguments micro-parser for all profiles.
 	
 	* decl.cs (LookupNamespaceOrType): Don't cache names which caused an error.
 	
 	* driver.cs: Updated --help option.
 	
2008-01-07  Marek Safar  <marek.safar@gmail.com>

 	* generic.cs (InferParamsTypeArguments): Removed.
 	(InferInPhases): Add params type inference.
 	(LowerBoundInference): Fixed scoring mechanism.
 	
 	* cs-tokenizer.cs (PreProcessPragma): Use Location instead of line.
 	
2008-01-06  Gert Driesen  <drieseng@users.sourceforge.net>

	* typemanager.cs: On 2.0 profile, GetPublicKeyToken returns an empty
	byte array for unsigned "baked" assemblies.

2008-01-05  Gert Driesen  <drieseng@users.sourceforge.net>

	* codegen.cs: AssemblyName.GetPublicKey returns a zero-length byte
	array for assemblies that are not strongnamed.

2008-01-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #351481
 	* expression.cs (MemberAccess.ResolveNamespaceOrType): Use correct
 	declaring type for nested generic types.
 	
2008-01-04  Marek Safar  <marek.safar@gmail.com>

 	* namespace.cs, class.cs, decl.cs, cs-parser.jay: Use GetSignatureForError
 	instead of ToString.
 	
2008-01-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #351047
 	* expression.cs (Binary.ResolveOperator): Allow equality operators between
 	null and structs only when equality and inequality operators are defined
 	either as an user-operators or predefined operators.
 	
2008-01-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #351047
 	* generic.cs, typemanager.cs, class.cs: New IsReferenceType helper method.
 	
2008-01-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #351257
 	* cs-tokenizer.cs: Advance line number for '\r' correctly.
 	
2008-01-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #351157
 	* class.cs (Using): Fixed yet another broken cloning.
 	
 	(Block): Put back more sensible default value for statements.
 	
2008-01-01  Gert Driesen  <drieseng@users.sourceforge.net>

	* codegen.cs: Allow AssemblyVersion with only major version component.
	Fixes bug #351055.

2007-12-29  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #324654
 	* class.cs: Use FullName property as member name.

2007-12-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #342117
 	* generic.cs (ConstraintChecker): Struct constraint also satisfies default
	constructor constraint.

2007-12-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #338273
 	* class.cs (ProbertyBase): Access modifier checks are required for overrides
 	only.

2007-12-28  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #350839
 	* ecore.cs (MethodroupExpr): Probing hacks are no longer required.

2007-12-27  AdTsai (http://code.google.com/u/AdTsai/)

	Reviewed by Ben Maurer, Miguel de Icaza, patches from Google's
	GHOP:
	
	http://code.google.com/p/google-highly-open-participation-mono/issues/detail?id=4 

	* statement.cs: Changed some Hashtables to use HybridDictionaries
	instead. It was observed that some HashTables only contained a few
	items in the vast majority of cases. Since HybridDictionary is
	more efficient on small sets (<10 elements), "known_variables"
	from class ExplicitBlock as well as "labels" and "constants " from
	class Block were changed to HybridDictionaries. 

	Atsai results: (56216kb->54987kb)

	Miguel results (bootstrap of mcs): 59819kb -> 59290kb


2007-12-27  AdTsai (http://code.google.com/u/AdTsai/)

	Reviewed by Ben Maurer, Miguel de Icaza, patches from Google's
	GHOP:
	
	http://code.google.com/p/google-highly-open-participation-mono/issues/detail?id=4 
	
	* expression.cs: foreach loop to for loop, saved on allocation of
	enumerator (59333kb->59141kb)

	* statement.cs. Changed foreach loops to for loops, saved on
	allocation of enumerator (59141kb->59006kb)

	* decl.cs: ArrayLists in .NET 1.1 allocate 16 elements by default
	when constructed with no specified capacity. This was causing a
	few ArrayLists to allocate more memory than they would potentially
	need in the Block class and MemberCache class. Setting the
	ArrayLists to construct with a capacity of 1 saves some
	memory. (56216kb->55585kb)

2007-12-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #347189 (2nd issue)
 	* expression.cs (MemberAccess): Nested type can be found in base non-generic
 	type.

2007-12-27  Miguel de Icaza  <miguel@novell.com>
	
	* report.cs: Do not use colors if stdout and stderr are not a
	terminal.

2007-12-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #346998
 	* ecore.cs (MethodGroupExpr): Implemented override filter for generic
 	overloads.

2007-12-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #343465
 	* class.cs: Explicit method name for nested types uses dots only.

2007-12-27  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #343707
 	* cs-tokenizer.cs: Advance line number for mixed CR/LF files correctly.

2007-12-27  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Report type inference errors only when arguments count matches
	parameter count.
	
	* generic.cs (NullCoalescingOperator): Cannot be applied to null.
	
 	* expression.cs, report.cs: New warning.
 	
 	* typemanager.cs: Catch anonymous method type too.

2007-12-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #346379
 	* expression.cs (UnaryMutator): Emit size of type for pointer mutator.

2007-12-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #347359
 	* expression.cs (Invocation): Don't resolve already resolved expression.

2007-12-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #347189
 	* class.cs (FixedField): Use non-dependent code only in the define phase.

2007-12-23  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #348076
 	* ecore.cs (FieldExpr.DoResolve): Allow any variable based expression.

2007-12-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (MethodGroupExpr.OverloadResolve): Set type arguments for
	discovered extension methods.

2007-12-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, namespace.cs, expression.cs: Removed broken ResolveGeneric
	method.

2007-12-21  Miguel de Icaza  <miguel@novell.com>

	* report.cs (ErrorMessage): Add support for using colors on
	terminals that support it. 

2007-12-21  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs: Use information about expanded params for error reporting.

2007-12-21  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs, generic.cs, delegate.cs: Refactoring of method overloading code
	and logic for params overloads.
	
2007-12-15  Miguel de Icaza  <miguel@novell.com>

	* generic.cs (NullCoalescingOperator.CloneTo): implement this one,
	as this is also created from the parser.  Fixes #349034

2007-12-12  Miguel de Icaza  <miguel@novell.com>

	* statement.cs (Throw.CloneTo): it is valid to have empty
	expressions for throw. 

2007-12-03  Marek Safar  <marek.safar@gmail.com>

 	* cs-parser.jay: Set delegate constraint parsing region correctly.

2007-12-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #345467
 	* typemanager.cs (IsEqual): Compare generic parameters position only.
 	
2007-11-28  Marek Safar  <marek.safar@gmail.com>

 	* expression.cs (BaseAccess): Type arguments can be null.

2007-11-27  Raja R Harinath  <harinath@gmail.com>

	* statement.cs (Block.Resolve): Ensure flow-branching tree is
	consistent even when an error has occured.
	(Switch.Resolve): Likewise.

2007-11-22  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #334505
 	* class.cs: Don't ignore InternalsVisibleTo attribute for internal
 	overrides.
 	
2007-11-22  Marek Safar  <marek.safar@gmail.com>

 	* ecore.cs, typemanager.cs, delegate.cs, expression.cs: The first of 
 	refactorings required to resolve extension methods correctly when mixing
 	generics and non-generics members.
 	
2007-11-20  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #342584
 	* convert.cs: Added not documented explicit IntPtr/UIntPtr to enum
 	conversion.
 	
2007-11-19  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #342512
 	* delegate.cs: Use delegate argument expression when is available. Don't
 	emit virtual call when class is sealed.
 	
2007-11-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #325423
 	* assign.cs (FieldInitializer): Use resolved expression for emit.
 	
 	* class.cs: Print less confusing error message.
 	
2007-11-16  Marek Safar  <marek.safar@gmail.com>

 	* cs-tokenizer.cs: Removed GMCS ifdefs.
 	
 	* rootcontext.cs, report.cs: Report unavailable gmcs features used by
 	mcs.
 	
	* cs-parser.jay: Disabled nullable check.
	
	* generic-mcs: Copied more generic stuff.
	 	
2007-11-16  Marek Safar  <marek.safar@gmail.com>

 	* gcs-parser.jay: Merged to cs-parser.jay.
 	
 	* generic.cs, typemanager.cs, cs-tokenizer.cs, linq.cs, Makefile
 	* *.csproj, *.sources: Updated to use only jay parser file.

2007-11-16  Marek Safar  <marek.safar@gmail.com>

 	* gcs-parser.jay: Added nullable and default expression feature checks.
 	
2007-11-16  Marek Safar  <marek.safar@gmail.com>

 	* gcs-parser.jay, cs-parser.jay, class.cs: Unified parameters parsing, 
 	it fixes many TODOs and hidden bugs.
 	
 	* expression: Removed duplicate error check.

2007-11-15  Marek Safar  <marek.safar@gmail.com>

 	* gcs-parser.jay, statement.cs, decl.cs, ecore.cs: Try to resolve an
 	implicitly type local variable only when it is used in a declaration.

2007-11-15  Marek Safar  <marek.safar@gmail.com>

 	* attribute.cs: Use CS0612 for empty strings.

2007-11-14  Marek Safar  <marek.safar@gmail.com>

 	* lambda.cs, statement.cs: Contextual return may act as a statement.

2007-11-14  Marek Safar  <marek.safar@gmail.com>

 	A fix for a regression cause by #324222
 	* class.cs: Don't report unused even when it implements an interface.
 	
2007-11-13  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #341205
 	* ecore.cs, expression.cs: Method group expression cannot do static
 	method access with an instance reference check before overloading takes
 	a place.
 	
2007-11-13  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #325359
 	* class.cs: Use predictable name for automatically generated property.
 	
2007-11-12  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #324996
 	* expression.cs (Is): Handle case where D is nullable and T is not
 	correctly.
 	
 	* generics.cs (Nullable.HasValue): Nullable HasValue expression.
 	
2007-11-12  Marek Safar  <marek.safar@gmail.com>

 	* generic.cs, literal.cs, ecore.cs, class.cs, delegate.cs, const.cs,
 	anonymous.cs, expression.cs, attribute.cs, codegen.cs, statement.cs:
 	Flush small error reporting changes.
 	
2007-11-09  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #324996
 	* expression.cs: Rewrote Is expression implementation to work with
 	generics, nullable types, anonymous method. A const result expression 
 	uses existing infrastructure instead of custom not fully-featured one.
  	
2007-11-08  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #340202
 	* class.cs: Consider generics for volatile field.

2007-11-08  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #335594
 	* expression.cs: Use conversion rules when handling string addition.
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #336651
 	* expression.cs: Fixed a crash when probing is on.
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #324242
 	* covert.cs: Added a conversion from any nullable-type with an 
 	underlying enum-type to the type System.Enum.
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #324222
 	* class.cs: Report all non-used event fields.
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #325161
 	* cs-parser.jay, gcs-parser.jay, decl.cs: Implemented namespace alias
 	qualifier for generic types.
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #322971
 	* expression.cs, ecore.cs: Added intermediate result value check for
 	indexers. 
 	
2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #324754
 	* cs-parser.jay, gcs-parser.jay, class.cs: Try to create an interator
 	when it was requested.

2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #325101
 	* expression.cs: Do type not value comparison for `is' expression.

2007-11-07  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #320236
 	* convert.cs: Don't apply user conversion on underlying target type.

2007-11-06  Marek Safar  <marek.safar@gmail.com>

 	* expression.cs: Don't use unresolved expression for error reporting.
 
2007-11-06  Marek Safar  <marek.safar@gmail.com>

 	A fix for bugs #337712, #324490
 	* ecore.cs (MethodGroupExpr): Refactored to handle delegate method
 	overloading resolution too.
 	
 	* delegate.cs: Uses MethodGroupExpr for overloading resolution. It makes
 	the process consistent and more robust.
 	
 	* expression.cs, linq.cs, report.cs: Update.

2007-11-02  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #332909
 	* attribute.cs: Resolve attributes in correct context using error
 	handling procedure.
 	
 	* rootcontext.cs: Define Obsolete attribute members as core members.
 	
2007-11-02  Marek Safar  <marek.safar@gmail.com>

 	* statement.cs: Removed unused methods.
 	
2007-10-31  Wade Berrier  <wberrier@novell.com>

	* Makefile:  reenable copy of gmcs.exe.config, but include it in EXTRA
	DIST (it doesn't get included because PROGRAM isn't defined to be gmcs
	during 'make dist')

2007-10-31  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #338102
 	* decl.cs (CheckExistingMembersOverloads): Workaround issue with generic
 	methods registered as non-generics.
 	
2007-10-31  Marek Safar  <marek.safar@gmail.com>

 	A fix for bugs #337712, #324490
 	* delegate.cs: Delegate covariance and contravariance is not allowed for
 	value types.
 	
2007-10-31  Marek Safar  <marek.safar@gmail.com>

 	A fix for bug #337719 
 	* cs-tokenizer.cs: Restore identifier buffer when parsing contextual
 	`from' keyword.
 	
2007-10-30  Marek Safar  <marek.safar@gmail.com>
 
	* Makefile (net_2_0_bootstrap/mcs.exe.config): Reverted copy gmcs.exe.config.

2007-10-29  Marek Safar  <marek.safar@gmail.com>
 
 	* cs-tokenizer.cs, gcs-parser.jay, driver.cs: Fixed parsing of nested
 	query expressions.

2007-10-29  Raja R Harinath  <rharinath@novell.com>

	* Makefile (net_2_0_bootstrap/mcs.exe.config): Copy gmcs.exe.config.

2007-10-29  Marek Safar  <marek.safar@gmail.com>
 
 	A fix for bug #334652
 	* ecore.cs (MethodGroupExpr.OverloadResolve): Do also lookup for
 	extension methods when we have not found the best candidate in normal
 	container.

2007-10-27  Marek Safar  <marek.safar@gmail.com>

	* AssemblyInfo.cs: Keep up-to-date.

2007-10-27  Marek Safar  <marek.safar@gmail.com>

	* Makefile: Fixed generics compiler name.
	
2007-10-27  Marek Safar  <marek.safar@gmail.com>

	* lambda.test: removed, lambda parsing is done differently.
	
	* gen-il.cs, gen-treedump.cs, old-code.cs : Obsolete.

2007-10-27  Gert Driesen  <drieseng@users.sourceforge.net>

	* Makefile: Removed dependency on gmcs.exe.config. Fixes build.

2007-10-27  Marek Safar  <marek.safar@gmail.com>

	* Makefile, *.sources : All C# compilers are in mcs folder.
	
	* *.cs: Use existing 2_1 define for smcs.

2007-10-26  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #335847
	* assign.cs, expression.cs: Couple of changes to avoid creating a
	temporary variable for each object initializer assignment statement. It
	simplifies struct initialization too, otherwise two temporary variables
	would be required.
	Implemented optimization of redundant default element initializers.
	
2007-10-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #336766
	* expression.cs (Class.CheckBase): Use generic name when method is
	generic.
	
2007-10-25  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #334737
	* expression.cs (IndexerAccess.EmitAssign): Emit local temporary
	variable and not variable argument for prepared copies.

2007-10-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #325110
	* class.cs, expression.cs, attribute.cs: Use open generic method when
	checking conditional attribute.
	
2007-10-24  Marek Safar  <marek.safar@gmail.com>

	* report.cs, cs-tokenizer.cs, class.cs, cs-parser.jay, anonymous.cs, 
	expression.cs, statement.cs: Renamed method FeatureIsNotISO to
	FeatureIsNotAvailable.

2007-10-24  Marek Safar  <marek.safar@gmail.com>

	** C# 3.0 Partial methods
	
	* cs-tokenizer.cs, support.cs, class.cs, decl.cs: Implemented partial
	methods support. Because of member cache issue with generics only
	non-generics partial methods are fully supported.
	
2007-10-23  Marek Safar  <marek.safar@gmail.com>
	
	* class.cs, decl.cs: Rewrote member overloads check to cope with 
	generics and to use member cache for member checking. It also improves
	performance and fixes remaining overloads issues.
	
2007-10-20  Marek Safar  <marek.safar@gmail.com>
	
	* class.cs, const.cs, decl.cs, delegate.cs, enum.cs, generic.cs,
	roottypes.cs, typemanager.cs:
		
	A member cache creation logic changed to add members immediately and
	not rely on fallback. The member cache is now only prefered way
	how to access and find type declaration members. It saves 5 MB of memory
	during MWF compilation and makes code ready for more optimizations and
	clean-ups, it's also a pre-requirement for partial methods.
	
2007-10-18  Raja R Harinath  <harinath@gmail.com>

	* ecore.cs (Expression.Error_ValueCannotBeConverted): Add special
	handling for generic parameters.

2007-10-15  Marek Safar  <marek.safar@gmail.com>
	
	* class.cs (FixedField): Removed redundant volatile check.
	
2007-10-15  Marek Safar  <marek.safar@gmail.com>
	
	* class.cs, decl.cs: Fixed overload members verification to do only one
	check per possible collision.
	
2007-10-13  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #325478
	* anonymous.cs (AnonymousContainer.Compatible): Merge are flags together
	and create only one disposable flags container.
	
2007-10-12  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #332442 by Alexandre Gomes <alexmipego@gmail.com>
	* statement.cs (Fixed): Fixed variables cloning.
	
2007-10-12  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #333342
	* class.cs (EventField): Don't mark value type event as synchronized. 
	
2007-10-12  Marek Safar  <marek.safar@gmail.com>
	
	* ecore.cs, anonymous.cs (MethodGroupExpr): Use score from type
	inference to identify best candidate method correctly.
	(ProperyExpr): A range variable is read only and cannot be modified.
	
2007-10-11  Marek Safar  <marek.safar@gmail.com>
	
	* ecore.cs, delegate.cs (MethodGroupExpr): Refactored best candidate
	logic to identify best candidate method correctly.
	
2007-10-11  Marek Safar  <marek.safar@gmail.com>
	
	* location.cs (Equals, GetHashCode): Removed.
	
2007-10-11  Marek Safar  <marek.safar@gmail.com>
	
	* report.cs: Implemented message recorder. It is used mainly for lambda
	expressions to capture otherwise swallowed error messages.
	
	* anonymous.cs, lambda.cs.cs: Do full parameters check.

	* ecore.cs (ExtensionMethodGroup): Report binding failure at the botton
	and not at the top.
	(MethodGroupExpr.DoResolve): Use message recorder for error handling.
		
	* expression.cs (MemberAccess): Always report lookup failure.
	
	* location.cs: Implemented Equals, GetHashCode.
	
	* statement.cs (Return.DoResolve): Fixed hardcoded error argument.
	
2007-10-10  Jb Evain  <jbevain@novell.com>

	* codegen.cs: re-enable assembly version check.

2007-10-09  Marek Safar  <marek.safar@gmail.com>
	
	* report.cs, anonymous.cs, driver.cs, expression.cs: Added few ISO-2
	checks.
	
	* namespace.cs (UsingAlias): Do correct version check.
	
2007-10-08  Marek Safar  <marek.safar@gmail.com>
	
	* expresison.cs, ecore.cs: Issue extension method error message when
	appropriate.
	
	* rootcontext.cs: Added ISO_2 compiler mode option.

2007-10-08  Marek Safar  <marek.safar@gmail.com>
	
	* expresison.cs (UnaryMutator.ResolveOperator): Print more useful error
	 message.
	
2007-10-08  Marek Safar  <marek.safar@gmail.com>
	
	* attribute.cs (GetString, GetBoolean): Work with both literal and
	constant.
	
	* ecore.cs, expresison.cs, delegate.cs (Invocation, MethodGroupExpr):
	Moved method overload specific methods to MethodGroupExpr.
	
	(IndexerAccess): Re-wrote resolving mechanism, fixed many issues and
	it should be less memory consuming.
	
Mon Oct 8 09:29:15 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* codegen.cs: remove the assembly version check until the buildbot is
	fixed.

2007-10-07  Jb Evain  <jbevain@novell.com>

	* attribute.cs (Attribute.GetString): if the value
	expression is a StringConstant, return its string value.

2007-10-07  Jb Evain  <jbevain@novell.com>

	* typemanager.cs: add `assembly_version_attribute_type`.
	* codegen.cs: on attribute emission, check that the
	AssemblyVersionAttribute doesn't overflow.

2007-10-05  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #324677
	* anonymous.cs, decl.cs: Yes another anonymous container hack. Overwrite
	parent container of a scope container with currently resolved one. 
	
2007-10-05  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #325534
	* class.cs (Invocation.DoResolve): Check invocation of object finalizer
	only.
	
2007-10-05  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #327504
	* class.cs (Operator.Define): Refactored implicit and explicit user
	operator conversion rules.
	
2007-10-05  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #327520
	* ecore.cs (ExtensionMethodGroupExpr): Emit resolved extension argument.
	
2007-10-04  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #328022
	* class.cs (MethodData.Define): Use correct method to check whether
	a method implementents an accessor.
	
2007-10-04  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #330069
	* statement.cs (Fixed.Resolve): Read the first array element only when
	an array is instantiated. 
	
2007-10-04  Marek Safar  <marek.safar@gmail.com>
	
	* expression.cs, assign.cs, generics.cs: Print correct operator when
	compound assignment is used.
	
2007-10-04  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #325841
	* expression.cs (ArrayAccess): Use full argument cloning only for
	string compound concatenation.
	
2007-10-03  Marek Safar  <marek.safar@gmail.com>
	
	A fix for bug #328774
	* ecore.cs (FieldExpr.EmitAssign): Fixed string concatenation compound
	assignment.
	(PropertyExpr.EmitAssign): Fixed string concatenation compound
	assignment.

2007-10-03  Raja R Harinath  <rharinath@novell.com>

	Fix #328490
	* ecore.cs (SimpleName.DoSimpleNameResolve): Handle Property and
	Event accessibility checks here.  Remove some bogus code that
	accidently made GenericMethods work.
	(PropertyExpr.IsAccessibleFrom, EventExpr.IsAccessibleFrom): New.

2007-09-25  Marek Safar  <marek.safar@gmail.com>
	
	* expression.cs (ArrayCreation): Fixed cloning of an implicit types.
	
	* statement.cs (Block): Refactored AddVariable to allow error handling
	customization.
	
	* generic.cs: New stub.
	
2007-09-23  Marek Safar  <marek.safar@gmail.com>
	
	* anonymous.cs, codegen.cs: Changed InferReturnType to be EmitContext
	flag.
	
2007-09-17  Marek Safar  <marek.safar@gmail.com>

	* class.cs: Use partial container to record whether any partial part
	contains static field initializer and therefore default contructor has
	to be defined.
	
2007-09-14  Marek Safar  <marek.safar@gmail.com>

	* class.cs (TypeContainer.AddPartial): Fixed an issue reported on
	mono-list when only one of two partial parts has defined accessibility
	modifier.
	
2007-09-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82845
	
	* class.cs (TypeContainer): Set correct resolve context for all field
	initializers.
	
2007-09-13  Marek Safar  <marek.safar@gmail.com>

	* assign.cs: Fixed a crash when field is resolved twice with an error.
	
	* codegen.cs: Changed InFieldInitializer to be flag.
	
	* anonymous.cs, ecore.cs, expression.cs: Update after
	IsInFieldInitializer rename.
	
	* const.cs: Removed unused parameter.
	
	* class.cs: Changed the way how we resolve and emit field initializers.
	The field initilizers have to have access to contructor block to emit
	compiler generated code.

2007-09-13  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (MemberAccess.DoResolve): DeclSpace is broken by
	generics use TypeContainer instead.
	
2007-09-12  Marek Safar  <marek.safar@gmail.com>
	
	* generic.cs (TypeInferenceContext.InflateGenericArgument): Stub.

	* lambda.cs (ResolveParameters): Use more powerful
	InflateGenericArgument.
	
	* parameters.cs: Better exception message.
		
2007-09-10  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousMethodExpression.CompatibleChecks): Report
	correct expression block type. 
	
	* ecore.cs (Expression.Error_MemberLookupFailed): Made virtual.
	
	* expression.cs (Invocation): Extracted method group resolve to
	DoResolveOverload.
	
2007-09-07  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (Expression.MemberLookupFinal): Removed unused loc parameter.
	(MethodGroupExpr.ResolveGeneric): Use existing method group instance.
	
	* expression.cs (MemberAccess.DoResolve): Uses generic resolver for
	generic extension methods.

2007-09-06  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82676 (Do I get it right now?)
	* convert.cs (Binary.ResolveOperator): An interface is converted to the
	object before a standard conversion is applied.
	
2007-09-06  Marek Safar  <marek.safar@gmail.com>

	* convert.cs (ImplicitReferenceConversionCore): Reverted wrong fix of
	#82676.
	
2007-09-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82676
	* convert.cs (ImplicitReferenceConversionCore): Check both sides for
	non-generic interface types.
	
2007-09-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82690
	* ecore.cs (PropertyExpr.EmitAssign): Leave a copy does just that.
	
2007-09-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82571
	* anonymous.cs (AnonymousMethod.DoCreateMethodHost): Use internal 
	modifier for container based methods.
	
2007-09-05  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82676
	* convert.cs (ImplicitReferenceConversionCore): From any class-type S to
	any interface-type T means to any of interface type T.

2007-09-04  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs: We have 2 versions of System.Core assembly.

2007-09-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82652
	* class.cs (Class.GetClassBases): Compare types and not expressions.

2007-09-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82620
	* expression.cs (Invocation.EmitArguments): Duplicate params arguments
	actually never worked before.
	(IndexerAccess): Emit prepared arguments before they are modified.
	
2007-09-04  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82563
	* assign.cs: Revert wrong fix.
	
	* expression.cs (VariableReference.EmitAssign): Handle ref reference
	correctly.
	(ArrayAccess): Changed the way we emit compound (prepared) assignments.
	Instead of ldelema/stdind we have to use temporary variables to handle
	cases like String.Concat (params string[]).
	
2007-08-31  Marek Safar  <marek.safar@gmail.com>

	* class.cs: EmitAttributes to Emit rename.
	
	* decl.cs (MemberCore.GetClsCompliantAttributeValue): Parent can be
	null.
	(MemberCore.HasClsCompliantAttribute): Don't depend on 
	GetClsCompliantAttributeValue execution.
	
2007-08-31  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: Use shorter type prefix.
	
	* ecore.cs (SimpleName.DoSimpleNameResolve): Use transparent identifiers
	when exist.
	
	* expression.cs (LocalVariableReference.DoResolveBase): Don't capture
	variables when probing is on.
	
	* statement.cs (LocaLInfo.Clone): Clone correctly resolved and 
	unresolved variables.
	(TopLevelBlock.GetTransparentIdentifier): Default implementation doesn't
	handle transparent identifiers.
	
2007-08-26  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs (IsClsCompliant): Add nullable types test.
	
2007-08-24  Atsushi Enomoto  <atsushi@ximian.com>

	* doc.cs : catch other types of exception than XmlException to
	  report CS1570. Fixed bug #82565.

2007-08-23  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousMethodExpressin.ExplicitTypeInference): 
	The number of delegate parameters has to match.
	(AnonymousMethodExpressin.VerifyParameterCompatibility): Handles generic
	arrays.

2007-08-21  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousMethod): Generate private anonymous method
	to fix problem with private arguments.

2007-08-20  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousTypeClass): An anonymous type can be empty.
	
	* decl.cs (MemberName): Ignore generic type with no generic arguments. 
	
	* expression.cs (AnonymousTypeDeclaration): An anonymous type can be
	empty. Add cloning suport.
	
	* roottypes.cs (GetAnonymousType): Fixed argument comparison logic.

2007-08-20  Marek Safar  <marek.safar@gmail.com>

	* convert.cs, ecore.cs, expression.cs, literal.cs: Use factory method 
	to create EmptyCast. It handles EmptyConstantCast specialization for
	constants.
	
2007-08-18  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (Binary.is_unsigned): Handle unsafe types too.
	(EmitArrayArgument): One routine for array arguments.
	(ArrayCreation.MakeByteBlob): Fixed an array alignment. 
	
2007-08-17  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs (GetKeyword): Handle from keyword in a different way.

2007-08-17  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs: MemberLookupFinal update.

	* class.cs (ConstructorInitializer): Is expression based.
	
	* delegate.cs: MethodGroupExpr update.
	
	* ecore.cs  (Error_MemberLookupFailed): Improved to report better error
	messages.
	(Error_MemberLookupFailed): Customizable error override.
	(MethodGroupExpr): Keep queried type for later usage.
	(MethodGroupExpr.OverloadResolve): Catch errors related to overload
	resolve.
	
	* expression.cs: Error_MemberLookupFailed refactoring.
	(New.DoResolve): Resolve as much as possible.
	(ElementInitializer.Error_MemberLookupFailed): Object initializer
	customization for invalid member types.

	* statement.cs: MethodGroupExpr update.
	
2007-08-16  Marek Safar  <marek.safar@gmail.com>

	* modifier.cs (Check): Check all modifiers and not only accessibility
	ones.

2007-08-16  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (Expression.Error_ValueCannotBeConverted): Report always a
	type and not an expression.

2007-08-16  Marek Safar  <marek.safar@gmail.com>

	* statement.cs (Catch.Clone): Type and variable can be null.

2007-08-16  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81979
	* assign.cs (Assign.Emit): Prepare arguments for string concatenation.
	I am really not sure whether this is the best fix.
	
	* expression.cs	(VariableReference.EmitAssign): Do prepare_load test
	only once.
	
2007-08-14  Marek Safar  <marek.safar@gmail.com>

	** C# 3.0 Object and collection initializers (major re-write)
	
	* assign.cs (DoResolve): Initializers are not assign related.
	
	* codegen.cs (EmitContext.CurrentInitializerVariable): Holds a varible
	used during collection or object initialization.
	
	* expression.cs (Error_InvalidArguments): Add initializers specific
	messages. More will come later because it requires some general
	refactoring.
	(New.DoResolve): Better error handling for unsafe types.
	(EmptyExpressionStatement): New class.
	(ElementInitializer): An object initializer expression.
	(CollectionElementInitializer): A collection initializer expression.
	(CollectionOrObjectInitializers): A block of object or collection
	initializers.
	(NewInitialize): New expression with element/object initializers.
	
	* statement.cs: Reverted object/collection initializer hacks.
	
	* typemanager.cs (CSharpName): Filter __arglist type.
	
2007-08-09  Marek Safar  <marek.safar@gmail.com>

	** C# 3.0 Anonymous Types (update to the latest standard)
	
	* expression.cs (Binary.ResolveOperator): Threat all null based types
	same.
	(AnonymousTypeDeclaration): Renamed from AnonymousType and simplified.
	(AnonymousTypeParameter): Updated.
	
	* anonymous.cs (CompilerGeneratedClass): Add custom name overload.
	(AnonymousTypeClass): New anonymous type container.
	
	* class.cs (AddField): Return operation result.
	
	* generic.cs: Another empty TypeArguments overload.
	
	* roottypes.cs (AddAnonymousType, GetAnonymousType): Anonymous types
	are stored at top of normal hierarchy.
	
	* typemanager.cs (CSharpName): Filter anonymous types.
	
2007-08-09  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (StringConcat.Append): Handle 3 and more concatenation
	as single Concat call. How could we miss that :-(
	
2007-08-08  Marek Safar  <marek.safar@gmail.com>

	* expression.cs (ArrayCreation.CloneTo): Allocate exact size.
	
2007-08-07  Miguel de Icaza  <miguel@novell.com>

	* expression.cs: Fix the previous commit, the creation of the
	arguments array list needs also to be conditional on the arguments
	not being null.

	* class.cs: Add a little bit of help to help narrow down problems.

	* expression.cs (ArrayCreation.CloneTo): Argument can be null, do
	not try to copy in that case. 

	* driver.cs: When building SMCS, include a new different set of
	default assemblies here.   Do this here so we can control whether
	to include the default assemblies with /noconfig.

2007-08-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81979
	* expression.cs (TypeOf.GetAttributableValue): Check for type arguments
	only.

2007-08-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82300

	* anonymous.cs (AnonymousContainer.Define): Don't define anything when
	we are in probing scope.

2007-08-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82301

	* statement.cs (Catch.CloneTo): Clone blocks in the right order.
	(Statement.CloneTo): Clone and not map children blocks.

2007-08-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82299

	* expression.cs (LocalVariableReference.CloneTo): Remap local info
	variable too.
	
	* statement.cs (Statement.CloneTo): Clone variables before statements
	to allow remaping of local variables.

2007-08-03  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82296

	* anonymous.cs,
	* report.cs: Log crash details for future clone problems.
	
	* statement.cs (Return.Clone): Don't clone non-existent expression.

2007-08-03  Raja R Harinath  <harinath@gmail.com>

	* class.cs (TypeContainer.AddBasesForPart): Make virtual.
	(Class.AddBasesForPart): Move CS0537 check here from ...
	* cs-parser.jay (class_declaration): ... here.  Move calling of
	'AddBasesForPart' to ...
	(class_bases): ... here.
	(struct_declaration, interface_declaration): Update to changes.

2007-08-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81923

	* statement.cs (Using.ResolveLocalVariableDecls): Only non-user implicit
	conversion is allowed.

2007-08-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81564

	* ecore.cs (EventExpr): Add IsBase handling.

	* expression.cs (BaseAccess.CommonResolve): Events can use base accessor
	too.	
	
2007-08-02  Raja R Harinath  <harinath@gmail.com>

	Reduce some differences between cs-parser.jay in mcs/ and gmcs/.
	* cs-parser.jay: Some whitespace cleanups.
	(current_delegate): New.
	(type_name): New.
	(struct_declaration): Make similar to gmcs/cs-parser.jay -- add
	a dummy code block, and use 'type_name' instead of 'member_name'.
	(interface_declaration, class_declaration): Likewise.
	(delegate_declaration): Likewise.  Rearrange slightly and use
	'current_delegate'.
	* cs-tokenizer.cs (handle_where): Rename from handle_constraints.
	(GetKeyword): Update to change.  Use '!foo' instead of 'foo == false'.

2007-08-02  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82039

	* ecore.cs (TypeLookup.GetSignatureForError): Use name when type is not
	available.

	* typemanager.cs (CSharpName): Split to string overload.

2007-08-02  Marek Safar  <marek.safar@gmail.com>

	* expression.cs,
	* report.cs: Updated warning CS0472.

2007-08-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82181
	* cs-parser.jay,
	* cs-tokenizer.cs: Ignore partial keyword inside block expression.

2007-08-01  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #82277
	* statememnt.cs (Block.Clone): Don't clone explicit blocks twice.

2007-08-01  Marek Safar  <marek.safar@gmail.com>

	** C# 3.0 Type Inference (major bits are working)
	
	* anonymous.cs (AnonymousMethodExpression): Removed refactored fields.
	(.ImplicitStandardConversionExists): Uses compatible.
	(.ExplicitTypeInference): Infers type arguments based on explicit arguments
	(.InferReturnType): New method.
	(.Compatible): Refactored.
	(.ResolveParameters): Uses factory to create resolved parameters.
	(.CompatibleMethod): Add probing mode support.
	(AnonymousContainer): Removed unused fields. Split Define and Resolve to
	clearly distinguish between 2 different operations.
	(LambdaMethod): Moved to lambda.cs.
	(AnonymousMethod): Removed unused fields and methods.
	(AnonymousDelegate): Simplified.
	
	* codegen.cs (ResolveTopBlock): Updated renamed Resolve to Define.
	
	* convert. cs (ImplicitConversionStandard): Compatible works differently.
	
	* delegate.cs (Delegate): New mehods to reduce code duplication.
	(.GetConstructor): New method.
	(.GetInvokeMethod): New method.
	(DelegateCreation): Updated.
	
	* ecore.cs (ResolveOverloadExtensions): Don't crash when extension method
	does not exist.
	(OverloadResolve): Made probing little bit faster.
	
	* expression.cs (ParameterReference.DoResolveLValue): Reference can be null
	when probing is on.
	
	* generic.cs (TypeInferenceContext): Dummy implementation.
	
	* iterators.cs: Updated after Resolve/Define rename.
	
	* lambda.cs (LambdaExpression)
	(.ResolveParameters): Handles both type of arguments and type inference too.
	
	* parameter.cs (ImplicitLambdaParameter.Resolve): Sanity check.
	(InflateTypes): Updated.
	
	* support.cs (InflateTypes): Changed signature and updated.
	
	* typemanager.cs (LookupMemberCache): Better dynamic type check.
	(MemberLookup_FindMembers): More MS tricks.
	(GetParameterData): Ditto.
	(GetDelegateParameters): Uses quick path for dynamic types.
	
2007-08-01  Marek Safar  <marek.safar@gmail.com>

	* class.cs (MethodData.Define): EmitContext is required for generic stuff
	only.

2007-07-31  Marek Safar  <marek.safar@gmail.com>

	* statement.cs (ProcessParameters): Don't crash when parameters have wrong
	syntax.
	
2007-07-26  Jb Evain  <jbevain@novell.com>

	* typemanager.cs (TypeManager.GetConstructor): Add a method overload
	which takes a boolean 'report_errors', similar to the GetMethod.
	(InitCodeHelpers): StructLayoutAttribute.ctor(int16) is not visible
	in .net 2.1, do not report errors here.

	* typemanager.cs (TypeManager.InitCoreTypes): System.ArgIterator,
	System.Runtime.CompilerServices.RequiredAttributeAttribute and
	System.Runtime.CompilerServices.TypeForwardedToAttribute are internal
	in .net 2.1.

	* typemanager.cs (TypeManager.InitCoreTypes): Move the resolution
	of the type InternalsVisibleToAttribute before the first call
	to CoreLookupType which is allowed to fail (third boolean parameter
	to true). Because, during the resolution for a type that is not
	immediately found, we try to check if the type is not defined in
	a friend assembly, and to do so, we need the
	InternalVisibleToAttribute.

2007-07-23  Miguel de Icaza  <miguel@novell.com>

	* expression.cs (Binary): Add support for the brain-dead CSC 2.x
	feature that allows structs to be compared against null and inline
	the result as true or false.

	Notice that the same code is not permitted inside a generic block
	of code that would do:

	class Foo<T> where T : struct {
	    bool Eval (T x)
	    {
	         return x == null;
	    }
	}

	It is only allowed if the type of T is not bound (no where
	clause).   In my opinion, this CSC 2 behavior is broken but people
	seem to be using it (IronRuby does, a few bug reports on bugzilla
	have it and some people have complained about it).

	All of the users that depend on this behavior have code that is
	very likely broken. 
	
	* report.cs (Warning, Error): make these take object arguments,
	not strings, as that allows us to take advantage of Format.

2007-07-20  William Holmes  <billholmes54@gmail.com>

	* decl.cs: Changed MemberName.CountTypeArguments to also check the 
	  Left member variable for the Count.
	* doc.cs: Changed DocUtil.GetMethodDocCommentName to call 
	  MemberName.CountTypeArguments to avoid a NRE. 

	This code is contributed under the MIT X11 license

2007-07-18  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Improved lambda parsing and removed old code.

2007-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* doc.cs : generic method arguments are written as ``x while generic
	  type arguments are `x. Combined with the previous change, fixed bug
	  #79706.

2007-07-18  Raja R Harinath  <rharinath@novell.com>

	Fix #82120
	* expression.cs (Binary.ResolveOperator): When converting
	'a + (-	b)' to 'a - b', ensure that the unary '-' is discarded.

2007-07-18  Atsushi Enomoto  <atsushi@ximian.com>

	* doc.cs : when T: or whatever x: is specified, it does not really
	  check the doc comment's syntax correctness. Fixed bug #82006.

2007-07-18  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymouseMethodExpression): Refactored to work with
	LambdaExpression better.
	
	* cs-tokenizer.cs: Changed a way how we detect lambda parameters.
	
	* driver.cs (LambdaTypeParseTest): Removed, tested method is gone.
	
	* ecore.cs (Expression.MemberLookupFailed): Don't show currect context
	as it can be generated.
	
	* expression.cs (Invocation.Error_InvalidArguments): Show correct
	modifiers.
	
	* lambda.cs (LambdaExpression): Refactored to share same code with
	AnonymousMethodExpression.
	
2007-07-17  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (MakeName): Include host name for easier debugging.
	(LambdaMethod): New class for lambda spcecific stuff.
	
	* attribute.cs: Set EmitContext return type.

	* class.cs: Set EmitContext return type.
	
	* codegen.cs (EmitContext): Return type cannot be null to stop messing
	with null/void meaning.
	
	* iterators.cs (ContainerType): Implemented.
	
	* rootcontext.cs: Set value of TypeManager.bool_type at early stage.
	
	* statement.cs (Return): Updated to lambda expressions.
	(Block.CloneTo): Parent can be null.
		
2007-07-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81917
	* attribute.cs (AttributeTester.GetFixedBuffer): More robust testing.
	
	* class.cs (FixedField): Check whether field is in unsafe scope.

	* ecore.cs (FieldExpr.DoResolve): Create fixed buffer expression here.
	(FieldExpr.Emit): Fixed buffers cannot be volatile.

	* expression.cs (ElementAccess.Resolve): Move fixed buffers resolve to
	FieldExpr.
	
	* statement.cs (Fixed.Resolve): Simplified fixed buffers.
		
2007-07-13  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs, class.cs, decl.cs, driver.cs, namespace.cs,
	rootcontext.cs, expression.cs, statement.cs: Updated to use WarningLevel
	from Report class.

2007-07-13  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (FieldExpr.AddressOf): Less confusing warning message.
	
2007-07-13  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousMethodExpression): Parameters are r/o.
	(AnonymousContainer.ResolveNoDefine): Another ec to aec flag conversion.
	
	* codegen.cs(EmitContext): Add ProbingMode flag.
	
	* delegate.cs (DelegateInvocation): Set few instance variables as r/o.
	
	* driver.cs: For now set both warning values.
	
	* ecore.cs (SimpleName): Name is readonly.
	(MethodGroup.OverloadResolve): One quick path for probing.
	
	* expression.cs (Unary): Set Oper r/o.
	(Binary): Set Oper r/o.
	(ParameterReference): Set few instance variables as r/o.
	(ParameterReference.DoResolveBase): Don't capture aruments when 
	the probing is on.
	(Invocation.CloneTo): Fixed typo, looks easy, yeah.
	(Arglist): arguments are private.
	(SizeOf): type is private and r/o.
	(MemberAccess): arguments are private.

	* report.cs: Enhanced reporting on/off capabilities.
	
	* lambda.cs: Uses ec.IsInProbingMode.
	(ContextualReturn): Derives from return.
	
	* rootcontext.cs: For now set both warning values.
	
	* statement.cs (CloneContext.RemapBlockCopy): Remaps block to cloned
	copy if one exists.
	(Return.Resolve): Don't die immediately.
	(Block.Resolve): Speed-up probing.
	(Block.CloneTo): Clone only child blocks.

Fri Jul 13 11:19:28 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* iterators.cs: reverted Miguel's latest change (r81925) as it
	breaks the build in System.

2007-07-13  Miguel de Icaza  <miguel@novell.com>

	* iterators.cs (Yield.CheckContext): Check for the iterator type
	also here as we can call into Yield even in codepaths that are not
	directly checked by
	(MethodOrOperator is the only path that was checked).

	In addition to the standard check, use a more specific check for
	constructors to report a more verbose error. 

2007-07-12  Miguel de Icaza  <miguel@novell.com>

	* ecore.cs (FieldExpr.AddressOf): Do not stop processing here,
	report the warning and continue 

	* statement.cs (Using.EmitLocalVariableDecls): We were leaving
	values on the stack on the call to Emit.   Use EmitStatement if
	possible, or using Emit + Pop if not possible.   Fixes #82064

2007-07-12  Raja R Harinath  <rharinath@novell.com>

	* expression.cs (Invocation.IsApplicable): Reorganize slightly to
	avoid try...finally in some cases.

2007-07-10  Marek Safar  <marek.safar@gmail.com>

	* attribute.cs (Attribute.ResolveConstructor): Uses method group.
	
	* class.cs (ConstructorInitializer.Resolve): Use and keep method group
	instead of method. Re-use standard error handling.
	(ConstructorInitializer.Emit): Simplified.
	
	* delegate.cs: Updated after Invocation.EmitCall change.
	
	* ecore.cs (GetOperatorTrueOrFalse): Uses MethodGroupExpr only.
	(SimpleName.SimpleNameResolve): Set and reset in_transit flag correctly.
	(ExtensionMethodGroupExpr): Refactored to use same OverloadResolve
	method and don't permanently changing input arguments.
	(MethodGroupExpr): Introduced resolved best_candidate, when method group
	is resolved it has one of the candidates is the best one which is later
	used to emit. Removed a few unused method.
	(MethodGroupExpr.MakeUnionSet): Moved from Invocation, it belongs here.

	* expression.cs (StaticCallExpr.MakeSimpleCall): Uses method group.
	(Binary.ResolveOperator): Ditto.
	(ConditionalLogicalOperator.DoResolve): Ditto.
	(Invocation): Uses method group.
	(Invocation.DoResolve): Simplified.
	(Invocation.EmitCall): Removed useless is_static.
	(Invocation.Emit): Delegate to method group.
	(Invocation.EmitStatement): Simplified.
	(New): Uses method group.
	(MemberAccess.DoResolve): Don't destroy original expression.
	
	* statement.cs (ForEach.Resolve): Use null for no method arguments.
	
2007-07-04  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (VarExpr.DoResolveLValue): More restriction checks.
	
	* anonymous.cs,
	* lambda.cs: Add custom error message type.

2007-07-03  Marek Safar  <marek.safar@gmail.com>

	* lambda.cs: Simplified little bit.
	
	* parameter.cs: Introduced ImplicitLambdaParameter.
	(Parameters.CreateFullyResolved): New factory instead of ctor.
	
	* anonymous.cs,
	* class.cs,
	* delegate.cs: Updated parameter creation.
	
2007-07-03  Marek Safar  <marek.safar@gmail.com>

	*  ecore.cs (SimpleName.GetSignatureForError): Display correctly generic
	arguments.
	
	* generic.cs: Synchronized with gmcs.
	
2007-07-03  Marek Safar  <marek.safar@gmail.com>

	* class.cs (Indexer): Check return type as soon as possible.
	
	* cs-parser.jay: Initialize implicit_value_parameter_type for interface
	members too.
	
	* ecore.cs (VarExpr.DoResolveLValue): Set eclass value.
	
	* expression.cs (Invocation.Error_InvalidArguments): Show type only.
	
	* parameter.cs (Parameter): Use expression type when it is available.
	
	* support.cs (ReflectionParameters.ParameterDesc): Show an extension
	method modifier for the first parameter only.

2007-06-24  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81938
	* typemanager.cs (ChangeType): Fixed couple of char conversions.
	
	* constant.cs: Tide up an exception message.

2007-06-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (SimpleName.DoSimpleNameResolve): Better error reporting when
	an uninitialized variable is used.
	
	* expression.cs (LocalVariableReference.DoResolve): Ditto.

2007-06-22  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (SimpleName.TypeOrNamespaceNotFound): Allow to override type
	not found error handling.

	* expression.cs (ArrayCreation): Removed redundant fields and little bit
	simplified.
	(ArrayCreation.ResolveArrayElement): To be ready to customization.
	(ArrayCreation.DoResolve): Simplified.
	(ImplicitlyTypedArrayCreation.DoResolve): Implicitly typed arrays have
	its own resolve process.
	(ImplicitlyTypedArrayCreation.ResolveArrayElement): Conversion magic.

2007-06-20  Marek Safar  <marek.safar@gmail.com>

	* namespace.cs (NamespaceEntry.Error_AmbiguousTypeReference): Print
	more error details.
	
2007-06-20  Marek Safar  <marek.safar@gmail.com>

	* cs-tokenizer.cs: Removed var related stuff.
	
	* ecore.cs (Expression.ResolveAsContextualType): Introduced new method.
	(VarExpr): Changed to derive from SimpleName. VarExpr now behaves as
	a type and a keyword at same time.
	
	* decl.cs (MembeName.GetTypeExpression): Create VarExpr when type name
	matches to "var".
	
	* expression.cs (ImplicitlyTypedArrayCreation): New empty class for
	implicitly typed arrays, more changes will follow.
	
	* statement.cs (LocalInfo.Resolve): Resolve type as contextual type.
	
2007-06-19  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (VarExpr): Removed Handled field.
	
	* statement.cs (Using.ResolveLocalVariableDecls): Refactored to use
	build-in assign functionality.
	(ForEach.Resolve): Removed all implicitly typed local variable code and
	simplified.
	(ArrayForeach.Resolve): Infer implicitly typed local variable here.
	(CollectionForeach.Resolve): Infer implicitly typed local variable here.

2007-06-18  Marek Safar  <marek.safar@gmail.com>

	* assign.cs: Removed implicitly typed local variable check.
	
	* expression.cs (LocalVariableReference.DoResolve): Add check for self
	referencing implicitly typed local variable.
	(LocalVariableReference.DoResolveLValue): Infer implicitly typed local
	variable here.
	
	* statement.cs (Fixed): Removed unsupported implicitly typed local
	variable code.

2007-06-15  Marek Safar  <marek.safar@gmail.com>

	* decl.cs (MemberName): Moved all Unbound stuff to parser.

2007-06-14  Marek Safar  <marek.safar@gmail.com>

	A fix for bugs #81855 and #76274
	* attribute.cs (AttachTo): Always set owner for global attributes to
	prefined owner.
	
	* ecore.cs (Error_TypeDoesNotContainDefinition): A type location can be
	usefull too.
	
	* cs-parser.jay: Assembly and module attributes must precede all other
	elements except using clauses and extern alias declarations.

2007-06-13  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81748
	* cs-tokenizer.cs,
	* expression.cs: More checks for non ISO-1 features.

2007-06-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81807
	* statement.cs(Switch.TableSwitchEmit): Define null label when it's not
	present inside switch statement and it is required by nullable check.

2007-06-12  Marek Safar  <marek.safar@gmail.com>

	A fix for bug #81840
	* ecore.cs (SimpleName.ResolveAsTypeStep): Look for non-generic type
	when type matching fails.
	
	* namespace.cs: Tiny error message change.

2007-06-12  Marek Safar  <marek.safar@gmail.com>

	* decl.cs (CheckAbstractAndExtern): Moved to MemberCore for easier error
	reporting. Added automatic property check.
	
	* class.cs: Updated after CheckAbstractAndExtern relocation.
	(AEventPropertyAccessor.GetSignatureForError): Customized.
	
2007-06-11  Marek Safar  <marek.safar@gmail.com>

	* class.cs (DefineBaseTypes): Base type can be undefined.
	
	* ecore.cs (TypeLookup): Minor refactoring.
	(DoResolveAsTypeStep): Removed redundant check.

	* namespace.cs (Lookup): Removed redundant check.
		
	* rootcontext.cs (BootstrapCorlib_ResolveType): Uses normal 
	ResolveAsTypeTerminal step.
	(BootstrapCorlib_*): Simplified.
	(PopulateCoreType): Core types can be now external.

2007-06-07  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (VerifyExplicitParameterCompatibility): Add flag to do
	 verification only.
	 (InferTypeArguments): Infers anonymous expression type arguments.
	 (Compatible): Split to Compatible and InferTypeArguments. 
	
	* lambda.cs: Updated.

2007-06-08  Marek Safar  <marek.safar@gmail.com>

	* anonymous.cs (AnonymousContainer): Marked as compiler generated.

2007-06-07  Raja R Harinath  <harinath@gmail.com>

	Fix #80477, cs0135-2.cs, cs0135-3.cs
	* statement.cs (ToplevelBlock.ProcessParameters): Add parameter
	names to the "known" variables list.
	(Block.CheckInvariantMeaningInBlock): Handle the fact the
	parameter names are also "known".
	(Block.CheckError136): Remove.
	(ExplicitBlock.CloneTo): New.  Set 'known_variables' in target to
	null.

2007-06-07  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (MethodGroupExpr.OverloadResolve): Print full method definition.

2007-06-06  Marek Safar  <marek.safar@gmail.com>

	* ecore.cs (SimpleName.Emit): Emitting unresolved simple name is
	internal error not an user error.
	 
	* expression.cs (IsApplicable): Refactored to make debugging easier.

	* support.cs: More tricks for non-mono runtimes.
	
	* typemanager.cs (CoreLookupType): Made public.
	(InitSystemCore): All linq specific stuff moved to linq.cs

2007-06-05  Marek Safar  <marek.safar@gmail.com>

	* typemanager.cs (CSharpSignature): One more missing build-in types
	replacement.
	More tricks for non-mono runtime.

2007-06-05  Raja R Harinath  <harinath@gmail.com>

	* statement.cs (Block.CheckError136_InParents): Remove.
	(Block.AddVariable): Use GetParameterInfo instead.
	(ToplevelBlock.ProcessArguments): Likewise.

2007-06-04  Raja R Harinath  <rharinath@novell.com>

	* statement.cs (ToplevelBlock.CloneTo): New.  Copy over parameter
	information too.
	(ToplevelBlock.GetParameterInfo): Split out of ...
	(ToplevelBlock.GetParameterRefernce): ... this.
	(ToplevelBlock.ParameterMap): Remove.
	* expression.cs (ParameterReference): Update to use
	ToplevelParameterInfo.

	* statement.cs (ToplevelBlock.ProcessParameters): Workaround some
	regression.

	* flowanalysis.cs (FlowBranching.CheckOutParameters): Move ...
	* statement.cs (ToplevelBlock.CheckOutParameters): ... here.

	* statement.cs (ToplevelBlock.ResolveMeta): Move CS0136 checks ...
	(ToplevelBlock.ProcessParameters) ... here.
	(ToplevelBlock..ctor): Invoke it.

	* statement.cs (ToplevelBlock.ResolveMeta): Add sanity checks for
	new parameters.

	* statement.cs (IKnownVariable): New interface.
	(LocalInfo): Implement it.
	(ToplevelParameterInfo): New class.
	(ExplicitBlock.AddKnownVariable): Use IKnownVariable.
	(ExplicitBlock.GetKnownVariable): Likewise.  Rename from
	GetKnownVariableInfo.

2007-06-03  Raja R Harinath  <harinath@gmail.com>

	Partly speed up CS0136 error checks.
	* statement.cs (ExplicitBlock.GetKnownVariableInfo): Remove
	'recurse' parameter.
	(Block.DoCheckError136): Only check errors in parameters.  Move
	local variable checks ...
	(Block.AddVariable): ... here, and ...
	(ToplevelBlock.ResolveMeta): ... here.

2007-06-02  Raja R Harinath  <harinath@gmail.com>

	* statement.cs (Block.IsChildOf): Remove.

	* statement.cs (Statement.Clone): Move special case code ...
	(Block.CloneTo): ... here.

2007-05-29  Raja R Harinath  <rharinath@novell.com>

	* statement.cs (ToplevelBlock.container): Remove field.  It's
	redundant with 'Parent'.
	(ToplevelBlock.ContainerBlock): Remove accessor.
	(ToplevelBlock..ctor): Update to changes.  Register anonymous
	child with parent here, ...
	* cs-parser.jay (end_anonymous): ... not here.  Don't modify
	current_block.
	(start_anonymous): Don't save current_block.
	(top_current_block): Remove.

	* statement.cs (Block.Flags): Remove IsExplicit and IsToplevel flags.
	(Block.Resolve): Update to changes.
	(Block..ctor): Move setting of "correct" 'Toplevel'
	and 'Explicit' fields to ...
	(ExplicitBlock..ctor, ToplevelBlock..ctor): ... here.

2007-05-27  Raja R Harinath  <harinath@gmail.com>

	Kill Block.Implicit
	* statement.cs (Block.Implicit): Remove.
	(Block): Update to changes.
	* flowanalysis.cs: Likewise.

